ConvergeFu = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0", "AceEvent-2.0"); 
local L = AceLibrary("AceLocale-2.2"):new("ConvergeFu"); 
local Tablet = AceLibrary("Tablet-2.0"); 

-- ----------------------------------------------------------------------------
-- -- Configure all profile variables that will be saved on reload/exit.     --
-- ----------------------------------------------------------------------------
ConvergeFu:RegisterDB("ConvergeFuDB");
ConvergeFu:RegisterDefaults("profile", {
  versionNumber       = "1.0",
  guildName           = L["common-guildname"],
  searchTarget        = UnitName("player"),
  raidInviter         = UnitName("player"),
  raidQueueManager    = UnitName("player"),
  raidOrganiser       = UnitName("player"),
  sendRaidInvitations = L["common-data-option-off"],
  showRaidInvitations = L["common-data-option-on"],
  showQueueRequests   = L["common-data-option-on"],
  showRaidActivities  = L["common-data-option-on"],
  skullType           = L["tools-crowd-control-common-clear-type-default"],
  skullName           = L["tools-crowd-control-common-clear-name-default"],
  crossType           = L["tools-crowd-control-common-clear-type-default"],
  crossName           = L["tools-crowd-control-common-clear-name-default"],
  squareType          = L["tools-crowd-control-common-clear-type-default"],
  squareName          = L["tools-crowd-control-common-clear-name-default"],
  moonType            = L["tools-crowd-control-common-clear-type-default"],
  moonName            = L["tools-crowd-control-common-clear-name-default"],
  triangleType        = L["tools-crowd-control-common-clear-type-default"],
  triangleName        = L["tools-crowd-control-common-clear-name-default"],
  diamondType         = L["tools-crowd-control-common-clear-type-default"],
  diamondName         = L["tools-crowd-control-common-clear-name-default"],
  circleType          = L["tools-crowd-control-common-clear-type-default"],
  circleName          = L["tools-crowd-control-common-clear-name-default"],
  starType            = L["tools-crowd-control-common-clear-type-default"],
  starName            = L["tools-crowd-control-common-clear-name-default"],
  defaultCCDeathKnight= L["tools-crowd-control-type-tank"],
  defaultCCDruid      = L["tools-crowd-control-type-root"],
  defaultCCHunter     = L["tools-crowd-control-type-trap"],
  defaultCCMage       = L["tools-crowd-control-type-sheep"],
  defaultCCPaladin    = L["tools-crowd-control-type-turnevil"],
  defaultCCPriest     = L["tools-crowd-control-type-mindcontrol"],
  defaultCCRogue      = L["tools-crowd-control-type-sap"],
  defaultCCShaman     = L["tools-crowd-control-type-hex"],
  defaultCCWarlock    = L["tools-crowd-control-type-banish"],
  defaultCCWarrior    = L["tools-crowd-control-type-tank"],
  ccChannel           = "RAID",
  itemLevelType       = "Epic",
  itemLevelSlot       = "Head",
  itemLevelValue      = "264",
  responderStatus     = L["common-data-option-off"],
  responderGuild      = L["common-data-option-off"],
  responderOfficer    = L["common-data-option-off"],
  responderParty      = L["common-data-option-off"],
  responderRaid       = L["common-data-option-off"],
  responderFriend     = L["common-data-option-off"],
  responderMessage    = L["tools-busy-responder-message-first"]..L["tools-busy-responder-message-stdrd"],
  versionString       = L["versionName"]..":"..L["versionNumber"],
  versionQuiet        = L["common-data-option-zero"],
  versionDispChat     = L["common-data-option-zero"],
  versionDispWin      = L["common-data-option-one"],
  vcGroupList         = "",
  vcLastUpdated       = "",
  vcListUnsetChannel  = "OFFICER",
  recruitCharName     = "",
  recruitCharRank     = "",
  recruitCharMain     = "",
  recruitStatus       = L["tools-recruiter-status-dormant"],
  recruitPromotes     = L["common-data-option-zero"],
  recruitPromoteText  = "",
  fishFeastStatus     = L["common-data-option-off"],
  fishFeastText       = L["event-chat-msg-addon-fish-feast-text"],
  fishFeastMatch      = L["event-chat-msg-addon-fish-feast-match"],
  fishFeastChannel    = L["event-chat-msg-addon-fish-feast-channel"],
  rcpTarget           = L["common-data-option-unset"],
  riwStatus           = L["common-data-option-on"],
  lootMonitorStatus   = L["common-data-option-off"],
  lootMonitorMLSeen   = L["common-data-option-no"],
  bidmgrOutputChannel = "CHAT",
  bidmgrSendingChannel= "WHISPER",
  bmIssuesFound       = L["common-data-option-no"],
  bmOutputChannel     = "CHAT",
  bmReportFlasks      = L["common-data-option-on"],
  bmReportElixirs     = L["common-data-option-on"],
  bmReportFood        = L["common-data-option-on"],
  bmReportRoguePoisons= L["common-data-option-on"],
  bmReportExpiry      = L["common-data-option-on"],
  bmReportDead        = L["common-data-option-on"],
  bmReportOffline     = L["common-data-option-on"], 
  bmCMGlobalStatus    = L["common-data-option-off"],
  bmCMEnterStatus     = L["common-data-option-off"],
  bmCMExitStatus      = L["common-data-option-off"],
  bmCMDoneOnce        = L["common-data-option-no"],
  bmExpiryTimeMinutes = 5,
  bmNotifyStatus      = L["common-data-option-off"],
  bmCurrentProfile    = L["tools-bm-current-profile-custom"],
  bmLastReadyCheckByMe= L["common-data-option-no"],
  bmRunPostRCReport   = L["common-data-option-on"],
  bmPostRCReportStatus= L["common-data-status-dormant"],
  debugStatus         = L["common-data-option-off"]
} )
ConvergeFu.hasIcon = true; 
ConvergeFu.defaultPosition = "LEFT"; 

-- ----------------------------------------------------------------------------
-- -- Configure Global Variables and Objects.                                --
-- ----------------------------------------------------------------------------
local versionCheckFrame
local versionCheckFrameCreated = L["common-data-option-zero"]
local bidManagerRBPT    = {}

local TooltipScanner = CreateFrame('GameTooltip', 'TooltipScanner', WorldFrame, 'GameTooltipTemplate')
TooltipScanner:SetOwner(WorldFrame, "ANCHOR_NONE")

-- ----------------------------------------------------------------------------
-- -- Configure the options for command line and FuBar/DewDrop menus.        --
-- ----------------------------------------------------------------------------
ConvergeFu.consoleOptions = { 
   type = 'group', 
   args = { 
      announce = { 
         name  = L["mainmenu-announce-title"], 
         type  = 'group',
         order = 10,
         desc  = L["mainmenu-announce-descr"], 
         args  = {
            header1  = {
               name  = L["announcements-header"],
               type  = "header",
               order = 09,
            },
            guild = { 
               name  = L["ann-guild-title"], 
               desc  = L["ann-guild-descr"],
               type  = 'group', 
               order = 10, 
               args  = {
                  header1  = {
                    name   = L["ann-guild-header"],
                    type   = "header",
                    order  = 09,
                  },               
                  invites = { 
                     name  = L["ann-guild-raid-invite-title"], 
                     desc  = L["ann-guild-raid-invite-descr"],
                     type  = 'group', 
                     order = 10, 
                     args  = {
                        header1  = {
                           name   = L["ann-guild-raid-invite-header"],
                           type   = "header",
                           order  = 09,
                        },                     
                        aspthal = { 
                           name  = L["common-officer-name-aspthal-numeric"], 
                           desc  = L["ann-guild-raid-invite-officer-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-aspthal"], "GUILD")
                           end
                        },
                        badlimp = { 
                           name  = L["common-officer-name-badlimp-numeric"], 
                           desc  = L["ann-guild-raid-invite-officer-descr"], 
                           type  = 'execute',
                           order = 20,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-badlimp"], "GUILD")
                           end
                        },                     
                        broliant = { 
                           name  = L["common-officer-name-broliant-numeric"], 
                           desc  = L["ann-guild-raid-invite-officer-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-broliant"], "GUILD")
                           end
                        },
                        jawa = { 
                           name  = L["common-officer-name-jawa-numeric"], 
                           desc  = L["ann-guild-raid-invite-officer-descr"], 
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-jawa"], "GUILD")
                           end
                        },
                        xen = { 
                           name  = L["common-officer-name-xen-numeric"], 
                           desc  = L["ann-guild-raid-invite-officer-descr"], 
                           type  = 'execute',
                           order = 50,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-xen"], "GUILD")
                           end 
                        },                                           
                        zmall = { 
                           name  = L["common-officer-name-zmall-numeric"], 
                           desc  = L["ann-guild-raid-invite-officer-descr"], 
                           type  = 'execute',
                           order = 60,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(L["common-officer-name-zmall"], "GUILD")
                           end 
                        },
                        header2  = {
                           name   = " ",
                           type   = "header",
                           order  = 199,
                        },                        
                        me = { 
                           name  = L["common-character-name-me"], 
                           desc  = L["ann-guild-raid-invite-me-descr"], 
                           type  = 'execute',
                           order = 200,
                           func  = function() 
                              ConvergeFu:AnnounceRaidInvite(UnitName("player"), "GUILD")
                           end
                        },
                        custom = { 
                           name  = L["common-character-name-custom"], 
                           desc  = L["ann-guild-raid-invite-character-descr"], 
                           type  = 'group',
                           order = 210,
                           args  = {
                              header1  = {
                                 name   = L["ann-guild-raid-invite-custom-header"],
                                 type   = "header",
                                 order  = 09,
                              },
                              set = {
                                 name  = L["ann-guild-raid-invite-custom-set-title"],
                                 desc  = L["ann-guild-raid-invite-custom-set-descr"],
                                 type  = 'text',
                                 order = 10,
                                 usage = L["ann-guild-raid-invite-custom-set-usage"],
                                 get   = function() return ConvergeFu.db.profile.raidInviter end,
                                 set   = function(newValue) ConvergeFu.db.profile.raidInviter = ConvergeFu:CaseCorrectedNameString(newValue) end,   
                              },
                              use ={ 
                                 name  = L["ann-guild-raid-invite-custom-use-title"], 
                                 desc  = L["ann-guild-raid-invite-custom-use-descr"], 
                                 type  = 'execute', 
                                 order = 20,
                                 func  = function() 
                                    ConvergeFu:AnnounceRaidInvite(ConvergeFu.db.profile.raidInviter, "GUILD")
                                 end
                              }                              
                           }
                        },
                        config ={ 
                           name  = L["ann-guild-raid-invite-config-title"], 
                           desc  = L["ann-guild-raid-invite-config-descr"], 
                           type  = 'group',
                           order = 220,
                           args  = {
                              header1  = {
                                 name   = L["ann-guild-raid-invite-config-header"],
                                 type   = "header",
                                 order  = 09,
                              },                           
                              send = {
                                 name     = L["ann-guild-raid-invite-config-send-title"],
                                 desc     = L["ann-guild-raid-invite-config-send-descr"],
                                 type     = 'text',
                                 order    = 10,
                                 usage    = L["ann-guild-raid-invite-config-send-usage"],
                                 get      = function() return ConvergeFu.db.profile.sendRaidInvitations end,
                                 set      = function(newValue) ConvergeFu.db.profile.sendRaidInvitations = newValue end,
                                 validate = {L["common-data-option-on"], L["common-data-option-off"]}
                              },
                              show = {
                                 name     = L["ann-guild-raid-invite-config-show-title"],
                                 desc     = L["ann-guild-raid-invite-config-show-descr"],
                                 type     = 'text',
                                 order    = 20,
                                 usage    = L["ann-guild-raid-invite-config-show-usage"],
                                 get      = function() return ConvergeFu.db.profile.showRaidInvitations end,
                                 set      = function(newValue) ConvergeFu.db.profile.showRaidInvitations = newValue end,
                                 validate = {L["common-data-option-on"], L["common-data-option-off"]}
                              }                             
                           }
                        }                        
                     }
                  },
                  queue = { 
                     name  = L["ann-guild-wait-list-title"], 
                     desc  = L["ann-guild-wait-list-descr"],
                     type  = 'group', 
                     order = 20,
                     args  = {
                        header1  = {
                           name  = L["ann-guild-wait-list-header"],
                           type  = "header",
                           order = 09,
                        },                      
                        aspthal ={ 
                           name  = L["common-officer-name-aspthal-numeric"], 
                           desc  = L["ann-guild-wait-list-officer-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function() 
                              ConvergeFu:AnnounceWaitList(L["common-officer-name-aspthal"], "GUILD")
                           end
                        },
                        badlimp ={ 
                           name  = L["common-officer-name-badlimp-numeric"], 
                           desc  = L["ann-guild-wait-list-officer-descr"], 
                           type  = 'execute',
                           order = 20,
                           func  = function() 
                              ConvergeFu:AnnounceWaitList(L["common-officer-name-badlimp"], "GUILD")
                           end
                        },                     
                        broliant ={ 
                           name  = L["common-officer-name-broliant-numeric"], 
                           desc  = L["ann-guild-wait-list-officer-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-broliant"], "GUILD")
                           end 
                        },
                        jawa ={ 
                           name  = L["common-officer-name-jawa-numeric"], 
                           desc  = L["ann-guild-wait-list-officer-descr"], 
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-jawa"], "GUILD")
                           end
                        },
                        xen ={ 
                           name  = L["common-officer-name-xen-numeric"], 
                           desc  = L["ann-guild-wait-list-officer-descr"], 
                           type  = 'execute',
                           order = 50,
                           func  = function() 
                              ConvergeFu:AnnounceWaitList(L["common-officer-name-xen"], "GUILD")
                           end 
                        },                                 
                        zmall ={ 
                           name  = L["common-officer-name-zmall-numeric"], 
                           desc  = L["ann-guild-wait-list-officer-descr"], 
                           type  = 'execute',
                           order = 60,
                           func  = function() 
                             ConvergeFu:AnnounceWaitList(L["common-officer-name-zmall"], "GUILD")
                           end 
                        },
                        header2  = {
                           name   = " ",
                           type   = "header",
                           order  = 199,
                        }, 
                        me ={ 
                           name  = L["common-character-name-me"], 
                           desc  = L["ann-guild-wait-list-me-descr"], 
                           type  = 'execute',
                           order = 200,
                           func  = function() 
                              ConvergeFu:AnnounceWaitList(UnitName("player"), "GUILD")
                           end
                        },
                        custom ={ 
                           name  = L["common-character-name-custom"], 
                           desc  = L["ann-guild-wait-list-character-descr"], 
                           type  = 'group',
                           order = 210,
                           args  = {
                              header1  = {
                                 name   = L["ann-guild-wait-list-custom-header"],
                                 type   = "header",
                                 order  = 09,
                              },
                              set = {
                                 name  = L["ann-guild-wait-list-custom-set-title"],
                                 desc  = L["ann-guild-wait-list-custom-set-descr"],
                                 type   = 'text',
                                 order  = 10,
                                 usage  = L["ann-guild-wait-list-custom-set-usage"],
                                 get    = function() return ConvergeFu.db.profile.raidQueueManager end,
                                 set    = function(newValue) ConvergeFu.db.profile.raidQueueManager = ConvergeFu:CaseCorrectedNameString(newValue) end,   
                              },
                              use ={ 
                                 name  = L["ann-guild-wait-list-custom-use-title"], 
                                 desc  = L["ann-guild-wait-list-custom-use-descr"], 
                                 type  = 'execute',
                                 order = 20,
                                 func  = function() 
                                    ConvergeFu:AnnounceWaitList(ConvergeFu.db.profile.raidQueueManager, "GUILD")
                                 end
                              }                              
                           }
                        },
                        config ={ 
                           name  = L["ann-guild-wait-list-config-title"], 
                           desc  = L["ann-guild-wait-list-config-descr"], 
                           type  = 'group',
                           order = 220,
                           args  = {
                              header1  = {
                                 name   = L["ann-guild-wait-list-config-header"],
                                 type   = "header",
                                 order  = 09,
                              },
                              show = {
                                 name     = L["ann-guild-wait-list-config-show-title"],
                                 desc     = L["ann-guild-wait-list-config-show-descr"],
                                 type     = 'text',
                                 order    = 10,
                                 usage    = L["ann-guild-wait-list-config-show-usage"],
                                 get      = function() return ConvergeFu.db.profile.showQueueRequests end,
                                 set      = function(newValue) ConvergeFu.db.profile.showQueueRequests = newValue end,
                                 validate = {L["common-data-option-on"], L["common-data-option-off"]}
                              }
                           }
                        }
                     }
                  },
                  welcome_new_trial = { 
                     name  = L["ann-guild-new-trial-title"], 
                     desc  = L["ann-guild-new-trial-descr"], 
                     type  = 'execute',
                     order = 30,
                     func  = function() 
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-01-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-02-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-03-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-04-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-05-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-06-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-07-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-08-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-09-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-10-msg"], "GUILD")
                        ConvergeFu:SendChatMessage(L["ann-guild-new-trial-11-msg"], "GUILD")
                     end 
                  },
                  welcome_new_alt = { 
                     name  = L["ann-guild-new-alt-title"], 
                     desc  = L["ann-guild-new-alt-descr"], 
                     type  = 'execute',
                     order = 40,
                     func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-01-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-02-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-03-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-04-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-05-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-06-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-07-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-08-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-09-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-10-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-new-alt-11-msg"], "GUILD")
                     end 
                  },  
                  trial_ended ={ 
                     name  = L["ann-guild-trial-ended-title"], 
                     desc  = L["ann-guild-trial-ended-descr"], 
                     type  = 'execute',
                     order = 50,
                     func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-01-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-02-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-03-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-04-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-05-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-06-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-07-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-08-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-09-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-10-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-trial-ended-11-msg"], "GUILD")
                     end
                  },             
                  promote_trial ={ 
                     name  = L["ann-guild-promote-title"], 
                     desc  = L["ann-guild-promote-descr"], 
                     type  = 'execute',
                     order = 60,
                     func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-01-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-02-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-03-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-04-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-05-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-06-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-07-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-08-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-09-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-10-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["ann-guild-promote-11-msg"], "GUILD")
                     end
                  },
                  hero_rank_changes ={ 
                     name  = L["ann-guild-hero-rank-changes-title"], 
                     desc  = L["ann-guild-hero-rank-changes-descr"], 
                     type  = 'execute',
                     order = 70,
                     func  = function() 
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-01-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-02-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-03-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-04-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-05-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-06-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-07-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-08-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-09-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-10-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-11-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-12-msg"], "GUILD")
                       ConvergeFu:SendChatMessage(L["common-rankchange-announce-13-msg"], "GUILD")
                     end
                  },                  
                  broadcast_raidend = {
                     name  = L["ann-guild-broadcast-raid-end-title"],
                     desc  = L["ann-guild-broadcast-raid-end-descr"],
                     type  = 'execute',
                     order = 80,
                     func  = function()
                        ConvergeFu:BroadcastRaidEnd()
                     end
                  }
               }
            },
            raid = {
               name  = L["ann-raid-title"], 
               desc  = L["ann-raid-descr"],
               type  = 'group', 
               order = 20, 
               args  = { 
                 header1   = {
                    name   = L["ann-raid-header"],
                    type   = "header",
                    order  = 09,
                 },               
                 quest = {
                    name = L["ann-raid-quest-title"], 
                    desc = L["ann-raid-quest-descr"], 
                    type = 'group', 
                    order = 70,
                    args = {
                       header1   = {
                          name  = L["ann-raid-quest-header"],
                          type  = "header",
                          order = 09,
                       },                    
                       quest_01 = { 
                          name  = L["ann-common-promotion-quest-01-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute',
                          order = 10,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-01-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-01-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-01-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-01-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_02 = { 
                          name  = L["ann-common-promotion-quest-02-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 20,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-02-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-02-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-02-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-02-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_03 = { 
                          name  = L["ann-common-promotion-quest-03-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 30,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-03-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-03-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-03-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-03-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_04 = { 
                          name  = L["ann-common-promotion-quest-04-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 40,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-04-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-04-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-04-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-04-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_05 = { 
                          name  = L["ann-common-promotion-quest-05-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 50,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-05-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-05-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-05-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-05-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_06 = { 
                          name  = L["ann-common-promotion-quest-06-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 60,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-06-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-06-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-06-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-06-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_07 = { 
                          name  = L["ann-common-promotion-quest-07-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 70,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-07-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-07-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-07-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-07-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_08 = { 
                          name  = L["ann-common-promotion-quest-08-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 80,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-08-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-08-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-08-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-08-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_09 = { 
                          name  = L["ann-common-promotion-quest-09-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 90,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-09-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-09-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-09-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-09-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_10 = { 
                          name  = L["ann-common-promotion-quest-10-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 100,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-10-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-10-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-10-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-10-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_11 = { 
                          name  = L["ann-common-promotion-quest-11-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 110,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-11-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-11-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-11-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-11-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_12 = { 
                          name  = L["ann-common-promotion-quest-12-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 120,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-12-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-12-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-12-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-12-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_13 = { 
                          name  = L["ann-common-promotion-quest-13-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 130,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-13-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-13-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-13-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-13-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_14 = { 
                          name  = L["ann-common-promotion-quest-14-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute',
                          order = 140,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-14-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-14-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-14-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-14-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_15 = { 
                          name  = L["ann-common-promotion-quest-15-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 150,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-15-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-15-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-15-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-15-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_16 = { 
                          name  = L["ann-common-promotion-quest-16-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 160,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-16-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-16-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-16-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-16-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_17 = { 
                          name  = L["ann-common-promotion-quest-17-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 170,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-17-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-17-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-17-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-17-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_18 = { 
                          name  = L["ann-common-promotion-quest-18-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 180,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-18-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-18-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-18-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-18-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_19 = { 
                          name  = L["ann-common-promotion-quest-19-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute', 
                          order = 190,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-19-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-19-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-19-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-19-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       },
                       quest_20 = { 
                          name  = L["ann-common-promotion-quest-20-title"], 
                          desc  = L["ann-common-promotion-quest-descr"], 
                          type  = 'execute',
                          order = 200,
                          func  = function() 
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-20-01-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-20-02-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-20-03-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-20-04-msg"], "RAID")
                             ConvergeFu:SendChatMessage(L["ann-common-promotion-quest-txt-05-msg"], "RAID")
                          end 
                       }
                    }
                 },
                 kill_order = { 
                    name  = L["ann-common-kill-order-title"], 
                    desc  = L["ann-common-kill-order-descr"], 
                    type  = 'execute',
                    order = 20,
                    func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-01-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-02-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-03-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-04-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-05-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-06-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-07-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-08-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-09-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-10-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-11-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-12-msg"], "RAID")
                    end 
                 },
                 ventrilo = { 
                    name  = L["ann-common-ventrilo-title"], 
                    desc  = L["ann-common-ventrilo-descr"], 
                    type  = 'execute',
                    order = 40,
                    func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-01-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-02-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-03-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-04-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-05-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-06-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-07-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-08-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-09-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-10-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-11-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-12-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-13-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-14-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-15-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-16-msg"], "RAID")
                    end 
                 },  
                 bidding = { 
                    name  = L["ann-raid-loot-bidding-title"], 
                    desc  = L["ann-raid-loot-bidding-descr"], 
                    type  = 'execute',
                    order = 60,
                    func  = function()
                       ConvergeFu:AnnounceBiddingInstructions("RAID")
                    end
                 },
                 bidding = { 
                    name  = L["ann-raid-loot-bidding-pugstyle-title"], 
                    desc  = L["ann-raid-loot-bidding-pugstyle-descr"], 
                    type  = 'execute',
                    order = 70,
                    func  = function()
                       ConvergeFu:AnnouncePUGStyleBiddingInstructions("RAID")
                    end
                 },                 
                 raid_begin = { 
                    name  = L["ann-raid-raid-begin-title"], 
                    desc  = L["ann-raid-raid-begin-descr"], 
                    type  = 'execute',
                    order = 10,
                    func  = function() 
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-02-msg"], "RAID_WARNING")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-14-msg"], "RAID_WARNING")
  
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-01-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-02-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-03-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-04-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-05-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-06-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-07-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-08-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-09-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-10-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-11-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-12-msg"], "RAID")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-13-msg"], "RAID")
                    end 
                 },               
                 raid_end = { 
                    name  = L["ann-raid-raid-end-title"], 
                    desc  = L["ann-raid-raid-end-descr"], 
                    type  = 'execute', 
                    order = 20,
                    func  = function() 
                      ConvergeFu:AnnounceRaidEnd("RAID")
                    end 
                 },
                 priority = { 
                    name  = L["ann-common-looting-order-title"], 
                    desc  = L["ann-common-looting-order-descr"], 
                    type  = 'execute',
                    order = 30,
                    func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-01-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-02-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-03-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-04-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-05-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-06-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-07-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-08-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-09-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-10-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-11-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-12-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-13-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-14-msg"], "RAID")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-15-msg"], "RAID")
                    end 
                 }
              }
          },
            party = {
               name  = L["ann-party-title"], 
               desc  = L["ann-party-descr"],
               type  = 'group', 
               order = 30, 
               args  = {  
                 header1   = {
                    name   = L["ann-party-header"],
                    type   = "header",
                    order  = 09,
                 },               
                 kill_order ={ 
                    name  = L["ann-common-kill-order-title"], 
                    desc  = L["ann-common-kill-order-descr"], 
                    type  = 'execute',
                    order = 30,
                    func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-01-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-02-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-03-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-04-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-05-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-06-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-07-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-08-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-09-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-10-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-11-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-kill-order-12-msg"], "PARTY")
                    end 
                 },
                 ventrilo ={ 
                    name  = L["ann-common-ventrilo-title"], 
                    desc  = L["ann-common-ventrilo-descr"], 
                    type  = 'execute', 
                    order = 50,
                    func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-01-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-02-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-03-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-04-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-05-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-06-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-07-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-08-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-09-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-10-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-11-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-12-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-13-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-14-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-15-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-ventrilo-16-msg"], "PARTY")
                    end 
                 },               
                 party_begin ={ 
                    name  = L["ann-raid-raid-begin-title"], 
                    desc  = L["ann-raid-raid-begin-descr"], 
                    type  = 'execute', 
                    order = 10,
                    func  = function() 
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-02-msg"], "RAID_WARNING")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-14-msg"], "RAID_WARNING")
  
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-01-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-02-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-03-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-04-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-05-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-06-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-07-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-08-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-09-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-10-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-11-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-12-msg"], "PARTY")
                      ConvergeFu:SendChatMessage(L["ann-raid-raid-begin-13-msg"], "PARTY")
                    end 
                 },               
                 party_end ={ 
                    name  = L["ann-raid-raid-end-title"], 
                    desc  = L["ann-raid-raid-end-descr"], 
                    type  = 'execute',
                    order = 20,
                    func  = function() 
                      ConvergeFu:AnnounceRaidEnd("PARTY")
                    end 
                 },
                 priority ={ 
                    name  = L["ann-common-looting-order-title"], 
                    desc  = L["ann-common-looting-order-descr"], 
                    type  = 'execute',
                    order = 40,
                    func  = function() 
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-01-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-02-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-03-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-04-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-05-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-06-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-07-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-08-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-09-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-10-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-11-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-12-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-13-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-14-msg"], "PARTY")
                       ConvergeFu:SendChatMessage(L["ann-common-looting-order-15-msg"], "PARTY")
                    end 
                 }
              }
           },
           say = {
              name  = L["ann-say-title"], 
              desc  = L["ann-say-descr"],
              type  = 'group', 
              order = 40,
              args  = {
                 header1   = {
                    name   = L["ann-say-header"],
                    type   = "header",
                    order  = 09,
                 },              
                 allhail = { 
                    name  = L["ann-say-allhailtothe-title"], 
                    desc  = L["ann-say-allhailtothe-descr"], 
                    type  = 'execute',
                    order = 10,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-allhailtothe-msg"]..ConvergeFu:MyTargetOrMeOtherwise().."!", "SAY") end
                 },
                 byyourcommand = { 
                    name  = L["ann-say-byyourcommand-title"], 
                    desc  = L["ann-say-byyourcommand-descr"], 
                    type  = 'execute',
                    order = 20,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-byyourcommand-msg"], "SAY") end
                 },
                 crazyivan = { 
                    name  = L["ann-say-crazyivan-title"], 
                    desc  = L["ann-say-crazyivan-descr"], 
                    type  = 'execute',
                    order = 30,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-crazyivan-msg"], "SAY") end
                 },
                 doyouunderstand = { 
                    name  = L["ann-say-doyouunderstand-title"], 
                    desc  = L["ann-say-doyouunderstand-descr"], 
                    type  = 'execute',
                    order = 40,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-doyouunderstand-msg"], "SAY") end
                 },
                 eeek = { 
                    name  = L["ann-say-eeek-title"], 
                    desc  = L["ann-say-eeek-descr"], 
                    type  = 'execute',
                    order = 50,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-eeek-msg"], "SAY") end
                 },
                 evasion = { 
                    name  = L["ann-say-evasion-title"], 
                    desc  = L["ann-say-evasion-descr"], 
                    type  = 'execute', 
                    order = 51,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-evasion-msg"], "SAY") end
                 },
                 fireball = { 
                    name  = L["ann-say-fireball-title"], 
                    desc  = L["ann-say-fireball-descr"], 
                    type  = 'execute', 
                    order = 60,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-fireball-msg"], "SAY") end
                 },
                 forconverge = { 
                    name  = L["ann-say-forconverge-title"], 
                    desc  = L["ann-say-forconverge-descr"], 
                    type  = 'execute',
                    order = 61,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-forconverge-msg"], "SAY") end
                 },                 
                 gameoverman = { 
                    name  = L["ann-say-gameoverman-title"], 
                    desc  = L["ann-say-gameoverman-descr"], 
                    type  = 'execute',
                    order = 70,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-gameoverman-msg"], "SAY") end
                 },                 
                 granny = { 
                    name  = L["ann-say-granny-title"], 
                    desc  = L["ann-say-granny-descr"], 
                    type  = 'execute',
                    order = 71,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-granny-msg"], "SAY") end
                 },
                 itscomingrightforus = { 
                    name  = L["ann-say-itscomingrightforus-title"], 
                    desc  = L["ann-say-itscomingrightforus-descr"], 
                    type  = 'execute', 
                    order = 100,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-itscomingrightforus-msg"], "SAY") end
                 },
                 mine = { 
                    name  = L["ann-say-mine-title"], 
                    desc  = L["ann-say-mine-descr"], 
                    type  = 'execute',
                    order = 130,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-mine-msg"], "SAY") end
                 },
                 nerfhunters = { 
                    name  = L["ann-say-nerfhunters-title"], 
                    desc  = L["ann-say-nerfhunters-descr"], 
                    type  = 'execute',
                    order = 140,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-nerfhunters-msg"], "SAY") end
                 },
                 pusspuss = { 
                    name = L["ann-say-pusspuss-title"], 
                    desc = L["ann-say-pusspuss-descr"], 
                    type = 'execute', 
                    order = 160,
                    func = function() ConvergeFu:SendChatMessage(L["ann-say-pusspuss-msg"], "SAY") end
                 },                 
                 rawr = { 
                    name  = L["ann-say-rawr-title"], 
                    desc  = L["ann-say-rawr-descr"], 
                    type  = 'execute',
                    order = 180,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-rawr-msg"], "SAY") end
                 },
                 retdps = { 
                    name  = L["ann-say-retdps-title"], 
                    desc  = L["ann-say-retdps-descr"], 
                    type  = 'execute',
                    order = 181,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-retdps-msg"], "SAY") end
                 },
                 siryessir = { 
                    name  = L["ann-say-siryessir-title"], 
                    desc  = L["ann-say-siryessir-descr"], 
                    type  = 'execute', 
                    order = 190,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-siryessir-msg"], "SAY") end
                 },
                 thisismyrifle = { 
                    name  = L["ann-say-thisismyrifle-title"], 
                    desc  = L["ann-say-thisismyrifle-descr"], 
                    type  = 'execute',
                    order = 200,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-thisismyrifle-msg"], "SAY") end
                 },
                 threat = { 
                    name  = L["ann-say-threat-title"], 
                    desc  = L["ann-say-threat-descr"], 
                    type  = 'execute',
                    order = 201,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-threat-msg"], "SAY") end
                 },                 
                 usemagic = { 
                    name  = L["ann-say-usemagic-title"], 
                    desc  = L["ann-say-usemagic-descr"], 
                    type  = 'execute', 
                    order = 210,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-usemagic-msg"], "SAY") end
                 },                 
                 wolfish = { 
                    name  = L["ann-say-wolfish-title"], 
                    desc  = L["ann-say-wolfish-descr"], 
                    type  = 'execute',
                    order = 230,
                    func  = function() ConvergeFu:SendChatMessage(L["ann-say-wolfish-msg"], "SAY") end
                 },  
                 zzzz = { 
                    name = L["ann-say-zzzz-title"], 
                    desc = L["ann-say-zzzz-descr"], 
                    type = 'execute', 
                    order = 260,
                    func = function() ConvergeFu:SendChatMessage(L["ann-say-zzzz-msg"], "SAY") end
                 },
                 random = { 
                    name  = L["ann-say-random-title"], 
                    desc  = L["ann-say-random-descr"], 
                    type  = 'execute',
                    order = 300,
                    func  = function()
                       randomNumber = math.random(1,21) 
                       if     randomNumber ==  1 then ConvergeFu:SendChatMessage(L["ann-say-allhailtothe-msg"]..ConvergeFu:MyTargetOrMeOtherwise().."!", "SAY")
                       elseif randomNumber ==  2 then ConvergeFu:SendChatMessage(L["ann-say-byyourcommand-msg"], "SAY")
                       elseif randomNumber ==  3 then ConvergeFu:SendChatMessage(L["ann-say-crazyivan-msg"], "SAY")
                       elseif randomNumber ==  4 then ConvergeFu:SendChatMessage(L["ann-say-doyouunderstand-msg"], "SAY")
                       elseif randomNumber ==  5 then ConvergeFu:SendChatMessage(L["ann-say-eeek-msg"], "SAY")
                       elseif randomNumber ==  6 then ConvergeFu:SendChatMessage(L["ann-say-evasion-msg"], "SAY")
                       elseif randomNumber ==  7 then ConvergeFu:SendChatMessage(L["ann-say-fireball-msg"], "SAY")
                       elseif randomNumber ==  8 then ConvergeFu:SendChatMessage(L["ann-say-forconverge-msg"], "SAY")
                       elseif randomNumber ==  9 then ConvergeFu:SendChatMessage(L["ann-say-gameoverman-msg"], "SAY")
                       elseif randomNumber == 10 then ConvergeFu:SendChatMessage(L["ann-say-granny-msg"], "SAY")
                       elseif randomNumber == 11 then ConvergeFu:SendChatMessage(L["ann-say-itscomingrightforus-msg"], "SAY")
                       elseif randomNumber == 12 then ConvergeFu:SendChatMessage(L["ann-say-mine-msg"], "SAY")                       
                       elseif randomNumber == 13 then ConvergeFu:SendChatMessage(L["ann-say-nerfhunters-msg"], "SAY")
                       elseif randomNumber == 14 then ConvergeFu:SendChatMessage(L["ann-say-pusspuss-msg"], "SAY")
                       elseif randomNumber == 15 then ConvergeFu:SendChatMessage(L["ann-say-rawr-msg"], "SAY")                       
                       elseif randomNumber == 16 then ConvergeFu:SendChatMessage(L["ann-say-retdps-msg"], "SAY")
                       elseif randomNumber == 17 then ConvergeFu:SendChatMessage(L["ann-say-siryessir-msg"], "SAY")
                       elseif randomNumber == 18 then ConvergeFu:SendChatMessage(L["ann-say-thisismyrifle-msg"], "SAY")
                       elseif randomNumber == 19 then ConvergeFu:SendChatMessage(L["ann-say-threat-msg"], "SAY")
                       elseif randomNumber == 20 then ConvergeFu:SendChatMessage(L["ann-say-usemagic-msg"], "SAY")
                       elseif randomNumber == 21 then ConvergeFu:SendChatMessage(L["ann-say-wolfish-msg"], "SAY")
                       elseif randomNumber == 22 then ConvergeFu:SendChatMessage(L["ann-say-zzzz-msg"], "SAY")
                       end
                    end
                 }                 
              }
           },
            gmotd = {
               name = L["ann-gmotd-title"] , 
               desc = L["ann-gmotd-descr"] ,
               type = 'group', 
               args = {
                  header1   = {
                    name   = L["ann-gmotd-header"],
                    type   = "header",
                    order  = 09,
                  },                
                  nextraid ={ 
                     name = L["ann-gmotd-nextraid-title"], 
                     desc = L["ann-gmotd-nextraid-descr"], 
                     type = 'group', 
                     args = {
                        header1   = {
                           name   = L["ann-gmotd-nextraid-header"],
                           type   = "header",
                           order  = 09,
                        },
                        sun = {
                           name  = L["ann-gmotd-nextraid-sun-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-sun"])
                           end
                        },
                        mon = {
                           name  = L["ann-gmotd-nextraid-mon-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-mon"])
                           end
                        },
                        tue = {
                           name  = L["ann-gmotd-nextraid-tue-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-tue"])
                           end
                        },
                        wed = {
                           name  = L["ann-gmotd-nextraid-wed-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-wed"])
                           end
                        },
                        thu = {
                           name  = L["ann-gmotd-nextraid-thu-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 50,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-thu"])
                           end
                        },
                        fri = {
                           name  = L["ann-gmotd-nextraid-fri-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 60,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-fri"])
                           end
                        },
                        sat = {
                           name  = L["ann-gmotd-nextraid-sat-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 70,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-sat"])
                           end
                        },
                        morning = {
                           name  = L["ann-gmotd-nextraid-morning-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 80,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-morning"])
                           end
                        },
                        afternoon = {
                           name  = L["ann-gmotd-nextraid-afternoon-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 90,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-afternoon"])
                           end
                        },
                        latenight = {
                           name  = L["ann-gmotd-nextraid-latenight-title"],
                           desc  = L["ann-gmotd-nextraid-common-descr"],
                           type  = 'execute',
                           order = 100,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["common-motd-nextraid-latenight"])
                           end
                        }                        
                     }
                  },
                  tips = {
                     name = L["ann-gmotd-tips-title"] ,
                     desc = L["ann-gmotd-tips-descr"],
                     type = 'group',
                     args = {
                        header1   = {
                           name   = L["ann-gmotd-tips-header"],
                           type   = "header",
                           order  = 09,
                        },
                        brevity = {
                           name  = L["ann-gmotd-tips-brevity-title"],
                           desc  = L["ann-gmotd-tips-brevity-descr"],
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-brevity-msg"])
                           end
                        },
                        sympathy = {
                           name  = L["ann-gmotd-tips-sympathy-title"],
                           desc  = L["ann-gmotd-tips-sympathy-descr"],
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-sympathy-msg"])
                           end
                        },
                        alertness = {
                           name  = L["ann-gmotd-tips-alertness-title"],
                           desc  = L["ann-gmotd-tips-alertness-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-alertness-msg"])
                           end
                        },
                        revenge = {
                           name  = L["ann-gmotd-tips-revenge-title"],
                           desc  = L["ann-gmotd-tips-revenge-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-revenge-msg"])
                           end
                        },
                        quickchange = {
                           name  = L["ann-gmotd-tips-quickchange-title"],
                           desc  = L["ann-gmotd-tips-quickchange-descr"],
                           type  = 'execute',
                           order = 50,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-quickchange-msg"])
                           end
                        },
                        mp5 = {
                           name  = L["ann-gmotd-tips-mp5-title"],
                           desc  = L["ann-gmotd-tips-mp5-descr"],
                           type  = 'execute',
                           order = 60,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-mp5-msg"])
                           end
                        },
                        escapology = {
                           name  = L["ann-gmotd-tips-escapology-title"],
                           desc  = L["ann-gmotd-tips-escapology-descr"],
                           type  = 'execute',
                           order = 70,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-escapology-msg"])
                           end
                        },
                        globalwarming = {
                           name  = L["ann-gmotd-tips-globalwarming-title"],
                           desc  = L["ann-gmotd-tips-globalwarming-descr"],
                           type  = 'execute',
                           order = 80,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-globalwarming-msg"])
                           end
                        },
                        holdingaggro = {
                           name  = L["ann-gmotd-tips-holdingaggro-title"],
                           desc  = L["ann-gmotd-tips-holdingaggro-descr"],
                           type  = 'execute',
                           order = 90,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-holdingaggro-msg"])
                           end
                        },
                        spottingaggro = {
                           name  = L["ann-gmotd-tips-spottingaggro-title"],
                           desc  = L["ann-gmotd-tips-spottingaggro-descr"],
                           type  = 'execute',
                           order = 100,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-spottingaggro-msg"])
                           end
                        },
                        winninglottery = {
                           name  = L["ann-gmotd-tips-winninglottery-title"],
                           desc  = L["ann-gmotd-tips-winninglottery-descr"],
                           type  = 'execute',
                           order = 110,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-winninglottery-msg"])
                           end
                        },
                        bleedingmobs = {
                           name  = L["ann-gmotd-tips-bleedingmobs-title"],
                           desc  = L["ann-gmotd-tips-bleedingmobs-descr"],
                           type  = 'execute',
                           order = 120,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-bleedingmobs-msg"])
                           end
                        },
                        translating = {
                           name  = L["ann-gmotd-tips-translating-title"],
                           desc  = L["ann-gmotd-tips-translating-descr"],
                           type  = 'execute',
                           order = 130,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-translating-msg"])
                           end
                        },
                        wildhammer = {
                           name  = L["ann-gmotd-tips-wildhammer-title"],
                           desc  = L["ann-gmotd-tips-wildhammer-descr"],
                           type  = 'execute',
                           order = 140,
                           func  = function()
                              ConvergeFu:SetGuildMessageOfTheDay(L["ann-gmotd-tips-wildhammer-msg"])
                           end
                        }
                     }
                  }
               }
            }           
         }
      },
      chat = { 
         name  = L["mainmenu-chat-title"], 
         desc  = L["mainmenu-chat-descr"],
         type  = 'group', 
         order = 20,
         args  = { 
            header1 = {
               name  = L["chat-header"],
               type  = "header",
               order = 9,
            },
            join = { 
               name  = L["chat-join-title"], 
               desc  = L["chat-join-descr"],
               type  = 'group', 
               order = 10, 
               args  = {
                  header1 = {
                     name  = L["chat-join-header"],
                     type  = "header",
                     order = 9,
                  },               
                  condknight = { 
                     name  = L["chat-condknight-title"], 
                     desc  = L["chat-condknight-descr"],
                     order = 10,
                     type  = 'execute', 
                     func  = function() ConvergeFu:ExecuteChatCommand("/join condknight") end 
                  },               
                  condruid = { 
                     name  = L["chat-condruid-title"], 
                     desc  = L["chat-condruid-descr"], 
                     type  = 'execute', 
                     order = 20,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join condruid") end 
                  }, 
                  conhunter = { 
                     name  = L["chat-conhunter-title"], 
                     desc  = L["chat-conhunter-descr"], 
                     type  = 'execute',
                     order = 30,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conhunter") end 
                  }, 
                  conmage = { 
                     name  = L["chat-conmage-title"], 
                     desc  = L["chat-conmage-descr"], 
                     type  = 'execute', 
                     order = 40,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conmage") end 
                  }, 
                  conpaladin = { 
                     name  = L["chat-conpaladin-title"], 
                     desc  = L["chat-conpaladin-descr"], 
                     type  = 'execute',
                     order = 50,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conpally") end 
                  }, 
                  conpriest = { 
                     name  = L["chat-conpriest-title"], 
                     desc  = L["chat-conpriest-descr"], 
                     type  = 'execute',
                     order = 60,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conpriest") end 
                  }, 
                  conrogue = { 
                     name  = L["chat-conrogue-title"], 
                     desc  = L["chat-conrogue-descr"], 
                     type  = 'execute',
                     order = 70,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conrogue") end 
                  }, 
                  conshaman = { 
                     name  = L["chat-conshaman-title"], 
                     desc  = L["chat-conshaman-descr"], 
                     type  = 'execute',
                     order = 80,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conshaman") end 
                  },
                  conlock = { 
                     name  = L["chat-conlock-title"], 
                     desc  = L["chat-conlock-descr"], 
                     type  = 'execute',
                     order = 90,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conlock") end 
                  }, 
                  conwarrior = { 
                     name  = L["chat-conwarrior-title"], 
                     desc  = L["chat-conwarrior-descr"], 
                     type  = 'execute',
                     order = 100,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conwarrior") end 
                  },
                  header2 = {
                     name  = " ",
                     type  = "header",
                     order = 109,
                  },                   
                  conhealer = { 
                     name  = L["chat-conhealer-title"], 
                     desc  = L["chat-conhealer-descr"], 
                     type  = 'execute', 
                     order = 110,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join conhealer") end 
                  },
                  contank = { 
                     name  = L["chat-contank-title"], 
                     desc  = L["chat-contank-descr"], 
                     type  = 'execute',
                     order = 120,
                     func  = function() ConvergeFu:ExecuteChatCommand("/join contank") end 
                  }
               }
            },
            leave = { 
               name  = L["chat-leave-title"], 
               desc  = L["chat-leave-descr"],
               type  = 'group', 
               order = 20,
               args  = {
                  header1 = {
                     name  = L["chat-leave-header"],
                     type  = "header",
                     order = 9,
                  },               
                  condknight = { 
                     name  = L["chat-condknight-title"], 
                     desc  = L["chat-condknight-descr"], 
                     type  = 'execute',
                     order = 10,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave condknight") end 
                  },                
                  condruid = { 
                     name  = L["chat-condruid-title"], 
                     desc  = L["chat-condruid-descr"], 
                     type  = 'execute', 
                     order = 20,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave condruid") end 
                  }, 
                  conhunter = { 
                     name  = L["chat-conhunter-title"], 
                     desc  = L["chat-conhunter-descr"], 
                     type  = 'execute', 
                     order = 30,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conhunter") end 
                  }, 
                  conmage = { 
                     name  = L["chat-conmage-title"], 
                     desc  = L["chat-conmage-descr"], 
                     type  = 'execute', 
                     order = 40,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conmage") end 
                  }, 
                  conpaladin = { 
                     name  = L["chat-conpaladin-title"], 
                     desc  = L["chat-conpaladin-descr"], 
                     type  = 'execute', 
                     order = 50,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conpaladin") end 
                  }, 
                  conpriest = { 
                     name  = L["chat-conpriest-title"], 
                     desc  = L["chat-conpriest-descr"], 
                     type  = 'execute',
                     order = 60,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conpriest") end 
                  }, 
                  conrogue = { 
                     name  = L["chat-conrogue-title"], 
                     desc  = L["chat-conrogue-descr"], 
                     type  = 'execute', 
                     order = 70,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conrogue") end 
                  }, 
                  conshaman = { 
                     name  = L["chat-conshaman-title"], 
                     desc  = L["chat-conshaman-descr"], 
                     type  = 'execute',
                     order = 80,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conshaman") end 
                  },
                  conlock = { 
                     name = L["chat-conlock-title"], 
                     desc = L["chat-conlock-descr"], 
                     type = 'execute',
                     order = 90,
                     func = function() ConvergeFu:ExecuteChatCommand("/leave conlock") end 
                  }, 
                  conwarrior = { 
                     name  = L["chat-conwarrior-title"], 
                     desc  = L["chat-conwarrior-descr"], 
                     type  = 'execute', 
                     order = 100,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conwarrior") end 
                  },
                  header2 = {
                     name  = " ",
                     type  = "header",
                     order = 109,
                  },                   
                  conhealer = { 
                     name  = L["chat-conhealer-title"], 
                     desc  = L["chat-conhealer-descr"], 
                     type  = 'execute',
                     order = 110,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave conhealer") end 
                  },
                  contank = { 
                     name  = L["chat-contank-title"], 
                     desc  = L["chat-contank-descr"], 
                     type  = 'execute',
                     order = 120,
                     func  = function() ConvergeFu:ExecuteChatCommand("/leave contank") end 
                  }
               }
            },
            who = {
               name  = L["chat-who-title"], 
               desc  = L["chat-who-descr"],
               type  = 'group', 
               order = 30, 
               args  = {
                  header1 = {
                     name  = L["chat-who-header"],
                     type  = "header",
                     order = 9,
                  },                
                  condknight = { 
                     name  = L["chat-condknight-title"], 
                     desc  = L["chat-condknight-descr"], 
                     type  = 'execute',
                     order = 10,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho condknight") end 
                  },                
                  condruid = { 
                     name = L["chat-condruid-title"], 
                     desc  = L["chat-condruid-descr"], 
                     type  = 'execute',
                     order = 20,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho condruid") end 
                  }, 
                  conhunter = { 
                     name  = L["chat-conhunter-title"], 
                     desc  = L["chat-conhunter-descr"], 
                     type  = 'execute',
                     order = 30,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conhunter") end 
                  }, 
                  conmage = { 
                     name  = L["chat-conmage-title"], 
                     desc  = L["chat-conmage-descr"], 
                     type  = 'execute',
                     order = 40,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conmage") end 
                  }, 
                  conpaladin = { 
                     name  = L["chat-conpaladin-title"], 
                     desc  = L["chat-conpaladin-descr"], 
                     type  = 'execute',
                     order = 50,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conpaladin") end 
                  }, 
                  conpriest = { 
                     name  = L["chat-conpriest-title"], 
                     desc  = L["chat-conpriest-descr"], 
                     type  = 'execute',
                     order = 60,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conpriest") end 
                  }, 
                  conrogue = { 
                     name  = L["chat-conrogue-title"], 
                     desc  = L["chat-conrogue-descr"], 
                     type  = 'execute',
                     order = 70,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conrogue") end 
                  }, 
                  conshaman = { 
                     name  = L["chat-conshaman-title"], 
                     desc  = L["chat-conshaman-descr"], 
                     type  = 'execute',
                     order = 80,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conshaman") end 
                  },
                  conlock = { 
                     name  = L["chat-conlock-title"], 
                     desc  = L["chat-conlock-descr"], 
                     type  = 'execute',
                     order = 90,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conlock") end 
                  }, 
                  conwarrior = { 
                     name  = L["chat-conwarrior-title"], 
                     desc  = L["chat-conwarrior-descr"], 
                     type  = 'execute',
                     order = 100,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho conwarrior") end 
                  },
                  header2 = {
                     name  = " ",
                     type  = "header",
                     order = 109,
                  },                   
                  conhealer = { 
                     name = L["chat-conhealer-title"], 
                     desc = L["chat-conhealer-descr"], 
                     type = 'execute',
                     order = 110,
                     func = function() ConvergeFu:ExecuteChatCommand("/chatwho conhealer") end 
                  },
                  contank = { 
                     name  = L["chat-contank-title"], 
                     desc  = L["chat-contank-descr"], 
                     type  = 'execute',
                     order = 120,
                     func  = function() ConvergeFu:ExecuteChatCommand("/chatwho contank") end 
                  }
               }            
            },
            list = {
               name  = L["chat-list-title"], 
               desc  = L["chat-list-descr"], 
               type  = 'execute', 
               order = 40,
               func  = function() ConvergeFu:ExecuteChatCommand("/chatlist") end 
            },
            announce = {
               name  = L["chat-announce-title"], 
               desc  = L["chat-announce-descr"], 
               type  = 'execute', 
               order = 50,
               func  = function() 
                  ConvergeFu:SendChatMessage(L["chat-announce-01-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-02-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-03-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-04-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-05-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-06-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-07-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-08-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-09-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-10-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-11-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-12-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-13-msg"], "RAID")
                  ConvergeFu:SendChatMessage(L["chat-announce-14-msg"], "RAID")
               end 
            }            
         }
      },
      addons = { 
         name  = L["mainmenu-addons-title"], 
         desc  = L["mainmenu-addons-descr"],
         type  = 'group', 
         order = 30, 
         args  = {
            header1 = {
               name  = L["addons-header"],
               type  = "header",
               order = 9,
            },
            ra = {
               name  = L["addon-ra-title"],
               desc  = L["addon-ra-descr"],
               type  = 'group',
               order = 50,
               args  = {
                  header1 = {
                     name  = L["addon-ra-header"],
                     type  = "header",
                     order = 9,
                  },               
                  ready = { 
                     name  = L["addon-ra-ready-title"], 
                     desc  = L["addon-ra-ready-descr"], 
                     type  = 'execute',
                     order = 10,
                     func  = function() ConvergeFu:DoReadyCheck()  end 
                  },
                  presence = {
                     name  = L["addon-ra-vote-presence-title"], 
                     desc  = L["addon-ra-vote-presence-descr"], 
                     type  = 'execute',
                     order = 20,
                     func  = function() ConvergeFu:ExecuteChatCommand("/ravote "..L["addon-ra-vote-presence-msg"])  end 
                  },
                  dura = { 
                     name  = L["addon-ra-dura-title"], 
                     desc  = L["addon-ra-dura-descr"], 
                     type  = 'execute',
                     order = 30,
                     func  = function() ConvergeFu:ExecuteChatCommand("/radur") end 
                  }, 
                  resist = { 
                     name  = L["addon-ra-resist-title"], 
                     desc  = L["addon-ra-resist-descr"], 
                     type  = 'execute', 
                     order = 40,
                     func  = function() ConvergeFu:ExecuteChatCommand("/raresist") end 
                  },
                  item = { 
                     name  = L["addon-ra-item-title"], 
                     desc  = L["addon-ra-item-descr"], 
                     type  = 'execute',
                     order = 50,
                     func  = function()
                        ConvergeFu:SendChatMessage(L["addon-ra-item-01-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-02-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-03-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-04-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-05-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-06-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-07-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-08-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-09-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-10-msg"], "OFFICER")
                        ConvergeFu:SendChatMessage(L["addon-ra-item-11-msg"], "OFFICER")                     
                     end 
                  },                  
                  version = { 
                     name  = L["addon-ra-version-title"], 
                     desc  = L["addon-ra-version-descr"], 
                     type  = 'execute',
                     order = 50,
                     func  = function() ConvergeFu:ExecuteChatCommand("/raversion")  end 
                  }               
               }
            },
            dbm = {
               name  = L["addon-dbm-title"],
               desc  = L["addon-dbm-descr"],
               type  = 'group',
               order = 10,
               args  = {
                  header1 = {
                     name  = L["addon-dbm-timer-bio-header"],
                     type  = "header",
                     order = 9,
                  },
                  timer_bio_03min = { 
                     name  = L["addon-dbm-timer-bio-03m-title"], 
                     desc  = L["addon-dbm-timer-bio-03m-descr"], 
                     type  = 'execute',
                     order = 10,
                     func  = function() DBM:CreatePizzaTimer(180, L["addon-dbm-timer-bio-break-msg"], true) end
                  }, 
                  timer_bio_05min = { 
                     name  = L["addon-dbm-timer-bio-05m-title"], 
                     desc  = L["addon-dbm-timer-bio-05m-descr"], 
                     type  = 'execute',
                     order = 20,
                     func  = function() DBM:CreatePizzaTimer(300, L["addon-dbm-timer-bio-break-msg"], true) end
                  }, 
                  timer_bio_07min = { 
                     name  = L["addon-dbm-timer-bio-07m-title"], 
                     desc  = L["addon-dbm-timer-bio-07m-descr"], 
                     type  = 'execute',
                     order = 30,
                     func  = function() DBM:CreatePizzaTimer(420, L["addon-dbm-timer-bio-break-msg"], true) end
                  }, 
                  timer_bio_10min = { 
                     name  = L["addon-dbm-timer-bio-10m-title"], 
                     desc  = L["addon-dbm-timer-bio-10m-descr"], 
                     type  = 'execute',
                     order = 40,
                     func  = function() DBM:CreatePizzaTimer(600, L["addon-dbm-timer-bio-break-msg"], true) end
                  },
                  header2 = {
                     name  = " ",
                     type  = "header",
                     order = 48,
                  },
                  header3 = {
                     name  = L["addon-dbm-timer-raid-start-header"],
                     type  = "header",
                     order = 49,
                  },
                  timer_raid_begins_05m = { 
                     name  = L["addon-dbm-timer-raid-start-05m-title"], 
                     desc  = L["addon-dbm-timer-raid-start-05m-descr"], 
                     type  = 'execute', 
                     order = 50,
                     func  = function() DBM:CreatePizzaTimer(300, L["addon-dbm-timer-raid-start-msg"], true) end
                  },
                  timer_raid_begins_10m = { 
                     name  = L["addon-dbm-timer-raid-start-10m-title"], 
                     desc  = L["addon-dbm-timer-raid-start-10m-descr"], 
                     type  = 'execute',
                     order = 60,
                     func  = function() DBM:CreatePizzaTimer(600, L["addon-dbm-timer-raid-start-msg"], true) end
                  }, 
                  timer_raid_begins_15m = { 
                     name  = L["addon-dbm-timer-raid-start-15m-title"], 
                     desc  = L["addon-dbm-timer-raid-start-15m-descr"], 
                     type  = 'execute',
                     order = 70,
                     func  = function() DBM:CreatePizzaTimer(900, L["addon-dbm-timer-raid-start-msg"], true) end
                  },
                  header4 = {
                     name  = " ",
                     type  = "header",
                     order = 78,
                  },
                  header5 = {
                     name  = L["addon-dbm-timer-pull-header"],
                     type  = "header",
                     order = 79,
                  },                  
                  timer_pull_05s_loud = { 
                     name  = L["addon-dbm-timer-pull-loud-05s-title"], 
                     desc  = L["addon-dbm-timer-pull-loud-05s-descr"], 
                     type  = 'execute',
                     order = 80,
                     func  = function() ConvergeFu:ExecuteChatCommand("/dbm pull 5") end 
                  },             
                  timer_pull_10s_loud = { 
                     name = L["addon-dbm-timer-pull-loud-10s-title"], 
                     desc = L["addon-dbm-timer-pull-loud-10s-descr"], 
                     type = 'execute',
                     order = 90,
                     func = function() ConvergeFu:ExecuteChatCommand("/dbm pull 10") end 
                  },
                  header6 = {
                     name  = " ",
                     type  = "header",
                     order = 98,
                  },
                  header7 = {
                     name  = L["addon-dbm-config-header"],
                     type  = "header",
                     order = 99,
                  },                  
                  stop = { 
                     name  = L["addon-dbm-stop-title"], 
                     desc  = L["addon-dbm-stop-descr"], 
                     type  = 'execute',
                     order = 100,
                     func  = function() ConvergeFu:ExecuteChatCommand("/dbm stop") end 
                  }, 
                  timer_bar_unlock = { 
                     name  = L["addon-dbm-unlock-title"], 
                     desc  = L["addon-dbm-unlock-descr"], 
                     type  = 'execute',
                     order = 110,
                     func  = function() ConvergeFu:ExecuteChatCommand("/dbm unlock") end 
                  },
                  version = { 
                     name  = L["addon-dbm-version-title"], 
                     desc  = L["addon-dbm-version-descr"], 
                     type  = 'execute',
                     order = 120,
                     func  = function() ConvergeFu:ExecuteChatCommand("/dbm ver") end 
                  }               
               }            
            },
            omen = {
               name  = L["addon-omen-title"],
               desc  = L["addon-omen-descr"],
               type  = 'group',
               order = 30,
               args  = {
                  header1 = {
                     name  = L["addon-omen-header"],
                     type  = "header",
                     order = 09,
                  },               
                  version = { 
                     name  = L["addon-omen-version-title"], 
                     desc  = L["addon-omen-version-descr"], 
                     type  = 'execute',
                     addon = 10,
                     func  = function()
                        Omen:VersionCheck(false)
                     end               
                  }               
               }            
            },
            ngr = {
               name  = L["addon-ngr-title"],
               desc  = L["addon-ngr-descr"],
               type  = 'group',
               order = 20,
               args  = {
                  header1 = {
                     name  = L["addon-ngr-header"],
                     type  = "header",
                     order = 09,
                  },               
                  set_default_msg = { 
                     name  = L["addon-ngr-version-title"], 
                     desc  = L["addon-ngr-version-descr"], 
                     type  = 'execute',
                     order = 10,
                     func  = function()
                        ConvergeFu:ExecuteChatCommand("/ngr msg " .. L["common-guild-recruitment-advert-msg"])   
                     end               
                  },
                  set_fun_msg = { 
                     name  = L["addon-ngr-fun-msg-title"], 
                     desc  = L["addon-ngr-fun-msg-descr"], 
                     type  = 'execute',
                     order = 20,
                     func  = function()
                        ConvergeFu:ExecuteChatCommand("/ngr msg " .. L["common-guild-recruitment-advert-fun-msg"])   
                     end               
                  },                  
                  set_zat_msg = { 
                     name  = L["addon-ngr-zat-msg-title"], 
                     desc  = L["addon-ngr-zat-msg-descr"], 
                     type  = 'execute',
                     order = 30,
                     func  = function()
                        ConvergeFu:ExecuteChatCommand("/ngr msg " .. L["common-guild-recruitment-advert-zat-msg"])   
                     end               
                  } 
               }            
            },            
            questhelper = {
               name  = L["addon-questhelper-title"],
               desc  = L["addon-questhelper-descr"],
               type  = 'group',
               order = 40,
               args  = {
                  header1 = {
                     name  = L["addon-questhelper-header"],
                     type  = "header",
                     order = 09,
                  },               
                  toggle = { 
                     name  = L["addon-questhelper-toggle-title"], 
                     desc  = L["addon-questhelper-toggle-descr"],
                     order = 10,
                     type  = 'execute', 
                     func  = function() ConvergeFu:ExecuteChatCommand("/qh hide") end               
                  }               
               }
            },
            raidbuffstatus = {
               name  = L["addon-raidbuffstatus-title"],
               desc  = L["addon-raidbuffstatus-descr"],
               type  = 'group',
               order = 60,
               args  = {
                  header1 = {
                     name  = L["addon-raidbuffstatus-header"],
                     type  = "header",
                     order = 09,
                  },               
                  toggle = { 
                     name  = L["addon-raidbuffstatus-toggle-title"], 
                     desc  = L["addon-raidbuffstatus-toggle-descr"], 
                     type  = 'execute',
                     order = 10,
                     func  = function() ConvergeFu:ExecuteChatCommand("/rbs toggle") end               
                  },
                  report = { 
                     name  = L["addon-raidbuffstatus-report-title"], 
                     desc  = L["addon-raidbuffstatus-report-descr"], 
                     type  = 'execute',
                     order = 20,
                     func  = function() ConvergeFu:ExecuteChatCommand("/rbs report") end               
                  }                   
               }
            }            
         }
      },
      macro = { 
         name  = L["mainmenu-macro-title"], 
         desc  = L["mainmenu-macro-descr"],
         type  = 'group', 
         order = 40,
         args  = {
            header1 = {
               name  = L["macros-header"],
               type  = "header",
               order = 9,
            },
            karazhan = { 
               name  = L["macro-karazhan-title"], 
               desc  = L["macro-karazhan-descr"],
               type  = 'group', 
               order = 10, 
               args  = {
                  header1 = {
                     name  = L["macro-karazhan-header"],
                     type  = "header",
                     order = 9,
                  },
                  curator = { 
                     name  = L["macro-karazhan-curator-title"], 
                     desc  = L["macro-karazhan-curator-descr"],
                     type  = 'group', 
                     order = 10, 
                     args  = {
                        header1 = {
                           name  = L["macro-karazhan-curator-header"],
                           type  = "header",
                           order = 9,
                        },                     
                        link ={ 
                           name  = L["macro-karazhan-curator-link-title"], 
                           desc  = L["macro-karazhan-curator-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-karazhan-curator-run-title"], 
                           desc  = L["macro-karazhan-curator-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:ExecuteChatCommand("/target astral flare")
                           end
                        },
                        show ={ 
                           name  = L["macro-karazhan-curator-show-title"], 
                           desc  = L["macro-karazhan-curator-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-curator-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  },
                  illhoof = { 
                     name  = L["macro-karazhan-illhoof-title"], 
                     desc  = L["macro-karazhan-illhoof-descr"],
                     type  = 'group', 
                     order = 20, 
                     args  = {
                        header1 = {
                           name  = L["macro-karazhan-illhoof-header"],
                           type  = "header",
                           order = 9,
                        },                     
                        link ={ 
                           name  = L["macro-karazhan-illhoof-link-title"], 
                           desc  = L["macro-karazhan-illhoof-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-karazhan-illhoof-run-title"], 
                           desc  = L["macro-karazhan-illhoof-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:ExecuteChatCommand("/target Demon Chains")
                           end
                        },
                        show ={ 
                           name  = L["macro-karazhan-illhoof-show-title"], 
                           desc  = L["macro-karazhan-illhoof-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-karazhan-illhoof-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  }
               }
            },
            ssc = { 
               name  = L["macro-ssc-title"], 
               desc  = L["macro-ssc-descr"],
               type  = 'group', 
               order = 20, 
               args  = {
                  header1 = {
                     name  = L["macro-ssc-header"],
                     type  = "header",
                     order = 9,
                  },
                  karathress = { 
                     name  = L["macro-ssc-karathress-title"], 
                     desc  = L["macro-ssc-karathress-descr"],
                     type  = 'group', 
                     order = 10, 
                     args  = {
                        header1 = {
                           name  = L["macro-ssc-karathress-header"],
                           type  = "header",
                           order = 9,
                        },
                        link ={ 
                           name  = L["macro-ssc-karathress-link-title"], 
                           desc  = L["macro-ssc-karathress-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-ssc-karathress-run-title"], 
                           desc  = L["macro-ssc-karathress-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:ExecuteChatCommand("/target Spitfire Totem")
                           end
                        },
                        show ={ 
                           name  = L["macro-ssc-karathress-show-title"], 
                           desc  = L["macro-ssc-karathress-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-karathress-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  },
                  vashj = { 
                     name = L["macro-ssc-vashj-title"], 
                     type = 'group', 
                     desc = L["macro-ssc-vashj-descr"], 
                     args = {
                        header1 = {
                           name  = L["macro-ssc-vashj-header"],
                           type  = "header",
                           order = 9,
                        },                     
                        link ={ 
                           name  = L["macro-ssc-vashj-link-title"], 
                           desc  = L["macro-ssc-vashj-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-ssc-vashj-run-title"], 
                           desc  = L["macro-ssc-vashj-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:ExecuteChatCommand("/use Tainted Core")
                              ConvergeFu:ExecuteChatCommand("/y <------- TAINTED CORE TO: %t ! ! !")
                              ConvergeFu:ExecuteChatCommand("/s <------- TAINTED CORE TO: %t ! ! !")
                              ConvergeFu:SendChatMessage("!!! YOU HAVE THE CORE !!!", "WHISPER", nil, UnitName("target"))
                           end
                        },
                        show ={ 
                           name  = L["macro-ssc-vashj-show-title"], 
                           desc  = L["macro-ssc-vashj-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-10-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-11-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-ssc-vashj-show-12-msg"], "RAID")
                           end
                        }                        
                     }
                  }
               }
            },
            eoe = {
               name  = L["macro-eoe-title"],
               desc  = L["macro-eoe-descr"],
               type  = 'group',
               order = 40,
               args  = {
                  header1 = {
                     name  = L["macro-eoe-header"],
                     type  = "header",
                     order = 9,
                  },               
                  p3drake = { 
                     name  = L["macro-eoe-malygos-p3drake-title"], 
                     desc  = L["macro-eoe-malygos-p3drake-descr"], 
                     type  = 'group', 
                     order = 10,
                     args  = {
                        header1 = {
                           name  = L["macro-eoe-malygos-p3drake-header"],
                           type  = "header",
                           order = 9,
                        },                     
                        link ={ 
                           name  = L["macro-eoe-malygos-p3drake-link-title"], 
                           desc  = L["macro-eoe-malygos-p3drake-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-link-06-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-eoe-malygos-p3drake-run-title"], 
                           desc  = L["macro-eoe-malygos-p3drake-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-run-01-msg"], "RAID")
                           end
                        },
                        show ={ 
                           name  = L["macro-eoe-malygos-p3drake-show-title"], 
                           desc  = L["macro-eoe-malygos-p3drake-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-10-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-11-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-12-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-eoe-malygos-p3drake-show-13-msg"], "RAID")
                           end
                        }                        
                     }
                  }
               }
            },
            bt = { 
               name  = L["macro-bt-title"], 
               desc  = L["macro-bt-descr"],
               type  = 'group', 
               order = 30, 
               args  = {
                  header1 = {
                     name  = L["macro-bt-header"],
                     type  = "header",
                     order = 9,
                  },               
                  najentus_spine = { 
                     name = L["macro-bt-najentus-spine-title"], 
                     desc = L["macro-bt-najentus-spine-descr"], 
                     type = 'group', 
                     order = 10,
                     args = {
                        header1 = {
                           name  = L["macro-bt-najentus-spine-header"],
                           type  = "header",
                           order = 9,
                        },                     
                        link ={ 
                           name  = L["macro-bt-najentus-spine-link-title"], 
                           desc  = L["macro-bt-najentus-spine-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-bt-najentus-spine-run-title"], 
                           desc  = L["macro-bt-najentus-spine-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:ExecuteChatCommand("/use Naj'entus Spine")
                           end
                        },
                        show ={ 
                           name  = L["macro-bt-najentus-spine-show-title"], 
                           desc  = L["macro-bt-najentus-spine-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-spine-show-09-msg"], "RAID")
                           end
                        }                        
                     }
                  },
                  najentus_hp = { 
                     name  = L["macro-bt-najentus-hp-title"], 
                     desc  = L["macro-bt-najentus-hp-descr"],
                     type  = 'group', 
                     order = 20,
                     args  = {
                        header1 = {
                           name  = L["macro-bt-najentus-hp-header"],
                           type  = "header",
                           order = 9,
                        },
                        link ={ 
                           name  = L["macro-bt-najentus-hp-link-title"], 
                           desc  = L["macro-bt-najentus-hp-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-link-10-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-bt-najentus-hp-run-title"], 
                           desc  = L["macro-bt-najentus-hp-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              for i = 1, 40 do
                                local u = "raid"..i;
                                local hp = UnitHealthMax(u);
                                local _, _, grp = GetRaidRosterInfo(i);
                                if UnitExists(u) and hp < 9500 and grp <= 5 then
                                  ChatFrame1:AddMessage(UnitName(u)..": "..hp.." HP");
                                end
                              end 
                           end
                        },
                        show ={ 
                           name  = L["macro-bt-najentus-hp-show-title"], 
                           desc  = L["macro-bt-najentus-hp-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-10-msg"], "RAID")                              
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-11-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-12-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-13-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-14-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-15-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-16-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-najentus-hp-show-17-msg"], "RAID")                              
                           end
                        }                        
                     }
                  },
                  gorefiend = { 
                     name  = L["macro-bt-gorefiend-const-title"], 
                     desc  = L["macro-bt-gorefiend-const-descr"],
                     type  = 'group', 
                     order = 30, 
                     args  = {
                        header1 = {
                           name  = L["macro-bt-gorefiend-header"],
                           type  = "header",
                           order = 9,
                        },                     
                        link ={ 
                           name  = L["macro-bt-gorefiend-const-link-title"], 
                           desc  = L["macro-bt-gorefiend-const-link-descr"], 
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-link-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-link-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-link-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-link-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-link-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-link-06-msg"], "RAID")
                           end
                        },
                        run ={ 
                           name  = L["macro-bt-gorefiend-const-run-title"], 
                           desc  = L["macro-bt-gorefiend-const-run-descr"],  
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-run-01-msg"], "CHAT")
                           end
                        },
                        show ={ 
                           name  = L["macro-bt-gorefiend-const-show-title"], 
                           desc  = L["macro-bt-gorefiend-const-show-descr"], 
                           type  = 'execute',
                           order = 30,
                           func  = function()
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-01-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-02-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-03-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-04-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-05-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-06-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-07-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-08-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-09-msg"], "RAID")
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-10-msg"], "RAID")                              
                              ConvergeFu:SendChatMessage(L["macro-bt-gorefiend-const-show-11-msg"], "RAID")
                           end
                        }                        
                     }
                  }                  
               }
            }
         }         
      },
      tools = {
         name  = L["mainmenu-tools-title"], 
         desc  = L["mainmenu-tools-descr"],
         type  = 'group', 
         order = 50,
         args  = {
            header1 = {
               name  = L["tools-header"],
               desc  = "",
               type  = 'header',
               order = 09
            },
            recruiter = {
               name  = L["tools-recruiter-title"],
               desc  = L["tools-recruiter-descr"],
               type  = 'group',
               order = 90,
               args  = {
                  header1 = {
                     name  = L["tools-recruiter-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },               
                  start = {
                     name = L["tools-recruiter-start-title"],
                     desc = L["tools-recruiter-start-descr"],
                     type = 'execute',
                     func = function()
                        ConvergeFu:RecruitCharacterCancel()
                        ConvergeFu:RecruitCharacter()
                     end
                  },
                  report = {
                     name = L["tools-recruiter-report-title"],
                     desc = L["tools-recruiter-report-descr"],
                     type = 'execute',
                     func = function()
                        ConvergeFu:RecruitReportStatus()
                     end
                  },
                  reset = {
                     name = L["tools-recruiter-reset-title"],
                     desc = L["tools-recruiter-reset-descr"],
                     type = 'execute',
                     func = function()
                        ConvergeFu:RecruitCharacterCancel()
                     end
                  }                                    
               }
            },
            itemleveldkp = {
               name  = L["tools-itemleveldkp-title"],
               desc  = L["tools-itemleveldkp-descr"],
               type  = 'group',
               order = 60,
               args  = {
                  header1 = {
                     name  = L["tools-itemleveldkp-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09
                  },               
                  settype = {
                     name     = L["tools-itemleveldkp-settype-title"],
                     desc     = L["tools-itemleveldkp-settype-descr"],
                     type     = 'text',
                     order    = 10,
                     usage    = L["tools-itemleveldkp-settype-usage"],
                     get      = function() return ConvergeFu.db.profile.itemLevelType end,
                     set      = function(newValue) ConvergeFu.db.profile.itemLevelType = newValue end,                              
                     validate = {"Rare", "Epic", "Legendary"}               
                  },                  
                  setslot = {
                     name     = L["tools-itemleveldkp-setslot-title"],
                     desc     = L["tools-itemleveldkp-setslot-descr"],
                     type     = 'text',
                     order    = 20,
                     usage    = L["tools-itemleveldkp-setslot-usage"],
                     get      = function() return ConvergeFu.db.profile.itemLevelSlot end,
                     set      = function(newValue) ConvergeFu.db.profile.itemLevelSlot = newValue end,                              
                     validate = {
                        L["tools-itemleveldkp-slot-head"],
                        L["tools-itemleveldkp-slot-neck"],
                        L["tools-itemleveldkp-slot-shoulder"],
                        L["tools-itemleveldkp-slot-back"],
                        L["tools-itemleveldkp-slot-chest"],
                        L["tools-itemleveldkp-slot-wrist"],
                        L["tools-itemleveldkp-slot-hands"],
                        L["tools-itemleveldkp-slot-waist"],
                        L["tools-itemleveldkp-slot-legs"],
                        L["tools-itemleveldkp-slot-feet"],
                        L["tools-itemleveldkp-slot-finger"],
                        L["tools-itemleveldkp-slot-trinket"],
                        L["tools-itemleveldkp-slot-weapon"],
                        L["tools-itemleveldkp-slot-shield"],
                        L["tools-itemleveldkp-slot-twohander"],
                        L["tools-itemleveldkp-slot-mainhand"],
                        L["tools-itemleveldkp-slot-onehand"],
                        L["tools-itemleveldkp-slot-offhand"],
                        L["tools-itemleveldkp-slot-bowcrossgun"],
                        L["tools-itemleveldkp-slot-wand"],
                        L["tools-itemleveldkp-slot-relictotem"]
                     }
                  },
                  setvalue = {
                     name      = L["tools-itemleveldkp-setvalue-title"],
                     desc      = L["tools-itemleveldkp-setvalue-title"],
                     type      = 'range',
                     order     = 30,
                     usage     = L["tools-itemleveldkp-setvalue-usage"],
                     get       = function() return ConvergeFu.db.profile.itemLevelValue end,
                     set       = function(newValue) ConvergeFu.db.profile.itemLevelValue = newValue end,
                     min       = 1,
                     max       = 300,
                     step      = 1,
                     isPercent = false
                  },
                  calculate = {
                     name  = L["tools-itemleveldkp-calculate-title"],
                     desc  = L["tools-itemleveldkp-calculate-descr"],
                     type  = 'execute',
                     order = 40,
                     func  = function() 
                        ConvergeFu:CalculateItemLevelDKP() 
                     end
                  }                  
               }
            },
            bidmanager = {
               name  = L["tools-bid-manager-title"],
               desc  = L["tools-bid-manager-descr"],
               type  = 'group',
               order = 10,
               args  = {
                  header1  = {
                    name   = L["tools-bidmgr-header-bids-normal"],
                    type   = "header",
                    order  = 10,
                  },
                  main = {
                     name = L["tools-bidmgr-makebid-main-std-title"],
                     desc = L["tools-bidmgr-makebid-main-std-descr"],
                     type = 'execute',
                     order  = 20,
                     func = function()
                        ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-main"], false)
                     end
                  },
                  resist = {
                     name = L["tools-bidmgr-makebid-resist-std-title"],
                     desc = L["tools-bidmgr-makebid-resist-std-descr"],
                     type = 'execute',
                     order  = 30,
                     func = function()
                        ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-resist"], false)
                     end
                  },
                  offspec = {
                     name = L["tools-bidmgr-makebid-offspec-std-title"],
                     desc = L["tools-bidmgr-makebid-offspec-std-descr"],
                     type = 'execute',
                     order  = 40,
                     func = function()
                        ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-offspec"], false)
                     end
                  },
                  header2  = {
                    name   = " ",
                    type   = "header",
                    order  = 49,
                  },                  
                  header3  = {
                    name   = L["tools-bidmgr-header-bids-req-alts"],
                    type   = "header",
                    order  = 50,
                  },                  
                  main_requested = {
                     name = L["tools-bidmgr-makebid-main-req-title"],
                     desc = L["tools-bidmgr-makebid-main-req-descr"],
                     type = 'execute',
                     order  = 60,
                     func = function()
                        ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-main"], true)
                     end
                  },
                  resist_requested = {
                     name = L["tools-bidmgr-makebid-resist-req-title"],
                     desc = L["tools-bidmgr-makebid-resist-req-descr"],
                     type = 'execute',
                     order  = 70,
                     func = function()
                        ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-resist"], true)
                     end
                  },
                  offspec_requested = {
                     name = L["tools-bidmgr-makebid-offspec-req-title"],
                     desc = L["tools-bidmgr-makebid-offspec-req-descr"],
                     type = 'execute',
                     order  = 80,
                     func = function()
                        ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-offspec"], true)
                     end
                  },
                  header4  = {
                    name   = " ",
                    type   = "header",
                    order  = 89,
                  },                  
                  header5  = {
                    name   = L["tools-bidmgr-header-mlconfig"],
                    type   = "header",
                    order  = 90,
                  },                  
                  init = {
                     name = L["tools-bidmgr-ml-initialise-title"],
                     desc = L["tools-bidmgr-ml-initialise-descr"],
                     type = 'execute',
                     order  = 100,
                     func = function()
                        ConvergeFu:InitialiseBidManagerRBPT()
                     end
                  },
                  howtobid = {
                     name = L["tools-bidmgr-ml-howtobid-title"],
                     desc = L["tools-bidmgr-ml-howtobid-descr"],
                     type = 'execute',
                     order  = 110,
                     func = function()
                        ConvergeFu:AnnounceBiddingInstructions("RAID")
                     end
                  },
                  howtobidpugstyle = {
                     name = L["tools-bidmgr-ml-howtobidpugstyle-title"],
                     desc = L["tools-bidmgr-ml-howtobidpugstyle-descr"],
                     type = 'execute',
                     order  = 120,
                     func = function()
                        ConvergeFu:AnnouncePUGStyleBiddingInstructions("RAID")
                     end
                  },                  
                  list_private = {
                     name = L["tools-bidmgr-ml-list-private-title"],
                     desc = L["tools-bidmgr-ml-list-private-descr"],
                     type = 'execute',
                     order  = 130,
                     func = function()
                        ConvergeFu:ListWinningBidders("CHAT")
                     end
                  },                  
                  list = {
                     name = L["tools-bidmgr-ml-list-winners-title"],
                     desc = L["tools-bidmgr-ml-list-winners-descr"],
                     type = 'execute',
                     order  = 140,
                     func = function()
                        ConvergeFu:ListWinningBidders(ConvergeFu.db.profile.bidmgrOutputChannel)
                     end
                  },
                  setlistchannel = {
                     name     = L["tools-bidmgr-ml-set-channel-list-title"],
                     desc     = L["tools-bidmgr-ml-set-channel-list-descr"],
                     type     = 'text',
                     order  = 150,
                     usage    = L["tools-bidmgr-ml-set-channel-list-usage"],
                     get      = function() return ConvergeFu.db.profile.bidmgrOutputChannel end,
                     set      = function(newValue) ConvergeFu.db.profile.bidmgrOutputChannel = newValue end,                              
                     validate = {["CHAT"]="Chat",["GUILD"]="Guild", ["RAID"]="Raid", ["OFFICER"]="Officer"} 
                  },
                  setsendchannel = {
                     name     = L["tools-bidmgr-ml-set-channel-send-title"],
                     desc     = L["tools-bidmgr-ml-set-channel-send-descr"],
                     type     = 'text',
                     order  = 160,
                     usage    = L["tools-bidmgr-ml-set-channel-send-usage"],
                     get      = function() return ConvergeFu.db.profile.bidmgrSendingChannel end,
                     set      = function(newValue) ConvergeFu.db.profile.bidmgrSendingChannel = newValue end,                              
                     validate = {["ADDON"]="Addon", ["WHISPER"]="Whisper"} 
                  }                  
               }
            },
            responder = {
               name  = L["tools-busy-responder-title"],
               desc  = L["tools-busy-responder-title"],
               type  = 'group',
               order = 30,
               args  = {
                  header1 = {
                     name  = L["tools-busy-responder-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },               
                  enabled = {
                     name     = L["tools-busy-responder-status-title"],
                     desc     = L["tools-busy-responder-status-descr"],
                     type     = 'text',
                     order    = 10,
                     usage    = L["tools-busy-responder-status-usage"],
                     get      = function() return ConvergeFu.db.profile.responderStatus end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.responderStatus = newValue
                                   ConvergeFu:BusyResponderStatusUpdated()
                                end,
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },
                  header2 = {
                     name  = " ",
                     desc  = "",
                     type  = 'header',
                     order = 18,
                  },
                  header3 = {
                     name  = L["tools-busy-responder-inclusions-header"],
                     desc  = "",
                     type  = 'header',
                     order = 19,
                  },                  
                  guild = {
                     name     = L["tools-busy-responder-guild-title"],
                     desc     = L["tools-busy-responder-guild-descr"],
                     type     = 'text',
                     order    = 20,
                     usage    = L["tools-busy-responder-guild-usage"],
                     get      = function() return ConvergeFu.db.profile.responderGuild end,
                     set      = function(newValue) 
                                   ConvergeFu.db.profile.responderGuild = newValue
                                   ConvergeFu:BusyResponderExclusionsUpdated()
                                end,                              
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },
                  officer = {
                     name     = L["tools-busy-responder-officer-title"],
                     desc     = L["tools-busy-responder-officer-descr"],
                     type     = 'text',
                     order    = 30,
                     usage    = L["tools-busy-responder-officer-usage"],
                     get      = function() return ConvergeFu.db.profile.responderOfficer end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.responderOfficer = newValue
                                   ConvergeFu:BusyResponderExclusionsUpdated()
                                end,                              
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },  
                  party = {
                     name     = L["tools-busy-responder-party-title"],
                     desc     = L["tools-busy-responder-party-descr"],
                     type     = 'text',
                     order    = 40,
                     usage    = L["tools-busy-responder-party-usage"],
                     get      = function() return ConvergeFu.db.profile.responderParty end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.responderParty = newValue
                                   ConvergeFu:BusyResponderExclusionsUpdated()
                                end,                              
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },  
                  raid = {
                     name     = L["tools-busy-responder-raid-title"],
                     desc     = L["tools-busy-responder-raid-descr"],
                     type     = 'text',
                     order    = 50,
                     usage    = L["tools-busy-responder-raid-usage"],
                     get      = function() return ConvergeFu.db.profile.responderRaid end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.responderRaid = newValue
                                   ConvergeFu:BusyResponderExclusionsUpdated()
                                end,                              
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },
                  friend = {
                     name     = L["tools-busy-responder-friend-title"],
                     desc     = L["tools-busy-responder-friend-descr"],
                     type     = 'text',
                     order    = 60,
                     usage    = L["tools-busy-responder-friend-usage"],
                     get      = function() return ConvergeFu.db.profile.responderFriend end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.responderFriend = newValue
                                   ConvergeFu:BusyResponderExclusionsUpdated()
                                end,                              
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },
                  header4 = {
                     name  = " ",
                     desc  = "",
                     type  = 'header',
                     order = 68,
                  },
                  header5 = {
                     name  = L["tools-busy-responder-message-header"],
                     desc  = "",
                     type  = 'header',
                     order = 69,
                  },                  
                  message = {
                     name  = L["tools-busy-responder-message-title"],
                     desc  = L["tools-busy-responder-message-descr"],
                     type  = 'text',
                     order    = 70,
                     usage = L["tools-busy-responder-message-usage"],
                     get   = function() return ConvergeFu.db.profile.responderMessage end,
                     set   = function(newValue)
                                ConvergeFu.db.profile.responderMessage = newValue
                                ConvergeFu:BusyResponderMessageUpdated()
                             end,                  
                  },
                  message_presets = {
                     name = L["tools-busy-responder-msg-presets-title"],
                     desc = L["tools-busy-responder-msg-presets-descr"],
                     type = 'group',
                     order    = 80,
                     args = {
                        header1 = {
                           name  = L["tools-busy-responder-msg-presets-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },                     
                        msg_preset_standard = {
                           name = L["tools-busy-responder-msg-std-title"],
                           desc = L["tools-busy-responder-msg-std-descr"],
                           type = 'execute',
                           func = function()
                              ConvergeFu.db.profile.responderMessage = L["tools-busy-responder-message-stdrd"]
                              ConvergeFu:BusyResponderMessageUpdated()
                           end
                        },
                        msg_preset_coffee = {
                           name = L["tools-busy-responder-msg-coffee-title"],
                           desc = L["tools-busy-responder-msg-coffee-descr"],
                           type = 'execute',
                           func = function()
                              ConvergeFu.db.profile.responderMessage = L["tools-busy-responder-msg-coffee-text"]
                              ConvergeFu:BusyResponderMessageUpdated()
                           end
                        },
                        msg_preset_raiding = {
                           name = L["tools-busy-responder-msg-raiding-title"],
                           desc = L["tools-busy-responder-msg-raiding-descr"],
                           type = 'execute',
                           func = function()
                              ConvergeFu.db.profile.responderMessage = L["tools-busy-responder-msg-raiding-text"]
                              ConvergeFu:BusyResponderMessageUpdated()
                           end
                        },
                        msg_preset_admin = {
                           name = L["tools-busy-responder-msg-admin-title"],
                           desc = L["tools-busy-responder-msg-admin-descr"],
                           type = 'execute',
                           func = function()
                              ConvergeFu.db.profile.responderMessage = L["tools-busy-responder-msg-admin-text"]
                              ConvergeFu:BusyResponderMessageUpdated()
                           end
                        }                       
                     }
                  },
                  header6 = {
                     name  = " ",
                     desc  = "",
                     type  = 'header',
                     order = 88,
                  },
                  header7 = {
                     name  = L["tools-busy-responder-config-header"],
                     desc  = "",
                     type  = 'header',
                     order = 89,
                  },                  
                  test = {
                     name  = L["tools-busy-responder-test-title"],
                     desc  = L["tools-busy-responder-test-descr"],
                     type  = 'execute',
                     order = 90,
                     func  = function() 
                        local testMessage = L["tools-busy-responder-message-first"]..ConvergeFu.db.profile.responderMessage
                        local playerName  = UnitName("player")
                        ConvergeFu:SendMessage(testMessage, "WHISPER", " ", playerName)
                     end
                  },                  
                  reset = {
                     name  = L["tools-busy-responder-reset-title"],
                     desc  = L["tools-busy-responder-reset-descr"],
                     type  = 'execute',
                     order = 100,
                     func  = function() 
                        ConvergeFu.db.profile.responderMessage = L["tools-busy-responder-message-stdrd"]
                        ConvergeFu:BusyResponderMessageUpdated()
                     end
                  },
                  showstatus = {
                     name  = L["tools-busy-responder-show-title"],
                     desc  = L["tools-busy-responder-show-descr"],
                     type  = 'execute',
                     order = 110,
                     func  = function() 
                        ConvergeFu:BusyResponderShowStatus()
                     end
                  }                  
               }
            },
            version = {
               name  = L["tools-versioncheck-title"],
               desc  = L["tools-versioncheck-descr"],
               type  = 'group',
               order = 110,
               args  = {
                 header1 = {
                     name  = L["tools-versioncheck-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },               
                  run = {
                     name  = L["tools-versioncheck-run-title"],
                     desc  = L["tools-versioncheck-run-descr"],
                     type  = 'execute',
                     order = 10,
                     func  = function()
                        ConvergeFu:DoVersionCheck("GUILD")
                     end
                  },
                  missing = {
                     name  = L["tools-versioncheck-missing-title"],
                     desc  = L["tools-versioncheck-missing-descr"],
                     type  = 'execute',
                     order = 20,
                     func  = function()
                        ConvergeFu:ListVersionCheckGroupListUnset(ConvergeFu.db.profile.vcListUnsetChannel)
                     end
                  },
                  list_channel = {
                     name     = L["tools-versioncheck-listchannel-title"],
                     desc     = L["tools-versioncheck-listchannel-descr"],
                     type     = 'text',
                     order    = 30,
                     usage    = L["tools-versioncheck-listchannel-usage"],
                     get      = function() return ConvergeFu.db.profile.vcListUnsetChannel end,
                     set      = function(newValue) ConvergeFu.db.profile.vcListUnsetChannel = newValue end,                              
                     validate = {["CHAT"]="Chat",["GUILD"]="Guild", ["RAID"]="Raid", ["OFFICER"]="Officer"} 
                  },                  
                  display_chat = {
                     name     = L["tools-versioncheck-chat-title"],
                     desc     = L["tools-versioncheck-chat-descr"],
                     type     = 'text',
                     order    = 40,
                     usage    = L["tools-versioncheck-chat-usage"],
                     get      = function() return ConvergeFu.db.profile.versionDispChat end,
                     set      = function(newValue) ConvergeFu.db.profile.versionDispChat = newValue end,                              
                     validate = {[L["common-data-option-zero"]]=L["common-data-option-off"], [L["common-data-option-one"]]=L["common-data-option-on"]} 
                  },
                  display_window = {
                     name     = L["tools-versioncheck-win-title"],
                     desc     = L["tools-versioncheck-win-descr"],
                     type     = 'text',
                     order    = 50,
                     usage    = L["tools-versioncheck-win-usage"],
                     get      = function() return ConvergeFu.db.profile.versionDispWin end,
                     set      = function(newValue) ConvergeFu.db.profile.versionDispWin = newValue end,                              
                     validate = {[L["common-data-option-zero"]]=L["common-data-option-off"], [L["common-data-option-one"]]=L["common-data-option-on"]}
                  }
               }
            },            
            rank = {
               name  = L["tools-rank-title"],
               desc  = L["tools-rank-descr"],
               type  = 'group',
               order = 80,
               args  = {
                  header1 = {
                     name  = L["tools-rank-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },
                  officerlist = {
                     name  = L["tools-rank-officer-listall-title"],
                     desc  = L["tools-rank-officer-listall-descr"],
                     type = 'execute',
                     order = 10,
                     func = function()
                        ConvergeFu:ListAllOfficers("OFFICER")
                     end
                  },
                  herolist = {
                      name  = L["tools-rank-hero-listall-title"],
                      desc  = L["tools-rank-hero-listall-descr"],
                      type  = 'execute',
                      order = 20,
                      func  = function()
                         ConvergeFu:ListAllHeroes("OFFICER")
                      end
                  },
                  normallist = {
                     name  = L["tools-rank-normal-listall-title"],
                     desc  = L["tools-rank-normal-listall-descr"],
                     order = 30,
                     type  = 'execute',
                     func  = function()
                        ConvergeFu:ListAllNormals("OFFICER")
                     end
                  },
                  triallist = {
                     name = L["tools-rank-trial-listall-title"],
                     desc = L["tools-rank-trial-listall-descr"],
                     order = 40,
                     type  = 'execute',
                     func  = function()
                        ConvergeFu:ListAllTrials("OFFICER")
                     end
                  },
                  benchedlist = {
                     name = L["tools-rank-benched-listall-title"],
                     desc = L["tools-rank-benched-listall-descr"],
                     order = 50,
                     type  = 'execute',
                     func  = function()
                        ConvergeFu:ListAllBenched("OFFICER")
                     end
                  },
                  header2 = {
                     name  = " ",
                     desc  = "",
                     type  = 'header',
                     order = 58,
                  },
                  header3 = {
                     name  = L["tools-rank-hero-changes-header"],
                     desc  = "",
                     type  = 'header',
                     order = 59,
                  },
                  announceherochanges = {
                     name = L["tools-rank-hero-ann-changes-title"],
                     desc = L["tools-rank-hero-ann-changes-descr"],
                     order = 60,
                     type  = 'execute',
                     func  = function()
                        ConvergeFu:AnnounceRankChanges("GUILD")
                     end
                  }
               }
            },
            cc = {
               name  = L["tools-crowd-control-title"],
               desc  = L["tools-crowd-control-descr"],
               type  = 'group',
               order = 50,
               args  = {
                  header1  = {
                    name  = L["tools-crowd-control-header"],
                    desc  = "",
                    type  = 'header',
                    order = 9,
                  },
                  header2  = {
                    name  = " ",
                    desc  = "",
                    type  = 'header',
                    order = 88,
                  },
                  header3  = {
                    name  = L["tools-crowd-control-config-header"],
                    desc  = "",
                    type  = 'header',
                    order = 89,
                  },                  
                  announce = {
                    name  = L["tools-crowd-control-announce-title"],
                    desc  = L["tools-crowd-control-announce-descr"],
                    type  = 'execute',
                    order = 90,
                    func  = function()
                      ConvergeFu:AnnounceCrowdControlTargets(ConvergeFu.db.profile.ccChannel)
                    end
                  },
                  autoset = {
                    name  = L["tools-crowd-control-autoset-title"],
                    desc  = L["tools-crowd-control-autoset-descr"],
                    type  = 'execute',
                    order = 140,
                    func  = function()
                      ConvergeFu:AutoSetCCTypes()
                    end
                  },
                  broadcast = {
                    name  = L["tools-crowd-control-broadcast-title"],
                    desc  = L["tools-crowd-control-broadcast-descr"],
                    type  = 'execute',
                    order = 150,
                    func  = function()
                      ConvergeFu:DoBroadcastCCTargets("RAID")
                    end
                  },                  
                  channel = {
                    name     = L["tools-crowd-control-channel-title"],
                    desc     = L["tools-crowd-control-channel-descr"],
                    type     = 'text',
                    order    = 130,
                    usage    = L["tools-crowd-control-channel-usage"],
                    get      = function() return ConvergeFu.db.profile.ccChannel end,
                    set      = function(newValue) ConvergeFu.db.profile.ccChannel = newValue end,                              
                    validate = { ["RAID"] = "Raid", ["PARTY"] = "Party", ["OFFICER"] = "Officer", ["GUILD"] = "Guild", ["SAY"] = "Say", ["CHAT"] = "Chat"}
                  },
                  gui = {
                     name  = L["tools-crowd-control-gui-title"],
                     desc  = L["tools-crowd-control-gui-descr"],
                     type  = 'execute',
                     order = 120,
                     func  = function()
                        FuBar:OpenConfigMenu(self)
                     end
                  },
                  test = {
                     name  = L["tools-crowd-control-test-title"],
                     desc  = L["tools-crowd-control-test-descr"],
                     type  = 'execute',
                     order = 100,
                     func  = function()
                        ConvergeFu:AnnounceCrowdControlTargets("CHAT")
                     end
                  },                  
                  clearall = {
                    name  = L["tools-crowd-control-clearall-title"],
                    desc  = L["tools-crowd-control-clearall-descr"],
                    type  = 'execute',
                    order = 110,
                    func  = function()
                       ConvergeFu:ClearAllCCSettings()
                    end,
                  },
                  default = {
                     name  = L["tools-crowd-control-defaults-title"],
                     desc  = L["tools-crowd-control-defaults-descr"],
                     type  = 'group',
                     order = 160,
                     args  = {
                        header1  = {
                           name  = L["tools-crowd-control-defaults-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },                    
                        deathknight = {
                           name     = L["common-data-class-name-death-knight"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCDeathKnight end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCDeathKnight = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        druid = {
                           name     = L["common-data-class-name-druid"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCDruid end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCDruid = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        hunter = {
                           name     = L["common-data-class-name-hunter"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 30,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCHunter end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCHunter = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        mage = {
                           name     = L["common-data-class-name-mage"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 40,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCMage end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCMage = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        paladin = {
                           name     = L["common-data-class-name-paladin"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 50,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCPaladin end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCPaladin = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        priest = {
                           name     = L["common-data-class-name-priest"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 60,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCPriest end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCPriest = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        rogue = {
                           name     = L["common-data-class-name-rogue"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 70,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCRogue end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCRogue = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        shaman = {
                           name     = L["common-data-class-name-shaman"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 80,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCShaman end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCShaman = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        warlock = {
                           name     = L["common-data-class-name-warlock"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 90,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCWarlock end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCWarlock = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        warrior = {
                           name     = L["common-data-class-name-warrior"],
                           desc     = L["tools-crowd-control-defs-setcc-descr"],
                           type     = 'text',
                           order    = 100,
                           usage    = L["tools-crowd-control-defs-setcc-usage"],
                           get      = function() return ConvergeFu.db.profile.defaultCCWarrior end,
                           set      = function(newValue) ConvergeFu.db.profile.defaultCCWarrior = newValue end,
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        }                      
                     }
                  },
                  skull = {
                     name = L["tools-crowd-control-skull-title"],
                     desc = L["tools-crowd-control-skull-descr"],
                     type = 'group',
                     order = 10,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-skull-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },                      
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.skullName end,
                           set   = function(newValue) ConvergeFu.db.profile.skullName = newValue end,                            
                        },
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.skullType end,
                           set      = function(newValue) ConvergeFu.db.profile.skullType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.skullName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                        
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                              ConvergeFu.db.profile.skullType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.skullName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        } 
                     }
                  },
                  cross = {
                     name = L["tools-crowd-control-cross-title"],
                     desc = L["tools-crowd-control-cross-descr"],
                     type = 'group',
                     order = 20,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-cross-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.crossName end,
                           set   = function(newValue) ConvergeFu.db.profile.crossName = newValue end,                           
                        },
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.crossType end,
                           set      = function(newValue) ConvergeFu.db.profile.crossType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.crossName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                        
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                              ConvergeFu.db.profile.crossType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.crossName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  },
                  square = {
                     name = L["tools-crowd-control-square-title"],
                     desc = L["tools-crowd-control-square-descr"],
                     type = 'group',
                     order = 30,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-square-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order    = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.squareName end,
                           set   = function(newValue) ConvergeFu.db.profile.squareName = newValue end,                           
                        },
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.squareType end,
                           set      = function(newValue) ConvergeFu.db.profile.squareType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order    = 30,
                           func = function() 
                              ConvergeFu.db.profile.squareName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                        
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order    = 40,
                           func = function() 
                              ConvergeFu.db.profile.squareType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.squareName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  },
                  moon = {
                     name = L["tools-crowd-control-moon-title"],
                     desc = L["tools-crowd-control-moon-descr"],
                     type = 'group',
                     order = 40,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-moon-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.moonName end,
                           set   = function(newValue) ConvergeFu.db.profile.moonName = newValue end,                           
                        },                     
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.moonType end,
                           set      = function(newValue) ConvergeFu.db.profile.moonType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },

                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.moonName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                        
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                              ConvergeFu.db.profile.moonType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.moonName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  },
                  triangle = {
                     name = L["tools-crowd-control-triangle-title"],
                     desc = L["tools-crowd-control-triangle-descr"],
                     type = 'group',
                     order = 50,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-triangle-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.triangleName end,
                           set   = function(newValue) ConvergeFu.db.profile.triangleName = newValue end,                           
                        },                     
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.triangleType end,
                           set      = function(newValue) ConvergeFu.db.profile.triangleType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },

                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.triangleName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                         
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order    = 10,
                           func = function() 
                              ConvergeFu.db.profile.triangleType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.triangleName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  },
                  diamond = {
                     name = L["tools-crowd-control-diamond-title"],
                     desc = L["tools-crowd-control-diamond-descr"],
                     type = 'group',
                     order = 60,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-diamond-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.diamondName end,
                           set   = function(newValue) ConvergeFu.db.profile.diamondName = newValue end,                           
                        },                     
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.diamondType end,
                           set      = function(newValue) ConvergeFu.db.profile.diamondType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.diamondName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                         
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                             ConvergeFu.db.profile.diamondType = L["tools-crowd-control-common-clear-type-default"]
                             ConvergeFu.db.profile.diamondName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  },
                  circle = {
                     name = L["tools-crowd-control-circle-title"],
                     desc = L["tools-crowd-control-circle-descr"],
                     type = 'group',
                     order = 70,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-circle-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.circleName end,
                           set   = function(newValue) ConvergeFu.db.profile.circleName = newValue end,                           
                        },                     
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.circleType end,
                           set      = function(newValue) ConvergeFu.db.profile.circleType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        mytarget = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.circleName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                         
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                              ConvergeFu.db.profile.circleType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.circleName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  },
                  star = {
                     name = L["tools-crowd-control-star-title"],
                     desc = L["tools-crowd-control-star-descr"],
                     type = 'group',
                     order = 80,
                     args = {
                        header1  = {
                           name  = L["tools-crowd-control-star-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        name = {
                           name  = L["tools-crowd-control-common-name-title"],
                           desc  = L["tools-crowd-control-common-name-descr"],
                           type  = 'text',
                           order = 10,
                           usage = L["tools-crowd-control-common-name-usage"],
                           get   = function() return ConvergeFu.db.profile.starName end,
                           set   = function(newValue) ConvergeFu.db.profile.starName = newValue end,                           
                        },                     
                        type = {
                           name     = L["tools-crowd-control-common-type-title"],
                           desc     = L["tools-crowd-control-common-type-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-crowd-control-common-type-usage"],
                           get      = function() return ConvergeFu.db.profile.starType end,
                           set      = function(newValue) ConvergeFu.db.profile.starType = newValue end,                              
                           validate = {"None", "Default", "Tank", "MT", "OT", "Sheep", "Banish", "Fear", "Seduce", "Enslave", "Shackle", "Mind Control", "Hibernate", "Root", "Cyclone", "Trap", "Kite", "Sap", "Hex", "Turn Evil"}
                        },
                        target = {
                           name  = L["tools-crowd-control-common-take-title"],
                           desc  = L["tools-crowd-control-common-take-descr"],
                           type  = 'execute',
                           order = 30,
                           func  = function() 
                              ConvergeFu.db.profile.starName = ConvergeFu:CCTakeMyTarget()
                           end
                        },                         
                        clear = {
                           name  = L["tools-crowd-control-common-clear-title"],
                           desc  = L["tools-crowd-control-common-clear-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function() 
                              ConvergeFu.db.profile.starType = L["tools-crowd-control-common-clear-type-default"]
                              ConvergeFu.db.profile.starName = L["tools-crowd-control-common-clear-name-default"]
                           end
                        }                          
                     }
                  }                                                                  
               }
            },
            search = {
               name  = L["tools-searchtarget-title"],
               desc  = L["tools-searchtarget-descr"],
               type  = 'group',
               order = 40,
               args  = {
                  header1  = {
                     name  = L["tools-searchtarget-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },
                  set = {
                     name  = L["tools-searchtarget-set-title"],
                     desc  = L["tools-searchtarget-set-descr"],
                     type  = 'text',
                     order = 10,
                     usage = L["tools-searchtarget-set-usage"],
                     get   = function() return ConvergeFu.db.profile.searchTarget end,
                     set   = function(newValue) ConvergeFu.db.profile.searchTarget = ConvergeFu:CaseCorrectedNameString(newValue) end,
                  },
                  findall = {
                     name  = L["tools-searchtarget-findall-title"],
                     desc  = L["tools-searchtarget-findall-descr"],
                     type  = 'execute',
                     order = 20,
                     func  = function()
                        ConvergeFu:ListAssociatedCharacters(ConvergeFu.db.profile.searchTarget,"Officer");
                     end
                  },
                  findonline = {
                     name  = L["tools-searchtarget-findonline-title"],
                     desc  = L["tools-searchtarget-findonline-descr"],
                     type  = 'execute',
                     order = 30,
                     func  = function()
                        ConvergeFu:SendChatMessage(ConvergeFu:FindPlayerByCharacterName(ConvergeFu.db.profile.searchTarget), "Officer")
                     end
                  }
               }
            },
            rcp = {
               name  = L["tools-rcp-title"],
               desc  = L["tools-rcp-descr"],
               type  = 'group',
               order = 100,
               args  = {
                  header1  = {
                     name  = L["tools-rcp-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },
                  moviemaker = {
                     name  = L["tools-rcp-moviemaker-title"],
                     desc  = L["tools-rcp-moviemaker-descr"],
                     type  = 'group',
                     order = 10,
                     args  = {
                        header1  = {
                           name  = L["tools-rcp-moviemaker-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },                     
                        say = {
                           name  = L["tools-rcp-mm-say-title"],
                           desc  = L["tools-rcp-mm-say-descr"],
                           type  = 'group',
                           order = 10,
                           args  = {
                              header1  = {
                                 name  = L["tools-rcp-mm-say-header"],
                                 desc  = "",
                                 type  = 'header',
                                 order = 09,
                              },
                              allhail = {
                                 name  = L["ann-say-allhailtothe-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 10,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-allhailtothe-msg"]..ConvergeFu:MyTargetOrMeOtherwise().."!", "RAID")
                                 end
                              },
                              byyourcommand = {
                                 name  = L["ann-say-byyourcommand-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 20,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-byyourcommand-msg"], "RAID")
                                 end
                              },
                              crazyivan = {
                                 name  = L["ann-say-crazyivan-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 30,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-crazyivan-msg"], "RAID")
                                 end
                              },
                              doyouunderstand = {
                                 name  = L["ann-say-doyouunderstand-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 40,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-doyouunderstand-msg"], "RAID")
                                 end
                              },
                              eeek = {
                                 name  = L["ann-say-eeek-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 50,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-eeek-msg"], "RAID")
                                 end
                              },
                              evasion = {
                                 name  = L["ann-say-evasion-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 60,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-evasion-msg"], "RAID")
                                 end
                              },
                              fireball = {
                                 name  = L["ann-say-fireball-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 70,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-fireball-msg"], "RAID")
                                 end
                              },
                             forconverge = {
                                 name  = L["ann-say-forconverge-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 80,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-forconverge-msg"], "RAID")
                                 end
                              },
                              gameoverman = {
                                 name  = L["ann-say-gameoverman-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 90,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-gameoverman-msg"], "RAID")
                                 end
                              },
                              granny = {
                                 name  = L["ann-say-granny-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 100,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-granny-msg"], "RAID")
                                 end
                              },
                             itscomingrightforus = {
                                 name  = L["ann-say-itscomingrightforus-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 110,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-itscomingrightforus-msg"], "RAID")
                                 end
                              },
                             mine = {
                                 name  = L["ann-say-mine-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 120,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-mine-msg"], "RAID")
                                 end
                              },
                              nerfhunters = {
                                 name  = L["ann-say-nerfhunters-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 130,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-nerfhunters-msg"], "RAID")
                                 end
                              },
                              pusspuss = {
                                 name  = L["ann-say-pusspuss-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 135,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-pusspuss-msg"], "RAID")
                                 end
                              },
                              rawr = {
                                 name  = L["ann-say-rawr-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 140,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-rawr-msg"], "RAID")
                                 end
                              },
                              retdps = {
                                 name  = L["ann-say-retdps-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 150,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-retdps-msg"], "RAID")
                                 end
                              },
                              siryessir = {
                                 name  = L["ann-say-siryessir-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 160,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-siryessir-msg"], "RAID")
                                 end
                              }, 
                              thisismyrifle = {
                                 name  = L["ann-say-thisismyrifle-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 170,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-thisismyrifle-msg"], "RAID")
                                 end
                              },
                              threat = {
                                 name  = L["ann-say-threat-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 180,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-threat-msg"], "RAID")
                                 end
                              },

                              usemagic = {
                                 name  = L["ann-say-usemagic-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 190,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-usemagic-msg"], "RAID")
                                 end
                              },
                              wolfish = {
                                 name  = L["ann-say-wolfish-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 200,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-wolfish-msg"], "RAID")
                                 end
                              },
                              zzzz = {
                                 name  = L["ann-say-zzzz-title"],
                                 desc  = L["tools-rcp-mm-say-descr"],
                                 type  = 'execute',
                                 order = 210,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-zzzz-msg"], "RAID")
                                 end
                              }
                           }
                        },
                        doit = {
                           name  = L["tools-rcp-mm-do-title"],
                           desc  = L["tools-rcp-mm-do-descr"],
                           type  = 'group',
                           order = 20,
                           args  = {
                              header1  = {
                                 name  = L["tools-rcp-mm-do-header"],
                                 desc  = "",
                                 type  = 'header',
                                 order = 09,
                              },
                              cheer = {
                                 name  = L["tools-rcp-mm-do-cheer-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 10,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-cheer-cmd"], "RAID")
                                 end
                              },
                              cower = {
                                 name  = L["tools-rcp-mm-do-cower-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 20,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-cower-cmd"], "RAID")
                                 end
                              },
                              flex = {
                                 name  = L["tools-rcp-mm-do-flex-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 30,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-flex-cmd"], "RAID")
                                 end
                              },
                              kneel = {
                                 name  = L["tools-rcp-mm-do-kneel-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 40,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-kneel-cmd"], "RAID")
                                 end
                              },
                              point = {
                                 name  = L["tools-rcp-mm-do-point-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 60,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-point-cmd"], "RAID")
                                 end
                              },
                              roar = {
                                 name  = L["tools-rcp-mm-do-roar-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 70,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-roar-cmd"], "RAID")
                                 end
                              },
                              salute = {
                                 name  = L["tools-rcp-mm-do-salute-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 80,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-salute-cmd"], "RAID")
                                 end
                              },
                              sleep = {
                                 name  = L["tools-rcp-mm-do-sleep-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 90,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-sleep-cmd"], "RAID")
                                 end
                              },
                              wave = {
                                 name  = L["tools-rcp-mm-do-wave-title"],
                                 desc  = L["tools-rcp-mm-do-descr"],
                                 type  = 'execute',
                                 order = 100,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-wave-cmd"], "RAID")
                                 end
                              }
                           }
                        },
                        sayanddo = {
                           name  = L["tools-rcp-mm-sayanddo-title"],
                           desc  = L["tools-rcp-mm-sayanddo-descr"],
                           type  = 'group',
                           order = 30,
                           args  = {
                              header1  = {
                                 name  = L["tools-rcp-mm-sayanddo-header"],
                                 desc  = "",
                                 type  = 'header',
                                 order = 09,
                              },                           
                              afraid = {
                                 name  = L["tools-rcp-mm-sayanddo-afraid-title"],
                                 desc  = L["tools-rcp-mm-sayanddo-descr"],
                                 type  = 'execute',
                                 order = 10,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-eeek-msg"], "RAID")
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-cower-cmd"], "RAID")
                                 end
                              },
                              brave = {
                                 name  = L["tools-rcp-mm-sayanddo-brave-title"],
                                 desc  = L["tools-rcp-mm-sayanddo-descr"],
                                 type  = 'execute',
                                 order = 20,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-rawr-msg"], "RAID")
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-roar-cmd"], "RAID")
                                 end
                              },
                              commanded = {
                                 name  = L["tools-rcp-mm-sayanddo-commanded-title"],
                                 desc  = L["tools-rcp-mm-sayanddo-descr"],
                                 type  = 'execute',
                                 order = 30,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-siryessir-msg"], "RAID")
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-salute-cmd"], "RAID")
                                 end
                              },                              
                              subservient = {
                                 name  = L["tools-rcp-mm-sayanddo-subservient-title"],
                                 desc  = L["tools-rcp-mm-sayanddo-descr"],
                                 type  = 'execute',
                                 order = 40,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-byyourcommand-msg"], "RAID")
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-kneel-cmd"], "RAID")
                                 end
                              },
                              sleepy = {
                                 name  = L["tools-rcp-mm-sayanddo-sleepy-title"],
                                 desc  = L["tools-rcp-mm-sayanddo-descr"],
                                 type  = 'execute',
                                 order = 50,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-zzzz-msg"], "RAID")
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-sleep-cmd"], "RAID")
                                 end
                              },
                              victorious = {
                                 name  = L["tools-rcp-mm-sayanddo-victorious-title"],
                                 desc  = L["tools-rcp-mm-sayanddo-descr"],
                                 type  = 'execute',
                                 order = 50,
                                 func  = function()
                                    ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                                    print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))                                 
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-say"].."@@@"..L["ann-say-forconverge-msg"], "RAID")
                                    ConvergeFu:SendRCPMessage(L["event-rcp-mm-do"].."@@@"..L["tools-rcp-mm-do-cheer-cmd"], "RAID")
                                 end
                              }
                           }
                        }
                     }
                  },
                  config = {
                     name  = L["tools-rcp-config-title"],
                     desc  = L["tools-rcp-config-descr"],
                     type  = 'group',
                     order = 20,
                     args  = {
                        header1  = {
                           name  = L["tools-rcp-ffa-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },                     
                        ffa_on = {
                           name  = L["tools-rcp-ffa-on-title"],
                           desc  = L["tools-rcp-ffa-on-descr"],
                           type  = 'execute',
                           order = 10,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ffa-on"], "RAID")
                           end
                        },
                        ffa_off = {
                           name = L["tools-rcp-ffa-off-title"],
                           desc = L["tools-rcp-ffa-off-descr"],
                           type = 'execute',
                           order = 20,
                           func = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ffa-off"], "RAID")
                           end
                        },
                        ffa_reset = {
                           name = L["tools-rcp-ffa-reset-title"],
                           desc = L["tools-rcp-ffa-reset-descr"],
                           type = 'execute',
                           order = 30,
                           func = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ffa-reset"], "RAID")
                           end
                        },
                        header2  = {
                           name  = " ",
                           desc  = "",
                           type  = 'header',
                           order = 38,
                        },
                        header3  = {
                           name  = L["tools-rcp-bmcm-header"],
                           desc  = "",
                           type  = 'header',
                           order = 39,
                        },                        
                        bmcm_on = {
                           name  = L["tools-rcp-bmcm-on-title"],
                           desc  = L["tools-rcp-bmcm-on-descr"],
                           type  = 'execute',
                           order = 40,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-bmcm-on"], "RAID")
                           end
                        },
                        bmcm_off = {
                           name  = L["tools-rcp-bmcm-off-title"],
                           desc  = L["tools-rcp-bmcm-off-descr"],
                           type  = 'execute',
                           order = 50,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-bmcm-off"], "RAID")
                           end
                        },
                        header5  = {
                           name  = " ",
                           desc  = "",
                           type  = 'header',
                           order = 58,
                        },
                        header6  = {
                           name  = L["tools-rcp-ria-header"],
                           desc  = "",
                           type  = 'header',
                           order = 59,
                        },                        
                        ria_showing_on = {
                           name  = L["tools-rcp-ria-showing-on-title"],
                           desc  = L["tools-rcp-ria-showing-on-descr"],
                           type  = 'execute',
                           order = 60,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ria-showing-on"], "RAID")
                           end
                        },
                        ria_showing_off = {
                           name  = L["tools-rcp-ria-showing-off-title"],
                           desc  = L["tools-rcp-ria-showing-off-descr"],
                           type  = 'execute',
                           order = 70,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ria-showing-off"], "RAID")
                           end
                        },                      
                        ria_sending_on = {
                           name  = L["tools-rcp-ria-sending-on-title"],
                           desc  = L["tools-rcp-ria-sending-on-descr"],
                           type  = 'execute',
                           order = 80,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ria-sending-on"], "RAID")
                           end
                        },
                        ria_sending_off = {
                           name  = L["tools-rcp-ria-sending-off-title"],
                           desc  = L["tools-rcp-ria-sending-off-descr"],
                           type  = 'execute',
                           order = 90,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-ria-sending-off"], "RAID")
                           end
                        },
                        header7  = {
                           name  = " ",
                           desc  = "",
                           type  = 'header',
                           order = 98,
                        },
                        header8  = {
                           name  = L["tools-rcp-rqa-header"],
                           desc  = "",
                           type  = 'header',
                           order = 99,
                        },                        
                        rqa_showing_on = {
                           name  = L["tools-rcp-rqa-showing-on-title"],
                           desc  = L["tools-rcp-rqa-showing-on-descr"],
                           type  = 'execute',
                           order = 100,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-rqa-showing-on"], "RAID")
                           end
                        },
                        rqa_showing_off = {
                           name  = L["tools-rcp-rqa-showing-off-title"],
                           desc  = L["tools-rcp-rqa-showing-off-descr"],
                           type  = 'execute',
                           order = 110,
                           func  = function()
                              ConvergeFu:SendRCPMessage(L["event-rcp-rqa-showing-off"], "RAID")
                           end
                        },
                        header9  = {
                           name  = " ",
                           desc  = "",
                           type  = 'header',
                           order = 118,
                        },
                        header10  = {
                           name  = L["tools-rcp-config-header"],
                           desc  = "",
                           type  = 'header',
                           order = 119,
                        },                        
                        target = {
                           name  = L["tools-rcp-target-player-title"],
                           desc  = L["tools-rcp-target-player-descr"],
                           type  = 'text',
                           order = 120,
                           usage = L["tools-rcp-target-player-usage"],
                           get   = function() return ConvergeFu.db.profile.rcpTarget end,
                           set   = function(newValue)
                              ConvergeFu.db.profile.rcpTarget = newValue
                              print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                              print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(newValue))
                           end                      
                        },
                        targetall = {
                           name  = L["tools-rcp-target-all-title"],
                           desc  = L["tools-rcp-target-all-descr"],
                           type  = 'execute',
                           order = 130,
                           usage = L["tools-rcp-target-all-usage"],
                           func  = function()
                              ConvergeFu.db.profile.rcpTarget = L["tools-rcp-target-all-keyword"]
                              print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])..ConvergeFu:ColourTextWhite(L["tools-rcp-msg-target-updated"]))
                              print(ConvergeFu:ColourTextPurple(L["tools-rcp-msg-target-isnow"])..ConvergeFu:ColourTextGreen(L["tools-rcp-target-all-keyword"]))
                           end
                        }                  
                     }
                  }
               }
            },
            buffmonitor = {
               name  = L["tools-buffmonitor-title"],
               desc  = L["tools-buffmonitor-descr"],
               type  = 'group',
               order = 20,
               args  = {
                  header1 = {
                    name  = L["tools-bm-header-reports"],
                    type  = "header",
                    order = 9,
                  },
                  checkraiders = {
                     name  = L["tools-bm-consumables-missing-raid-title"],
                     desc  = L["tools-bm-consumables-missing-raid-descr"],
                     type  = 'execute',
                     order = 10,
                     func  = function()
                        ConvergeFu:ListRaidersWithMissingConsumables(ConvergeFu.db.profile.bmOutputChannel)
                     end
                  },
                  checkme = {
                     name  = L["tools-bm-consumables-missing-me-title"],
                     desc  = L["tools-bm-consumables-missing-me-descr"],
                     type  = 'execute',
                     order = 20,
                     func  = function()
                        ConvergeFu:CheckMyBuffs(L["tools-bm-checkmybuffs-msg-viamenu"])
                     end
                  },                  
                  header2 = {
                    name  = " ",
                    type  = "header",
                    order = 28,
                  },
                  header3 = {
                    name  = L["tools-bm-header-quick-profiles"],
                    type  = "header",
                    order = 29,
                  },
                  modeboss = {
                     name  = L["tools-bm-profile-bossmode-title"],
                     desc  = L["tools-bm-profile-bossmode-descr"],
                     type  = 'execute',
                     order = 30,
                     func  = function()
                        ConvergeFu:ConfigureBuffMonitorBossMode()
                     end
                  },
                  modetrash = {
                     name  = L["tools-bm-profile-trashmode-title"],
                     desc  = L["tools-bm-profile-trashmode-descr"],
                     type  = 'execute',
                     order = 40,
                     func  = function()
                        ConvergeFu:ConfigureBuffMonitorTrashMode()
                     end
                  },
                  header4 = {
                    name  = " ",
                    type  = "header",
                    order = 48,
                  },
                  header5 = {
                    name  = L["tools-bm-header-config-options"],
                    type  = "header",
                    order = 49,
                  },                  
                  showstatus = {
                     name  = L["tools-bm-show-status-title"],
                     desc  = L["tools-bm-show-status-descr"],
                     type  = 'execute',
                     order = 50,
                     func  = function()
                        ConvergeFu:ShowBuffMonitorStatus(true, true, true, true)
                     end
                  },                  
                  notify = {
                     name     = L["tools-bm-notify-status-title"],
                     desc     = L["tools-bm-notify-status-descr"],
                     type     = 'text',
                     order    = 60,
                     usage    = L["tools-bm-notify-status-usage"],
                     get      = function() return ConvergeFu.db.profile.bmNotifyStatus end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.bmNotifyStatus = newValue
                                   ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                   ConvergeFu:ShowBuffMonitorStatus(false, true, false, false)
                                end,                              
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },
                  cm = {
                     name  = L["tools-bm-combat-monitor-title"],
                     desc  = L["tools-bm-combat-monitor-descr"],
                     type  = 'group',
                     order = 70,
                     args  = {
                        header1 = {
                           name  = L["tools-bm-header-combat-monitor-options"],
                           type  = "header",
                           order = 9,
                        },                       
                        status = {
                           name     = L["tools-bm-cm-global-status-title"],
                           desc     = L["tools-bm-cm-global-status-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-bm-cm-global-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmCMGlobalStatus end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmCMGlobalStatus = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(true, false, false, false)
                                      end,                              
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}                           
                        },
                        onenter = {
                           name     = L["tools-bm-cm-enter-status-title"],
                           desc     = L["tools-bm-cm-enter-status-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-bm-cm-enter-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmCMEnterStatus end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmCMEnterStatus = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(true, false, false, false)
                                      end,                              
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}                           
                        },
                        onexit = {
                           name     = L["tools-bm-cm-exit-status-title"],
                           desc     = L["tools-bm-cm-exit-status-descr"],
                           type     = 'text',
                           order    = 30,
                           usage    = L["tools-bm-cm-exit-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmCMExitStatus end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmCMExitStatus = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(true, false, false, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}                           
                        }
                     }
                  },
                  report_config = {
                     name  = L["tools-bm-report-config-title"],
                     desc  = L["tools-bm-report-config-descr"],
                     type  = 'group',
                     order = 80,
                     args  = {
                        header1 = {
                           name  = L["tools-bm-header-reporting-options"],
                           type  = "header",
                           order = 9,
                        },                      
                        flasks = {
                           name     = L["tools-bm-report-flasks-status-title"],
                           desc     = L["tools-bm-report-flasks-status-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-bm-report-flasks-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportFlasks end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportFlasks = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        elixirs = {
                           name     = L["tools-bm-report-elixirs-status-title"],
                           desc     = L["tools-bm-report-elixirs-status-descr"],
                           type     = 'text',
                           order    = 20,
                           usage    = L["tools-bm-report-elixirs-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportElixirs end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportElixirs = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        food = {
                           name     = L["tools-bm-report-food-status-title"],
                           desc     = L["tools-bm-report-food-status-descr"],
                           type     = 'text',
                           order    = 30,
                           usage    = L["tools-bm-report-food-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportFood end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportFood = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        roguepoisons = {
                           name     = L["tools-bm-report-roguepoisons-status-title"],
                           desc     = L["tools-bm-report-roguepoisons-status-descr"],
                           type     = 'text',
                           order    = 40,
                           usage    = L["tools-bm-report-roguepoisons-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportRoguePoisons end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportRoguePoisons = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        expiry = {
                           name     = L["tools-bm-report-expiry-status-title"],
                           desc     = L["tools-bm-report-expiry-status-descr"],
                           type     = 'text',
                           order    = 50,
                           usage    = L["tools-bm-report-expiry-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportExpiry end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportExpiry = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        expirytime = {
                           name      = L["tools-bm-report-expiry-time-title"],
                           desc      = L["tools-bm-report-expiry-time-descr"],
                           type      = 'range',
                           order     = 60,
                           usage     = L["tools-bm-report-expiry-time-usage"],
                           get       = function() return ConvergeFu.db.profile.bmExpiryTimeMinutes end,
                           set       = function(newValue) ConvergeFu.db.profile.bmExpiryTimeMinutes = newValue end,
                           min       = 1,
                           max       = 30,
                           step      = 1,
                           isPercent = false
                        },
                        dead = {
                           name     = L["tools-bm-report-dead-status-title"],
                           desc     = L["tools-bm-report-dead-status-descr"],
                           type     = 'text',
                           order    = 70,
                           usage    = L["tools-bm-report-dead-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportDead end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportDead = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        offline = {
                           name     = L["tools-bm-report-offline-status-title"],
                           desc     = L["tools-bm-report-offline-status-descr"],
                           type     = 'text',
                           order    = 80,
                           usage    = L["tools-bm-report-offline-status-usage"],
                           get      = function() return ConvergeFu.db.profile.bmReportOffline end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.bmReportOffline = newValue
                                         ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                         ConvergeFu:ShowBuffMonitorStatus(false, false, true, false)
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}                           
                        }
                     }
                  },
                  post_readycheck_report = {
                     name     = L["tools-bm-report-post-readycheck-title"],
                     desc     = L["tools-bm-report-post-readycheck-descr"],
                     type     = 'text',
                     order    = 90,
                     usage    = L["tools-bm-report-post-readycheck-usage"],
                     get      = function() return ConvergeFu.db.profile.bmRunPostRCReport end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.bmRunPostRCReport = newValue
                                end,
                     validate = {L["common-data-option-on"], L["common-data-option-off"]}
                  },
                  output_channel = {
                     name     = L["tools-bm-output-channel-title"],
                     desc     = L["tools-bm-output-channel-descr"],
                     type     = 'text',
                     order    = 100,
                     usage    = L["tools-bm-output-channel-usage"],
                     get      = function() return ConvergeFu.db.profile.bmOutputChannel end,
                     set      = function(newValue)
                                   ConvergeFu.db.profile.bmOutputChannel = newValue
                                   ConvergeFu.db.profile.bmCurrentProfile = L["tools-bm-current-profile-custom"]
                                   ConvergeFu:ShowBuffMonitorStatus(false, false, false, true)
                                end,
                     validate = {["CHAT"]="Chat",["GUILD"]="Guild", ["RAID"]="Raid", ["OFFICER"]="Officer"}
                  }
               }
            },
            misc = {
               name  = L["tools-misc-title"],
               desc  = L["tools-misc-descr"],
               type  = 'group',
               order = 70,
               args  = {
                  header1  = {
                     name  = L["tools-misc-header"],
                     desc  = "",
                     type  = 'header',
                     order = 09,
                  },
                  fishfeastannouncer = {
                     name  = L["tools-fish-feast-title"],
                     desc  = L["tools-fish-feast-descr"],
                     type  = 'group',
                     order = 10,
                     args  = {
                        header1  = {
                           name  = L["tools-fish-feast-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        fishfeastenabled = {
                           name     = L["tools-fish-feast-status-title"],
                           desc     = L["tools-fish-feast-status-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-fish-feast-status-usage"],
                           get      = function() return ConvergeFu.db.profile.fishFeastStatus end,
                           set      = function(newValue)
                                       ConvergeFu.db.profile.fishFeastStatus = newValue
                                       ConvergeFu:FishFeastAnnouncementsUpdated()
                                    end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        fishfeasttext = {
                           name  = L["tools-fish-feast-text-title"],
                           desc  = L["tools-fish-feast-text-descr"],
                           type  = 'text',
                           order = 20,
                           usage = L["tools-fish-feast-text-usage"],
                           get   = function() return ConvergeFu.db.profile.fishFeastText end,
                           set   = function(newValue)
                                      ConvergeFu.db.profile.fishFeastText = newValue
                                      ConvergeFu:FishFeastAnnouncementsUpdated()
                                   end,                  
                        },
                        fishfeastpresettext = {
                           name    = L["tools-fish-feast-preset-text-title"],
                           desc    = L["tools-fish-feast-preset-text-descr"],
                           type    = 'text',
                           order   = 30,
                           usage   = L["tools-fish-feast-preset-text-usage"],
                           get     = function() return ConvergeFu.db.profile.fishFeastText end,
                           set     = function(newValue)
                                        ConvergeFu.db.profile.fishFeastText = newValue
                                        ConvergeFu:FishFeastAnnouncementsUpdated()
                                     end, 
                          validate = {
                                        [L["tools-fish-feast-preset-descr-order"]]    = L["tools-fish-feast-preset-title-order"],
                                        [L["tools-fish-feast-preset-descr-miream"]]   = L["tools-fish-feast-preset-title-miream"],
                                        [L["tools-fish-feast-preset-descr-puns"]]     = L["tools-fish-feast-preset-title-puns"],
                                        [L["tools-fish-feast-preset-descr-sarajevo"]] = L["tools-fish-feast-preset-title-sarajevo"]
                                     }
                        },                        
                        fishfeastmatch = {
                           name  = L["tools-fish-feast-match-title"],
                           desc  = L["tools-fish-feast-match-descr"],
                           type  = 'text',
                           order = 40,
                           usage = L["tools-fish-feast-match-usage"],
                           get   = function() return ConvergeFu.db.profile.fishFeastMatch end,
                           set   = function(newValue)
                                      ConvergeFu.db.profile.fishFeastMatch = newValue
                                      ConvergeFu:FishFeastAnnouncementsUpdated()
                                   end,                  
                        },
                        fishfeastchannel = {
                           name     = L["tools-fish-feast-channel-title"],
                           desc     = L["tools-fish-feast-channel-descr"],
                           type     = 'text',
                           order    = 50,
                           usage    = L["tools-fish-feast-channel-usage"],
                           get      = function() return ConvergeFu.db.profile.fishFeastChannel end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.fishFeastChannel = newValue
                                         ConvergeFu:FishFeastAnnouncementsUpdated()
                                      end,
                           validate = { ["RAID"] = "1 - Raid", ["RAID_WARNING"] = "2 - Raid Warning", ["BOTH"] = "3 - Raid + Raid Warning" }
                        },
                        fishfeastreset = {
                           name  = L["tools-fish-feast-reset-title"],
                           desc  = L["tools-fish-feast-reset-descr"],
                           type  = 'execute',
                           order = 60,
                           func  = function()
                              ConvergeFu.db.profile.fishFeastText   = L["event-chat-msg-addon-fish-feast-text"]
                              ConvergeFu.db.profile.fishFeastMatch  = L["event-chat-msg-addon-fish-feast-match"]
                              ConvergeFu:FishFeastAnnouncementsUpdated()
                           end
                        }
                     }
                  },
                  riw = {
                     name  = L["tools-riw-title"],
                     desc  = L["tools-riw-descr"],
                     type  = 'group',
                     order = 20,
                     args  = {
                        header1  = {
                           name  = L["tools-riw-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        status = {
                           name     = L["tools-riw-status-title"],
                           desc     = L["tools-riw-status-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-riw-status-usage"],
                           get      = function() return ConvergeFu.db.profile.riwStatus end,
                           set      = function(newValue)
                              ConvergeFu.db.profile.riwStatus = newValue
                              ConvergeFu:RaidInstanceWelcomeStatusUpdated()
                           end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        }                      
                     }
                  },
                  guild_status = {
                     name  = L["tools-misc-guildstatus-title"],
                     desc  = L["tools-misc-guildstatus-descr"],
                     type  = 'execute',
                     order = 30,
                     func  = function()
                        ConvergeFu:CheckGuildAdminStatus()   
                     end
                  },
                  loot_monitor = {
                     name  = L["tools-loot-monitor-title"],
                     desc  = L["tools-loot-monitor-descr"],
                     type  = 'group',
                     order = 40,
                     args  = {
                        header1  = {
                           name  = L["tools-loot-monitor-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        loot_monitor_enabled = {
                           name     = L["tools-loot-monitor-status-title"],
                           desc     = L["tools-loot-monitor-status-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-loot-monitor-status-usage"],
                           get      = function() return ConvergeFu.db.profile.lootMonitorStatus end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.lootMonitorStatus = newValue
                                         ConvergeFu:LootMonitorStatusUpdated()
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        },
                        loot_monitor_test = {
                           name  = L["tools-loot-monitor-test-title"],
                           desc  = L["tools-loot-monitor-test-descr"],
                           type  = 'execute',
                           order = 20,
                           func  = function()
                              ConvergeFu:LootMonitorTest()   
                           end
                        }                      
                     }
                  },
                  rogue_avoidance = {
                     name  = L["tools-misc-rogueav-title"],
                     desc  = L["tools-misc-rogueav-descr"],
                     type  = 'execute',
                     order = 50,
                     func  = function()
                        ConvergeFu:ShowAvoidanceForLevel70Rogues()   
                     end
                  },
                  debug = {
                     name  = L["tools-debug-title"],
                     desc  = L["tools-debug-descr"],
                     type  = 'group',
                     order = 60,
                     args  = {
                        header1  = {
                           name  = L["tools-debug-header"],
                           desc  = "",
                           type  = 'header',
                           order = 09,
                        },
                        messages = {
                           name     = L["tools-debug-status-title"],
                           desc     = L["tools-debug-status-descr"],
                           type     = 'text',
                           order    = 10,
                           usage    = L["tools-debug-status-usage"],
                           get      = function() return ConvergeFu.db.profile.debugStatus end,
                           set      = function(newValue)
                                         ConvergeFu.db.profile.debugStatus = newValue
                                      end,
                           validate = {L["common-data-option-on"], L["common-data-option-off"]}
                        }                     
                     }
                  }
               }
            }
         }
      },
      header1 = {
         name  = " ", 
         type  = 'header',
         order = 59,
      },
      quickbidoptions = {
         name  = L["mainmenu-quickbidoptions-header"], 
         type  = 'header',
         order = 60,
      }, 
      main = {
         name = L["tools-bidmgr-makebid-main-std-title"],
         desc = L["tools-bidmgr-makebid-main-std-descr"],
         type = 'execute',
         order  = 70,
         func = function()
            ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-main"], false)
         end
      },
      resist = {
         name = L["tools-bidmgr-makebid-resist-std-title"],
         desc = L["tools-bidmgr-makebid-resist-std-descr"],
         type = 'execute',
         order  = 80,
         func = function()
            ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-resist"], false)
         end
      },
      offspec = {
         name = L["tools-bidmgr-makebid-offspec-std-title"],
         desc = L["tools-bidmgr-makebid-offspec-std-descr"],
         type = 'execute',
         order  = 90,
         func = function()
            ConvergeFu:MakeBidToMasterLooter(L["tools-bidmgr-bid-type-offspec"], false)
         end
      },
      header2 = {
         name  = " ", 
         type  = 'header',
         order = 99,
      },
      quickraidchecks = {
         name  = L["mainmenu-quickraidchecks-header"], 
         type  = 'header',
         order = 100,
      },
      buffcheck = {
         name = L["mainmenu-quickraidcheck-buffs-title"],
         desc = L["mainmenu-quickraidcheck-buffs-descr"],
         type = 'execute',
         order  = 110,
         func = function()
            ConvergeFu:ListRaidersWithMissingConsumables(ConvergeFu.db.profile.bmOutputChannel)
         end
      },
      readycheck = {
         name = L["mainmenu-quickraidcheck-ready-title"],
         desc = L["mainmenu-quickraidcheck-ready-descr"],
         type = 'execute',
         order  = 120,
         func = function()
            ConvergeFu:DoReadyCheck()
         end
      },
      presencecheck = {
         name = L["mainmenu-quickraidcheck-present-title"],
         desc = L["mainmenu-quickraidcheck-present-descr"],
         type = 'execute',
         order  = 130,
         func = function()
            ConvergeFu:ExecuteChatCommand("/ravote "..L["mainmenu-quickraidcheck-present-msg"])
         end
      },
      header3 = {
         name  = " ", 
         type  = 'header',
         order = 139,
      },
      fubaroptions = {
         name  = L["mainmenu-fubaroptions-header"], 
         type  = 'header',
         order = 140,
      }, 
   } 
} 

ConvergeFu:RegisterChatCommand({"/confu"}, ConvergeFu.consoleOptions);
ConvergeFu.OnMenuRequest = ConvergeFu.consoleOptions; 

-- ============================================================================
-- == OnEnable()                                                             ==
-- ==                                                                        ==
-- == This function is part of the provided API.                             ==
-- ============================================================================

function ConvergeFu:OnEnable()

    self:RegisterEvent("RAID_INSTANCE_WELCOME")
    self:RegisterEvent("CHAT_MSG_WHISPER")
    self:RegisterEvent("CHAT_MSG_ADDON")
    self:RegisterEvent("CHAT_MSG_SYSTEM")
    self:RegisterEvent("CHAT_MSG_EMOTE")
    self:RegisterEvent("CHAT_MSG_MONSTER_EMOTE")
    self:RegisterEvent("LOOT_OPENED")
    
    self:RegisterEvent("PLAYER_REGEN_ENABLED")
    self:RegisterEvent("PLAYER_REGEN_DISABLED")
    self:RegisterEvent("READY_CHECK")
    self:RegisterEvent("READY_CHECK_FINISHED")
    
    ConvergeFu:Update()
    ConvergeFu:DoUpToDateCheck("GUILD")
    ConvergeFu:RecruitCharacterCancel()
    ConvergeFu:CheckGuildAdminStatus()
    ConvergeFu:InitialiseBidManagerRBPT()
    
    ConvergeFu.db.profile.showRaidActivities = L["common-data-option-on"]

end 

-- ============================================================================
-- == Update()                                                               ==
-- ==                                                                        ==
-- == This function checks if this is the first time that this version of    ==
-- == that addon has been run by this player and seeks to update various     ==
-- == settings to ensure that the player experience is optimal.              ==
-- ============================================================================

function ConvergeFu:Update()

   if ConvergeFu.db.profile.versionNumber < L["versionNumber"] then
   
      ConvergeFu.db.profile.bmExpiryTimeMinutes = 5
      ConvergeFu.db.profile.itemLevelValue      = "264"
      ConvergeFu.db.profile.versionNumber       = L["versionNumber"]
      
      msgText1 = L["updater-msg-title"]..L["updater-msg-001"]..ConvergeFu.db.profile.versionNumber..L["updater-msg-002"]
      msgText2 = L["updater-msg-003"]
      
      print(ConvergeFu:ColourTextForReportTitle(msgText1, "CHAT"))
      print(ConvergeFu:ColourTextWhite(msgText2))
      
   end

end

-- ============================================================================
-- == RAID_INSTANCE_WELCOME(instanceName, ttl)                               ==
-- ==                                                                        ==
-- == This function performs actions when the RAID_INSTANCE_WELCOME event is ==
-- == triggered. It is triggered when the player enters an instance that     ==
-- == saves raid members after a boss is killed.                             ==
-- ==                                                                        ==
-- == instanceName - The name of the instance entered.                       ==
-- == ttl          - The number of seconds until the instance resets.        ==
-- ============================================================================

function ConvergeFu:RAID_INSTANCE_WELCOME(instanceName, ttl)

   if ConvergeFu:IsDebugEnabled() then
      ConvergeFu:Debug("Function: ConvergeFu:RAID_INSTANCE_WELCOME(instanceName, ttl)")
      ConvergeFu:Debug(" - instanceName: "..ConvergeFu:ColourTextGreen(instanceName))
      ConvergeFu:Debug(" - ttl: "..ConvergeFu:ColourTextGreen(ttl))
   end
   
   playerName     = UnitName("player")
   playerNameText = ConvergeFu:ColourTextByCharacterClass(playerName, playerName)
   
   if ConvergeFu.db.profile.riwStatus == L["common-data-option-on"] then
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Icecrown Citadel.                           --
      -- == -------------------------------------------------------------------
      if string.match(instanceName, L["event-riw-ic-name"]) then
         print(ConvergeFu:ColourTextStory(L["event-riw-ic-msg-01"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-ic-msg-02"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-ic-msg-03"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-ic-msg-04"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-ic-msg-05"]))
         
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Trial of the Crusader.                      --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-cc-name"]) then
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-01"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-02"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-03"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-04"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-05"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-06"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-07"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-08"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-09"])..playerNameText..ConvergeFu:ColourTextStory(L["event-riw-cc-msg-10"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-11"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-12"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-cc-msg-13"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Ulduar.                                     --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-ulduar-name"]) then
         if UnitSex("player") == 3 then
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-01-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-02-1-female"])..playerNameText..ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-02-2-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-03-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-04-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-05-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-06-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-07-1-female"])..playerNameText..ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-07-2-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-08-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-09-1-female"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-10-1-female"]))
         else
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-01-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-02-1-male"])..playerNameText..ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-02-2-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-03-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-04-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-05-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-06-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-07-1-male"])..playerNameText..ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-07-2-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-08-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-09-1-male"]))
            print(ConvergeFu:ColourTextStory(L["event-riw-ulduar-msg-10-1-male"]))
         end
         
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Naxxramas.                                  --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-naxxramas-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-magtheridon-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Vault of Archavon.                          --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-voa-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-voa-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Obsidian Sanctum.                           --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-os-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-os-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Eye of Eternity.                            --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-eoe-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-eoe-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Mount Hyjal.                                --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-mh-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-mh-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Black Temple.                               --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-bt-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-bt-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Zul'aman.                                   --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-za-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-za-msg-01"]))
         
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Tempest Keep.                               --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-tk-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-tk-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Serpentshrine Cavern.                       --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-ssc-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-ssc-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Magtheridon's Lair.                         --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-magtheridon-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-magtheridon-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Gruul's Lair.                               --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-gruul-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-gruul-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Karazhan.                                   --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-karazhan-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-karazhan-msg-01"]))

      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: The Temple of Ahn'Qiraj (AQ40)              --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-aq40-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-aq40-msg-01"]))
         
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: The Ruins of Ahn'Qiraj (AQ20)               --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-aq20-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-aq20-msg-01"]))
         
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Blackwing Lair                              --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-bwl-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-bwl-msg-01"]))            
      
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Molten Core.                                --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-mc-name"]) then
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-01"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-02"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-03"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-04"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-05"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-06"]))
         print(ConvergeFu:ColourTextStory(L["event-riw-mc-msg-07"])..playerNameText..ConvergeFu:ColourTextStory("."))
      end
      
      -- == -------------------------------------------------------------------
      -- == -- Welcome text for: Zul'gurub                                   --
      -- == -------------------------------------------------------------------
      elseif string.match(instanceName, L["event-riw-zg-name"]) then
         print(playerNameText..ConvergeFu:ColourTextStory(L["event-riw-bwl-zg-01"]))  
      
   end
  
end

-- ============================================================================
-- == CHAT_MSG_WHISPER(msg, sender)                                          ==
-- ==                                                                        ==
-- == This function performs actions when the CHAT_MSG_WHISPER event is      ==
-- == triggered. It is triggered when the player's character receives a      ==
-- == message via the whisper 'channel.'                                     ==
-- ============================================================================

function ConvergeFu:CHAT_MSG_WHISPER(msg, sender)
  
  local Args = self:GetArgs(msg, " ")
  
  -- == -----------------------------------------------------------------------
  -- == -- Check if the sender was making a recognised loot bid.             --
  -- == -----------------------------------------------------------------------
  if string.match(msg, L["tools-bidmgr-bid-type-main"])
  or string.match(msg, L["tools-bidmgr-bid-type-resist"])
  or string.match(msg, L["tools-bidmgr-bid-type-offspec"]) then
     if ConvergeFu:IsThisARecognisedBid(msg) then
       ConvergeFu:DoProcessRecognisedLootBid(msg, sender)
       return
     end
  end
  
  -- == -----------------------------------------------------------------------
  -- == -- Check if the sender was making an informal (manual) loot bid.     --
  -- == -----------------------------------------------------------------------
  if string.lower(Args[1]) == L["tools-bidmgr-whisper-keyword"] then
       ConvergeFu:DoProcessManualLootBid(msg, sender)
       return
  end  
  
  -- == -----------------------------------------------------------------------
  -- == -- Check if the sender requested guild information.                  --
  -- == -----------------------------------------------------------------------
  if string.lower(Args[1]) == L["event-command-name-guildinfo"] then
    ConvergeFu:SendWhisperGuildInfo(sender)
    return
  end

  -- == -----------------------------------------------------------------------
  -- == -- Check if the sender issued a 'confu' command.                     --
  -- == -----------------------------------------------------------------------
  if string.lower(Args[1]) ~= L["event-command-name-confu"] then
    
    if ConvergeFu.db.profile.responderStatus == L["common-data-option-on"] then
      ConvergeFu:DoBusyResponder(sender, msg)
    end
    
    return
  end

  -- == -----------------------------------------------------------------------
  -- == -- Process the 'confu' command.                                      --
  -- == -----------------------------------------------------------------------
  local command; if Args[2] then command = string.lower(Args[2]); end

  -- == -----------------------------------------------------------------------
  -- == -- Sender requested confu command help.                              --
  -- == -----------------------------------------------------------------------  
  if command == nil  
  or command == L["event-command-name-help"] then
    ConvergeFu:SendWhisperCommandHelp(sender)
    return
  end
  
  -- == -----------------------------------------------------------------------
  -- == -- Sender requested cctargets info.                                  --
  -- == -----------------------------------------------------------------------  
  if command == L["event-command-name-cctargets"] then
    ConvergeFu:AnnounceCrowdControlTargets("WHISPER", sender)
    return
  end
  
  -- == -----------------------------------------------------------------------
  -- == -- Sender requested cctargets info.                                  --
  -- == -----------------------------------------------------------------------  
  if command == L["event-command-name-ccupdate"] then
    ConvergeFu:DoBroadcastCCTargets("RAID")
    broadcastMessage = ConvergeFu:ColourTextWhite(L["tools-crowd-control-broadcast-msg-02"])
                     ..ConvergeFu:ColourTextGreen(sender)
                     ..ConvergeFu:ColourTextWhite(".")
    self:Print(broadcastMessage)
    return
  end  
  
  -- == -----------------------------------------------------------------------
  -- == -- If we haven't returned yet, command must have been unrecognised.  --
  -- == ----------------------------------------------------------------------- 
  ConvergeFu:SendMessage(L["event-command-unknown-01-msg"], "WHISPER", " ", sender)
  ConvergeFu:SendMessage(L["event-command-unknown-02-msg"], "WHISPER", " ", sender)
  
end

-- ============================================================================
-- == SendWhisperCommandHelp(recipient)                                      ==
-- ==                                                                        ==
-- == This function sends hints via whispers on the available whisper-based  ==
-- == commands currently recognised by ConvergeFu to the named recipient.    ==
-- ============================================================================

function ConvergeFu:SendWhisperCommandHelp(recipient)

   ConvergeFu:SendMessage(L["event-helpinfo-01-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-helpinfo-02-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-helpinfo-03-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-helpinfo-04-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-helpinfo-05-msg"], "WHISPER", " ", recipient)
   
end

-- ============================================================================
-- == SendWhisperGuildInfo(recipient)                                        ==
-- ==                                                                        ==
-- == This function sends a summary of guild information via the whisper     ==
-- == channel to the named recipient.                                        ==
-- ============================================================================

function ConvergeFu:SendWhisperGuildInfo(recipient)

   ConvergeFu:SendMessage(L["event-guildinfo2-01-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-guildinfo2-02-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-guildinfo2-03-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-guildinfo2-04-msg"], "WHISPER", " ", recipient)
   ConvergeFu:SendMessage(L["event-guildinfo2-05-msg"], "WHISPER", " ", recipient)
   
end

-- ============================================================================
-- == GetArgs(message, separator)                                            ==
-- ==                                                                        ==
-- == This function receives a string and converts it into a list of         ==
-- == arguments, using a supplied separator character.                       ==
-- ============================================================================

function ConvergeFu:GetArgs(message, separator)
 
   if message == nil then
     message = ""
   end
   
   local args = {}
   local i = 0


   -- search for seperators in the string and return the separated data
   for value in string.gmatch(message, "[^"..separator.."]+") do
      i = i + 1
      args[i] = value
   end

   return args
   
end

-- ============================================================================
-- == DoBusyResponder(sender, msg)                                           ==
-- ==                                                                        ==
-- == This function aims to send a response to the 'sender' of the whispered ==
-- == message that was received. Before it sends the response however, it    ==
-- == first checks whether the sender is in one of several possible groups   ==
-- == that are currently excluded from receiving Responder messages.         ==
-- ==                                                                        ==
-- == Current flags the responder can be configured to notice:               ==
-- ==                                                                        ==
-- == If the sender is in our guild.                                         ==
-- == If the sender is an officer of our guild.                              ==
-- == If the sender is in our party.                                         ==
-- == If the sender is in our raid.                                          ==
-- == If the sender is on our friends-list.                                  ==
-- ==                                                                        ==
-- == Each of these options may be toggled by the user individually.         ==
-- ============================================================================

function ConvergeFu:DoBusyResponder(sender, msg)
  
   -- == ----------------------------------------------------------------------
   -- == Perform the info-requester check.                                   --
   -- == ----------------------------------------------------------------------
   if  msg == L["event-command-name-guildinfo"] then
      return
   end
   
   -- == ----------------------------------------------------------------------
   -- == Perform the guild-member exclusion check.                           --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu:IsCharacterInGuild(sender)
   and ConvergeFu.db.profile.responderGuild == L["common-data-option-off"] then
      return
   end

   -- == ----------------------------------------------------------------------
   -- == Perform the officer-member exclusion check.                         --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu:IsCharacterInGuild(sender)
   and ConvergeFu:IsOfficerRankedCharacter(sender)
   and ConvergeFu.db.profile.responderOfficer == L["common-data-option-off"] then
      return
   end
    
   -- == ----------------------------------------------------------------------
   -- == Perform the party-member exclusion check.                           --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu:IsCharacterInParty(sender)
   and ConvergeFu.db.profile.responderParty == L["common-data-option-off"] then
      return  
   end
  
   -- == ----------------------------------------------------------------------
   -- == Perform the raid-member exclusion check.                            --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu:IsCharacterInRaid(sender)
   and ConvergeFu.db.profile.responderRaid == L["common-data-option-off"] then
      return  
   end
  
   -- == ----------------------------------------------------------------------
   -- == Perform the friends-list exclusion check.                           --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu:IsCharacterAFriend(sender)
   and ConvergeFu.db.profile.responderFriend == L["common-data-option-off"] then
      return  
   end  
  
   -- == ----------------------------------------------------------------------
   -- == Perform the "responding to a [BusyResponder] message" check.        --
   -- == ----------------------------------------------------------------------
   local brMessageTest = string.find(msg, "BusyResponder")
   if brMessageTest then
     return
   end
  
   -- == ----------------------------------------------------------------------
   -- == Send the response message.                                          --
   -- == ----------------------------------------------------------------------
   messageText = L["tools-busy-responder-message-first"]..ConvergeFu.db.profile.responderMessage    
   ConvergeFu:SendMessage(messageText, "WHISPER", nil, sender)

end

-- ============================================================================
-- == ToggleBusyResponder()                                                  ==
-- ==                                                                        ==
-- == This function simply toggles the BusyResponder tool on or off and      ==
-- == reports the outcome of the 'toggle' to the chat window.                ==
-- ============================================================================

function ConvergeFu:ToggleBusyResponder()

  if ConvergeFu.db.profile.responderStatus == L["common-data-option-on"] then
    ConvergeFu.db.profile.responderStatus = L["common-data-option-off"]
  else
    ConvergeFu.db.profile.responderStatus = L["common-data-option-on"]
  end
  
end

-- ============================================================================
-- == BusyResponderShowStatus()                                              ==
-- ==                                                                        ==
-- == This function simply reports on the current status of BusyResponder.   ==
-- ============================================================================

function ConvergeFu:BusyResponderShowStatus()

   statusMessage1 = L["tools-busy-responder-states-01-msg"]
                   ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderStatus)

   statusMessage2 = L["tools-busy-responder-states-02-msg"]
                  ..L["tools-busy-responder-states-03-msg"]
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderGuild)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-04-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderOfficer)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-05-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderParty)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-06-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderRaid)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-07-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderFriend)
                  .."."
       
   statusMessage3 = L["tools-busy-responder-msg-current-msg"]
                  ..ConvergeFu:ColourTextGreen('[')
                  ..ConvergeFu:ColourTextYellow(ConvergeFu.db.profile.responderMessage)
                  ..ConvergeFu:ColourTextGreen(']')
                  
   self:Print(statusMessage1)
   self:Print(statusMessage2)
   self:Print(statusMessage3)
   
end

-- ============================================================================
-- == BusyResponderStatusUpdated()                                           ==
-- ==                                                                        ==
-- == This function simply reports the state of BusyResponder's current      ==
-- == operational state.                                                     ==
-- ============================================================================

function ConvergeFu:BusyResponderStatusUpdated()

   statusMessage1 = L["tools-busy-responder-states-01-msg"]
                   ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderStatus)

                  
   self:Print(statusMessage1)
   
end


-- ============================================================================
-- == BusyResponderExclusionsUpdated()                                       ==
-- ==                                                                        ==
-- == This function simply reports the state of BusyResponder's current      ==
-- == exclusion flags.                                                       ==
-- ============================================================================

function ConvergeFu:BusyResponderExclusionsUpdated()

   statusMessage2 = L["tools-busy-responder-states-02-msg"]
                  ..L["tools-busy-responder-states-03-msg"]
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderGuild)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-04-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderOfficer)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-05-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderParty)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-06-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderRaid)
                  ..ConvergeFu:ColourTextWhite(L["tools-busy-responder-states-07-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.responderFriend)
                  .."."
   
   self:Print(statusMessage2)
   
end

-- ============================================================================
-- == BusyResponderMessageUpdated()                                          ==
-- ==                                                                        ==
-- == This function simply reports that the BusyResponder message has been   ==
-- == updated.                                                               ==
-- ============================================================================

function ConvergeFu:BusyResponderMessageUpdated()

   msgUpdated1 = ConvergeFu:ColourTextWhite(L["tools-busy-responder-msg-updated-01-msg"])
   msgUpdated2 = ConvergeFu:ColourTextYellow(ConvergeFu.db.profile.responderMessage)
   
   msgUpdated  = msgUpdated1 .. msgUpdated2
   
   self:Print(msgUpdated)
   
end

-- ============================================================================
-- == FishFeastAnnouncementsUpdated()                                        ==
-- ==                                                                        ==
-- == This function simply reports that the BusyResponder message has been   ==
-- == updated.                                                               ==
-- ============================================================================

function ConvergeFu:FishFeastAnnouncementsUpdated()

   msgUpdated1 = ConvergeFu:ColourTextWhite(L["tools-fish-feast-msg-updated-01-msg"])
   msgUpdated2 = ConvergeFu:ColourTextYellow(L["tools-fish-feast-msg-updated-02-msg"])..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.fishFeastStatus)
   msgUpdated3 = ConvergeFu:ColourTextYellow(" "..L["tools-fish-feast-msg-updated-03-msg"])..ConvergeFu:ColourTextGreen(ConvergeFu.db.profile.fishFeastText)
   msgUpdated4 = ConvergeFu:ColourTextYellow(" "..L["tools-fish-feast-msg-updated-04-msg"])..ConvergeFu:ColourTextGreen(ConvergeFu.db.profile.fishFeastMatch)

   msgUpdated = msgUpdated1 .. msgUpdated2 .. msgUpdated3 .. msgUpdated4

   self:Print(msgUpdated)
end

-- ============================================================================
-- == CHAT_MSG_ADDON(prefix, msg, channel, sender)                           ==
-- ==                                                                        ==
-- == This function performs actions when the CHAT_MSG_ADDON event is        ==
-- == triggered. It is triggered when the player's character receives a      ==
-- == message via the addon 'channel' that was introduced circa patch 1.12.  ==
-- ==                                                                        ==
-- == Currently, this event is monitored to permit communication between     ==
-- == instances of ConvergeFu being run by different players.                ==
-- ==                                                                        ==
-- == The following prefix codes will be intercepted by this function:       ==
-- ==                                                                        ==
-- == Prefix Code: CFUVCQ                                                    ==
-- == Description: ConvegeFu Version Check Query.                            ==
-- == Message fmt: "sender"                                                  ==
-- ==                                                                        ==
-- == Prefix Code: CFUVCR                                                    ==
-- == Description: ConvegeFu Version Check Response.                         ==
-- == Message fmt: "sender-version"                                          ==
-- ==                                                                        ==
-- == Prefix Code: CFULMT                                                    ==
-- == Description: ConvegeFu Loot Monitor Trigger.                           ==
-- == Message fmt: "characterName messageText targetName."                   ==
-- ==                                                                        ==
-- == Prefix Code: CFUCCU                                                    ==
-- == Description: ConvegeFu Crowd Control Update.                           ==
-- == Message fmt: "skullName:::skullType:::...:::starName:::starType"       ==
-- ==                                                                        ==
-- == Prefix Code: CFURIA                                                    ==
-- == Description: ConvegeFu Raid Invitation Announcement.                   ==
-- == Message fmt: "characterName"                                           ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CHAT_MSG_ADDON(prefix, msg, channel, sender)

  if prefix == L["event-addon-vc-query"] then
     ConvergeFu:DoProcessVersionCheckQuery(msg, channel, sender)
  end  

  if prefix == L["event-addon-vc-response"] then
     ConvergeFu:DoProcessVersionCheckResponse(msg, channel, sender)
  end 
  
  if prefix == L["event-addon-lm-trigger"] then
     ConvergeFu:DoNotifyLootMonitorTriggered(msg, channel, sender)
  end 
  
  if prefix == L["event-addon-lm-stoplooting"] then
     ConvergeFu:DoWarnLootMonitorStopLooting(msg, channel, sender)
  end   
  
  if prefix == L["event-addon-cc-update"] then
     ConvergeFu:DoProcessCCUpdateMessage(msg, channel, sender)
  end
  
  if prefix == L["event-addon-raid-invitation-announce"] then
     ConvergeFu:DoProcessRaidInvitationAnnouncement(msg, channel, sender)
  end
  
  if prefix == L["event-addon-raid-end-announce"] then
     ConvergeFu:DoProcessRaidEndNotification(msg, channel, sender)
  end  
  
  if prefix == L["event-addon-remote-control-protocol"] then
     ConvergeFu:DoProcessRCPMessage(msg, channel, sender)
  end

  if prefix == L["event-addon-bid-manager-bid-transmit"] then
     if ConvergeFu:IsThisARecognisedBid(msg) then
        ConvergeFu:DoProcessRecognisedLootBid(msg, sender)
     end  
  end
  
  if prefix == L["event-addon-bid-manager-ack-bid"] then
     ConvergeFu:DoProcessBidAcknowledgement(msg, sender, channel)
  end

  if prefix == L["event-addon-buff-monitor-notification"] then
     ConvergeFu:DoProcessBMNotification(msg, sender)
  end

end

-- ============================================================================
-- == SendRCPMessage(messageText, channelName)                               ==
-- ==                                                                        ==
-- == This function sends an RCP message as supplied by the calling code.    ==
--  ==                                                                        ==
-- == Message format: {variable}                                             ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:SendRCPMessage(messageText, channelName)

   -- == ----------------------------------------------------------------------
   -- == -- Check the target is set to an appropriate value.                 --
   -- == ----------------------------------------------------------------------
   if ConvergeFu.db.profile.rcpTarget == L["common-data-option-unset"] then
      unsetTargetText =  ConvergeFu:ColourTextPurple(L["event-rcp-msg-first"])
                       ..ConvergeFu:ColourTextWhite(L["event-rcp-target-unset-msg-01"])
      self:Print(unsetTargetText)
      return
   end

   fullMessageText = messageText..":::"..ConvergeFu.db.profile.rcpTarget
   
   SendAddonMessage(L["event-addon-remote-control-protocol"], fullMessageText, channelName)
   
end

-- ============================================================================
-- == DoProcessRCPMessage(msg, channel, sender)                              ==
-- ==                                                                        ==
-- == This function processes a 'remote control protocol' message received   ==
-- == by the running instance of ConvergeFu.                                 ==
-- ==                                                                        ==
-- == Message format: {variable}                                             ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:DoProcessRCPMessage(msg, channel, sender)

   -- == ----------------------------------------------------------------------
   -- == -- Debug Code.                                                      --
   -- == ----------------------------------------------------------------------   
   if ConvergeFu:IsDebugEnabled() then
      ConvergeFu:Debug("Function: ConvergeFu:DoProcessRCPMessage(msg, channel, sender)")
      ConvergeFu:Debug(" - msg: "..ConvergeFu:ColourTextGreen(msg))
      ConvergeFu:Debug(" - channel: "..ConvergeFu:ColourTextGreen(channel))
      ConvergeFu:Debug(" - sender: "..ConvergeFu:ColourTextGreen(sender))
   end

   -- == ----------------------------------------------------------------------
   -- == -- Separate out the message components.                             --
   -- == ----------------------------------------------------------------------
   local Args = self:GetArgs(msg, ":::")
   rcpCommand = ConvergeFu:SafeText(Args[1])
   rcpTarget  = ConvergeFu:SafeText(Args[2])
   
   ConvergeFu:Debug(" - rcpCommand = "..ConvergeFu:ColourTextGreen(rcpCommand))
   ConvergeFu:Debug(" - rcpTarget = "..ConvergeFu:ColourTextGreen(rcpTarget))
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if rcpTarget == L["tools-rcp-target-all-keyword"] then
      ConvergeFu:Debug(L["event-rcp-msg-targetting-all"])
   else
      if rcpTarget ~= UnitName("player") then
         ConvergeFu:Debug(L["event-rcp-msg-targetting-not-me"])
         return
      end
   end

   -- == ----------------------------------------------------------------------
   -- == -- Perform command reporting as appropriate.                        --
   -- == ----------------------------------------------------------------------
   ConvergeFu:RCPCommandReporting(rcpCommand, sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn on the fish feast announcer?            --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ffa-on"] then
      ConvergeFu:RCPCommandEnableFFA(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn off the fish feast announcer?           --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ffa-off"] then
      ConvergeFu:RCPCommandDisableFFA(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Reset the fish feast announcer message?      --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ffa-reset"] then
      ConvergeFu:RCPCommandResetFFAMessage(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn on the Buff Monitor CM functionality?   --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-bmcm-on"] then
      ConvergeFu:RCPCommandEnableBuffMonitorCM(sender)
   end   

   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn off the Buff Monitor CM functionality?  --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-bmcm-off"] then
      ConvergeFu:RCPCommandDisableBuffMonitorCM(sender)
   end 
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn on RAS message showing capability?      --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ras-on"] then
      ConvergeFu:RCPCommandEnableRaidActivityShowing(sender)
   end  
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn off RAS message showing capability?     --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ras-off"] then
      ConvergeFu:RCPCommandDisableRaidActivityShowing(sender)
   end  
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn on RIA message showing capability?      --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ria-showing-on"] then
      ConvergeFu:RCPCommandEnableRIAShowing(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn off RIA message showing capability?     --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ria-showing-off"] then
      ConvergeFu:RCPCommandDisableRIAShowing(sender)
   end   
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn on RIA messages sending capability?     --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ria-sending-on"] then
      ConvergeFu:RCPCommandEnableRIASending(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn off RIA message sending capability?     --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-ria-sending-off"] then
      ConvergeFu:RCPCommandDisableRIASending(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn on RQA message showing capability?      --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-rqa-showing-on"] then
      ConvergeFu:RCPCommandEnableRQAShowing(sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: Turn off RQA message showing capability?     --
   -- == ----------------------------------------------------------------------
   if rcpCommand == L["event-rcp-rqa-showing-off"] then
      ConvergeFu:RCPCommandDisableRQAShowing(sender)
   end  
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: A movie-maker co-ordinated 'say' command?    --
   -- == ----------------------------------------------------------------------
   if string.match(rcpCommand, L["event-rcp-mm-say"]) then
      ConvergeFu:RCPCommandMovieMakerSay(rcpCommand, sender)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Is the RCP request: A movie-maker co-ordinated 'do' command?     --
   -- == ----------------------------------------------------------------------
   if string.match(rcpCommand, L["event-rcp-mm-do"]) then
      ConvergeFu:RCPCommandMovieMakerDo(rcpCommand, sender)
   end

end

-- ============================================================================
-- == RCPCommandReporting(rcpCommand, sender)                                ==
-- ==                                                                        ==
-- == This function reports on command instuctions that have been issued. It ==
-- == is only intended currently to function for officer ranked members of   ==
-- == the guild.                                                             ==
-- ============================================================================

function ConvergeFu:RCPCommandReporting(rcpCommand, sender)

   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user is an officer ranked player or not.       --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(UnitName("player")) then
      return
   end
     
   crText1 = L["event-rcp-msg-first"]
           ..L["event-rcp-msg-reporting-command"]
           ..rcpCommand
           ..L["event-rcp-msg-reporting-sender"]
           ..sender
           ..L["event-rcp-msg-reporting-last"]
           
   crText1 = ConvergeFu:ColourTextForReportTitle(crText1, "CHAT")

   ConvergeFu:SendChatMessage(crText1, "CHAT")
   
end

-- ============================================================================
-- == RCPCommandEnableFFA(sender)                                            ==
-- ==                                                                        ==
-- == This function services the RCP command to enable the custom Fish Feast ==
-- == Announcer (FFA) message generation.                                    ==
-- ==                                                                        ==
-- == Message Format...: FishFeastAnnouncementsOn                            ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandEnableFFA(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.fishFeastStatus = L["common-data-option-on"]
   
end

-- ============================================================================
-- == RCPCommandDisableFFA(sender)                                           ==
-- ==                                                                        ==
-- == This function services the RCP command to disable the custom Fish      ==
-- == Feast Announcer (FFA) message generation.                              ==
-- ==                                                                        ==
-- == Message Format...: FishFeastAnnouncementsOff                           ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandDisableFFA(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.fishFeastStatus = L["common-data-option-off"]
   
end

-- ============================================================================
-- == RCPCommandResetFFAMessage(sender)                                      ==
-- ==                                                                        ==
-- == This function services the RCP command to reset the custom Fish Feast  ==
-- == Announcer (FFA) message to its default value.                          ==
-- ==                                                                        ==
-- == Message Format...: FishFeastAnnouncementsMsgReset                      ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandResetFFAMessage(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.fishFeastText = L["event-chat-msg-addon-fish-feast-text"]
   
end

-- ============================================================================
-- == RCPCommandEnableBuffMonitorCM(sender)                                  ==
-- ==                                                                        ==
-- == This function services the RCP command to enable the Buff Monitor's    ==
-- == combat status monitoring functionality.                                ==
-- ==                                                                        ==
-- == Message Format...: BuffMonitorCMStatusOn                               ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandEnableBuffMonitorCM(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.bmCMGlobalStatus = L["common-data-option-on"]
   
end

-- ============================================================================
-- == RCPCommandDisableBuffMonitorCM(sender)                                 ==
-- ==                                                                        ==
-- == This function services the RCP command to disable the Buff Monitor's   ==
-- == combat status monitoring functionality.                                ==
-- ==                                                                        ==
-- == Message Format...: BuffMonitorCMStatusOff                              ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandDisableBuffMonitorCM(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.bmCMGlobalStatus = L["common-data-option-off"]
   
end

-- ============================================================================
-- == RCPCommandEnableRaidActivityShowing(sender)                            ==
-- ==                                                                        ==
-- == This function services the RCP command to enable the showing of raid   ==
-- == activity (RAS) messages.                                               ==
-- ==                                                                        ==
-- == Message Format...: RaidActivityShowingOn                               ==
-- == Permissions......: Any Character.                                      ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandEnableRaidActivityShowing(sender)

   ConvergeFu.db.profile.showRaidActivities = L["common-data-option-on"]
   
end

-- ============================================================================
-- == RCPCommandDisableRaidActivityShowing(sender)                           ==
-- ==                                                                        ==
-- == This function services the RCP command to disable the showing of raid  ==
-- == activity (RAS) messages.                                               ==
-- ==                                                                        ==
-- == Message Format...: RaidActivityShowingOff                              ==
-- == Permissions......: Any Character.                                      ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:RCPCommandDisableRaidActivityShowing(sender)

   ConvergeFu.db.profile.showRaidActivities = L["common-data-option-off"]
   
end

-- ============================================================================
-- == RCPCommandEnableRIAShowing(sender)                                     ==
-- ==                                                                        ==
-- == This function services the RCP command to enable the showing of raid   ==
-- == invitation announcement (RIA) messages.                                ==
-- ==                                                                        ==
-- == Message Format...: RaidInvitationAnnouncementShowingOn                 ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandEnableRIAShowing(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.showRaidInvitations = L["common-data-option-on"]
   
end

-- ============================================================================
-- == RCPCommandDisableRIAShowing(sender)                                    ==
-- ==                                                                        ==
-- == This function services the RCP command to disable the showing of raid  ==
-- == invitation announcement (RIA) messages.                                ==
-- ==                                                                        ==
-- == Message Format...: RaidInvitationAnnouncementShowingOff                ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandDisableRIAShowing(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.showRaidInvitations = L["common-data-option-off"]
   
end

-- ============================================================================
-- == RCPCommandEnableRIASending(sender)                                     ==
-- ==                                                                        ==
-- == This function services the RCP command to enable the sending of raid   ==
-- == invitation announcement (RIA) messages.                                ==
-- ==                                                                        ==
-- == Message Format...: RaidInvitationAnnouncementSendingOn                 ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandEnableRIASending(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.sendRaidInvitations = L["common-data-option-on"]
   
end

-- ============================================================================
-- == RCPCommandDisableRIASending(sender)                                    ==
-- ==                                                                        ==
-- == This function services the RCP command to disable the sending of raid  ==
-- == invitation announcement (RIA) messages.                                ==
-- ==                                                                        ==
-- == Message Format...: RaidInvitationAnnouncementSendingOff                ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandDisableRIASending(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.sendRaidInvitations = L["common-data-option-off"]
   
end

-- ============================================================================
-- == RCPCommandEnableRQAShowing(sender)                                     ==
-- ==                                                                        ==
-- == This function services the RCP command to enable the showing of raid   ==
-- == queue announcement (RQA) messages.                                     ==
-- ==                                                                        ==
-- == Message Format...: RaidQueueAnnouncementShowingOn                      ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandEnableRQAShowing(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.showQueueRequests = L["common-data-option-on"]
   
end

-- ============================================================================
-- == RCPCommandDisableRQAShowing(sender)                                    ==
-- ==                                                                        ==
-- == This function services the RCP command to disable the showing of raid  ==
-- == queue announcement (RQA) messages.                                     ==
-- ==                                                                        ==
-- == Message Format...: RaidQueueAnnouncementShowingOff                     ==
-- == Permissions......: Officer Ranked Characters Only.                     ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandDisableRQAShowing(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if this user needs to respond to the RCP message.      --
   -- == ----------------------------------------------------------------------
   if not ConvergeFu:IsOfficerRankedCharacter(sender) then
      return
   end
   
   ConvergeFu.db.profile.showQueueRequests = L["common-data-option-off"]
   
end

-- ============================================================================
-- == RCPCommandMovieMakerSay(rcpCommand, sender)                            ==
-- ==                                                                        ==
-- == This function services the RCP command to enable budding movie-makers  ==
-- == to co-ordinate the raid members to say selected phrases in unison.     ==
-- ==                                                                        ==
-- == Message Format...: MovieMakerSay@@@{expressionToSay}                   ==
-- == Permissions......: Any Character.                                      ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandMovieMakerSay(rcpCommand, sender)

   -- == ----------------------------------------------------------------------
   -- == -- Separate out the message components.                             --
   -- == ----------------------------------------------------------------------
   local Args     = self:GetArgs(rcpCommand, "@@@")
   rcpCommandType = ConvergeFu:SafeText(Args[1])
   rcpTextToSay   = ConvergeFu:SafeText(Args[2])

   rcpReportText1 = ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])
                  ..ConvergeFu:ColourTextWhite(L["tools-rcp-mm-msg-01"])
                  ..ConvergeFu:ColourTextGreen(sender)
   
   rcpReportText2 = ConvergeFu:ColourTextWhite(L["tools-rcp-mm-msg-02"])
                  ..ConvergeFu:ColourTextGreen(rcpCommandType)

   rcpReportText3 = ConvergeFu:ColourTextWhite(L["tools-rcp-mm-msg-03"])
                  ..ConvergeFu:ColourTextGreen(rcpTextToSay)                  
   
   self:Print(rcpReportText1)
   self:Print(rcpReportText2)
   self:Print(rcpReportText3)
   
   ConvergeFu:SendChatMessage(rcpTextToSay, "SAY")
   
end

-- ============================================================================
-- == RCPCommandMovieMakerDo(rcpCommand, sender)                             ==
-- ==                                                                        ==
-- == This function services the RCP command to enable budding movie-makers  ==
-- == to co-ordinate the raid members to perform selected actions in unison. ==
-- ==                                                                        ==
-- == Message Format...: MovieMakerDo@@@{actionToPerform}                    ==
-- == Permissions......: Any Character.                                      ==
-- ==                                                                        ==
-- ============================================================================
function ConvergeFu:RCPCommandMovieMakerDo(rcpCommand, sender)

   -- == ----------------------------------------------------------------------
   -- == -- Separate out the message components.                             --
   -- == ----------------------------------------------------------------------
   local Args         = self:GetArgs(rcpCommand, "@@@")
   rcpCommandType     = ConvergeFu:SafeText(Args[1])
   rcpActionToPerform = ConvergeFu:SafeText(Args[2])

   rcpReportText1 = ConvergeFu:ColourTextPurple(L["tools-rcp-msg-first"])
                  ..ConvergeFu:ColourTextWhite(L["tools-rcp-mm-msg-01"])
                  ..ConvergeFu:ColourTextGreen(sender)
   
   rcpReportText2 = ConvergeFu:ColourTextWhite(L["tools-rcp-mm-msg-02"])
                  ..ConvergeFu:ColourTextGreen(rcpCommandType)

   rcpReportText3 = ConvergeFu:ColourTextWhite(L["tools-rcp-mm-msg-03"])
                  ..ConvergeFu:ColourTextGreen(rcpActionToPerform)                  
   
   self:Print(rcpReportText1)
   self:Print(rcpReportText2)
   self:Print(rcpReportText3)
   
   ConvergeFu:ExecuteChatCommand(rcpActionToPerform)
   
end

-- ============================================================================
-- == DoProcessRaidInvitationAnnouncement(msg, channel, sender)              ==
-- ==                                                                        ==
-- == This function processes the raid invitation broadcast announcement. It ==
-- == asks the player if they wish to request a raid invitation from the     ==
-- == current raid inviter.                                                  ==
-- ==                                                                        ==
-- == Message format: CHARACTER_NAME                                         ==
-- == CHARACTER_NAME: The name of the character offering raid invitations.   ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:DoProcessRaidInvitationAnnouncement(msg, channel, sender)

   -- == ----------------------------------------------------------------------
   -- == -- Ignore this announcement if one of the following are true:       --
   -- == --                                                                  --
   -- == -- 1: You sent the Raid Invitation Announcement (RIA).              --
   -- == -- 2: You are in the same party as the person that sent the RIA.    --
   -- == -- 3: You are in the same raid as the person that sent the RIA.     --
   -- == -- 4: You already received an RCP command turning off RAS notices.  --
   -- == ----------------------------------------------------------------------
   if UnitName("player") == msg then
      return
   end
   
   if ConvergeFu:IsCharacterInParty(msg) then
      return
   end
   
   if ConvergeFu:IsCharacterInParty(msg) then
      return
   end
   
   if ConvergeFu.db.profile.showRaidActivities == L["common-data-option-off"] then
      return
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Set the raid organiser field to the message sender's name...     --
   -- == ----------------------------------------------------------------------
   ConvergeFu.db.profile.raidOrganiser = sender
   
   -- == ----------------------------------------------------------------------
   -- == -- Configure the text strings...                                    --
   -- == ----------------------------------------------------------------------
   characterToWhisper = msg
   windowTitle        = L["event-raid-invitation-window-msg-01"]..characterToWhisper.."?"
   
   joinMessage        = ConvergeFu:ColourTextPurple(L["event-raid-invitation-msg-first"])
                      ..ConvergeFu:ColourTextWhite(L["event-raid-invitation-join-msg-01"])
                      
   cancelMessage      = ConvergeFu:ColourTextPurple(L["event-raid-invitation-msg-first"])
                      ..ConvergeFu:ColourTextWhite(L["event-raid-invitation-cancel-msg-01"])
                      ..ConvergeFu:ColourTextYellow(L["event-raid-invitation-keyword"])
                      ..ConvergeFu:ColourTextWhite(L["event-raid-invitation-cancel-msg-02"])
                      ..ConvergeFu:ColourTextGreen(characterToWhisper)
                      ..ConvergeFu:ColourTextWhite(L["event-raid-invitation-cancel-msg-03"])
   
   -- == ----------------------------------------------------------------------
   -- == -- Configure the popup window...                                    --
   -- == ----------------------------------------------------------------------
   StaticPopupDialogs[L["event-raid-invitation-window-title"]] = {
      
      text         = windowTitle,
      button1      = L["event-raid-invitation-window-btn-yes"],
      button2      = L["event-raid-invitation-window-btn-no"],      
      timeout      = 30,
      whileDead    = 1,
      hideOnEscape = 0,

      OnAccept = function()
         ConvergeFu:SendMessage(L["event-raid-invitation-keyword"], "WHISPER", nil, characterToWhisper)
         ConvergeFu.db.profile.showRaidActivities = L["common-data-option-off"]
         self:Print(joinMessage)
      end,
      
      OnCancel = function()
         self:Print(cancelMessage)
         ConvergeFu.db.profile.showRaidActivities = L["common-data-option-on"]
      end      
   }

   -- == ----------------------------------------------------------------------
   -- == -- Display the popup window...                                      --
   -- == ----------------------------------------------------------------------
   if ConvergeFu.db.profile.showRaidInvitations == L["common-data-option-on"] then
      StaticPopup_Show (L["event-raid-invitation-window-title"])
      PlaySound("DwarfExploration")
   end
end

-- ============================================================================
-- == DoProcessRaidEndNotification(msg, channel, sender)                     ==
-- ==                                                                        ==
-- == This function processes the raid end notification and sets the raid    ==
-- == status variables to their default values.                              ==
-- ==                                                                        ==
-- == Message format: CHARACTER_NAME                                         ==
-- == CHARACTER_NAME: The name of the character notifying the raid end.      ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:DoProcessRaidEndNotification(msg, channel, sender)

   ConvergeFu.db.profile.raidInviter        = ""
   ConvergeFu.db.profile.raidQueueManager   = ""
   ConvergeFu.db.profile.raidOrganiser      = ""
   ConvergeFu.db.profile.showRaidActivities = L["common-data-option-on"]
   
   messageText = ConvergeFu:ColourTextPurple(L["event-raid-end-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["event-raid-end-msg-01"])
               ..ConvergeFu:ColourTextGreen(sender.."|r.")
               
   ConvergeFu:Debug(messageText)
   
end

-- ============================================================================
-- == DoProcessVersionCheckQuery(msg, channelName, sender)                   ==
-- ==                                                                        ==
-- == This function processes the inter-addon version check request event.   ==
-- == It constructs a response containing the version number of the instance ==
-- == of this addon being run by the user and sends the response out via the ==
-- == addon channel, using the same channel-focus as the receive message.    ==
-- ==                                                                        ==
-- == Message format: RECIPIENT-VERSIONSTRING                                ==
-- == RECIPIENT:      The person to whom this response is targeted.          ==
-- == VERSIONSTRING:  The version details for this instance of ConvergeFu.   ==
-- ==                 in "versionName:versionNumber" format.                 ==
-- ============================================================================

function ConvergeFu:DoProcessVersionCheckQuery(msg, channelName, sender)

   myName = UnitName("player")
   
   if myName == sender then
     return
   end
   
   messageText = sender.."-"..ConvergeFu.db.profile.versionString
   
   SendAddonMessage(L["event-addon-vc-response"], messageText, channelName)

end

-- ============================================================================
-- == DoProcessVersionCheckResponse(msg, channel, sender)                    ==
-- ==                                                                        ==
-- == This function processes the inter-addon version check response event.  ==
-- == It determines whether this is a response sent to the user and if it is ==
-- == it then displays that response in the user's chat window.              ==
-- ============================================================================

function ConvergeFu:DoProcessVersionCheckResponse(msg, channel, sender)

   myName = UnitName("player")
   
   -- == ----------------------------------------------------------------------
   -- == -- Decode the message text into its component parts.                --
   -- == ----------------------------------------------------------------------
   local Args               = self:GetArgs(msg, "-")
   local recipient          = Args[1]
   local versionInformation = Args[2]
   
   local Args               = self:GetArgs(versionInformation, ":")
   local versionName        = Args[1]
   local versionNumber      = Args[2]
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform some rudimentary error corrections.                      --
   -- == ----------------------------------------------------------------------
   if versionName == nil then
      versionName = "[Version Unknown]"
   end
   
   if versionNumber == nil then
      versionNumber = "0.00"
   end

   -- == ----------------------------------------------------------------------
   -- == -- Confirm whether we are expected to respond to this message.      --
   -- == ----------------------------------------------------------------------
   if myName ~= recipient then
      return
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Pre-colour the version number, w.r.t. this version.              --
   -- == ----------------------------------------------------------------------
   local colouredVersionNumber = ConvergeFu:ColourTextYellow(versionNumber)
   
   if versionNumber > L["versionNumber"] then
     colouredVersionNumber = ConvergeFu:ColourTextGreen(versionNumber)
   end
   
   if versionNumber < L["versionNumber"] then
     colouredVersionNumber = ConvergeFu:ColourTextRed(versionNumber)
   end
      
   -- == ----------------------------------------------------------------------
   -- == -- Configure the message strings to be used.                        --   
   -- == ----------------------------------------------------------------------
   senderText    = ConvergeFu:ColourTextByCharacterClass(sender, sender)
   
   messageText1  = senderText
                 ..ConvergeFu:ColourTextWhite(": ")
                 ..ConvergeFu:ColourTextBlizzard(versionName..": ")
                 ..colouredVersionNumber

   versionText   = ConvergeFu:ColourTextBlizzard(versionName..": ")
                 ..colouredVersionNumber

   groupListText = versionName..": "..versionNumber
   
   -- == ----------------------------------------------------------------------
   -- == -- Update the version check group list.                             --   
   -- == ----------------------------------------------------------------------
   ConvergeFu:UpdateVersionCheckGroupList(sender, groupListText)
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the response for a standard version-check.               --
   -- == ----------------------------------------------------------------------            
   if ConvergeFu.db.profile.versionQuiet == L["common-data-option-zero"] then
     
     if ConvergeFu.db.profile.versionDispChat == L["common-data-option-one"] then
        self:Print(messageText1)
     end     
     
     if versionCheckFrameCreated == L["common-data-option-zero"] then
        ConvergeFu:CreateVersionCheckFrame(sender, versionText)
     else
        versionCheckFrame:AddLine(senderText, versionText)
     end
     
     if ConvergeFu.db.profile.versionDispWin == L["common-data-option-one"] then
        versionCheckFrame:Show()
     end
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the response for an up-to-date version-check.            --
   -- == ----------------------------------------------------------------------
   if ConvergeFu.db.profile.versionQuiet == L["common-data-option-one"] then
     if versionNumber > L["versionNumber"] then

       messageText2 = ConvergeFu:ColourTextYellow(" Newer Version: ")
                    ..senderText
                    ..ConvergeFu:ColourTextWhite(" - [")
                    ..ConvergeFu:ColourTextBlizzard(versionName..": ")
                    ..ConvergeFu:ColourTextGreen(versionNumber)
                    ..ConvergeFu:ColourTextWhite("]")
       
       print(messageText2)
              
       if versionCheckFrameCreated == L["common-data-option-zero"] then
          ConvergeFu:CreateVersionCheckFrame(senderText, versionText)
       else
          versionCheckFrame:AddLine(senderText, versionText)
       end
       
       -- ConvergeFu:CreateVersionCheckFrame(senderText, versionText)
       versionCheckFrame:Show()
     end
   end
end

-- ============================================================================
-- == DoVersionCheck(channelName)                                            ==
-- ==                                                                        ==
-- == This function outputs an inter-addon message to trigger a version      ==
-- == check response from any other instances of ConvergeFu that are within  == 
-- == 'earshot', depending upon the channel on which the message is sent out ==
-- == on.                                                                    ==
-- ============================================================================

function ConvergeFu:DoVersionCheck(channelName)

   -- -------------------------------------------------------------------------
   -- -- Check if both output methods are switched off, such that the        --
   -- -- results of the version check could not be displayed.                --
   -- -------------------------------------------------------------------------
   if  ConvergeFu.db.profile.versionDispWin == L["common-data-option-zero"]
   and ConvergeFu.db.profile.versionDispChat == L["common-data-option-zero"] then
      self:Print(L["tools-versioncheck-muted-01-msg"])
   end

   ConvergeFu:PrepareVersionCheckGroupList()
   
   local Args               = self:GetArgs(ConvergeFu.db.profile.versionString, ":")
   local versionName        = Args[1]
   local versionNumber      = Args[2]
   
   myName = UnitName("player")

   messageText = ConvergeFu:ColourTextWhite(myName..": ")
               ..ConvergeFu:ColourTextBlizzard(versionName..":")
               ..ConvergeFu:ColourTextYellow(versionNumber)

   if ConvergeFu.db.profile.versionDispChat == L["common-data-option-one"] then
      self:Print(L["common-separator-dashed-line"])
      self:Print(L["tools-versioncheck-msg-01"])
      self:Print(L["common-separator-dashed-line"])
      self:Print(messageText)
   end

   ConvergeFu.db.profile.versionQuiet = L["common-data-option-zero"]
   
   SendAddonMessage(L["event-addon-vc-query"], myName, channelName)
   
   if versionCheckFrameCreated == L["common-data-option-zero"] then
      ConvergeFu:CreateVersionCheckFrame(sender, versionText)
      versionCheckFrame:PrepareForVersionCheck()
   else
      versionCheckFrame:PrepareForVersionCheck()
   end
   
   if ConvergeFu.db.profile.versionDispWin == L["common-data-option-one"] then
     versionCheckFrame:Show()
   end
      
end

-- ============================================================================
-- == DoUpToDateCheck(channelName)                                           ==
-- ==                                                                        ==
-- == This function sends out a version check request at the noted level of  == 
-- == visibility and reports via chat-window messages if there is anyone     ==
-- == who responds that has a more recent copy of the addon.                 ==
-- ============================================================================

function ConvergeFu:DoUpToDateCheck(channelName)
   
   ConvergeFu:PrepareVersionCheckGroupList()
   
   local Args               = self:GetArgs(ConvergeFu.db.profile.versionString, ":")
   local versionName        = Args[1]
   local versionNumber      = Args[2]
   
   myName = UnitName("player")

   messageText = ConvergeFu:ColourTextYellow(" My Version: ")
               ..ConvergeFu:ColourTextByCharacterClass(myName, myName)
               ..ConvergeFu:ColourTextWhite(" - [")
               ..ConvergeFu:ColourTextBlizzard(versionName..": ")
               ..ConvergeFu:ColourTextWhite(versionNumber)
               ..ConvergeFu:ColourTextWhite("]")

   if ConvergeFu.db.profile.versionDispChat == L["common-data-option-one"] then
      print(L["common-separator-dashed-line"])
      print(L["tools-versioncheck-uptodate-msg-01"])
      print(L["common-separator-dashed-line"])
      print(messageText)
   end

   ConvergeFu.db.profile.versionQuiet = L["common-data-option-one"]
   
   SendAddonMessage(L["event-addon-vc-query"], messageText, channelName)
      
end

-- ============================================================================
-- == PrepareVersionCheckGroupList()                                         ==
-- ==                                                                        ==
-- == This function prepares the version check group list which is used to   ==
-- == help determine which members in a group DO NOT have a copy of          ==
-- == ConvergeFu installed and working correctly.                            ==
-- ============================================================================
function ConvergeFu:PrepareVersionCheckGroupList()

   ConvergeFu.db.profile.vcGroupList   = ""
   ConvergeFu.db.profile.vcLastUpdated = ""
   versionCheckGroupList               = ""
   
   messageText = ConvergeFu:ColourTextPurple(L["tools-versioncheck-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["tools-versioncheck-msg-02"])
   
   
   for i=1, GetNumGroupMembers() do
      
      name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i)
      
      if i > 1 then
         versionCheckGroupList = versionCheckGroupList.."@@@"
      end
      
      versionCheckGroupList = versionCheckGroupList..ConvergeFu:SafeText(name)..":::"..L["common-data-option-unset"]
      
   end
   
   ConvergeFu.db.profile.vcGroupList = versionCheckGroupList
   
   self:Print(messageText)
   
end

-- ============================================================================
-- == UpdateVersionCheckGroupList(characterName, versionNumber)              ==
-- ==                                                                        ==
-- == This function updates the version check group list with the details of ==
-- == the characterName and the version information supplied.                ==
-- ============================================================================

function ConvergeFu:UpdateVersionCheckGroupList(characterName, versionNumber)

   newVersionGroupList = ""
   
   local records = self:GetArgs(ConvergeFu.db.profile.vcGroupList, "@@@")
   -- table.getn(records)
   maxValue = table.getn(records)
   
   for i=1, maxValue ,1  do
      
      local fields = self:GetArgs(records[i], ":::")
      raidCharacterName = ConvergeFu:SafeText(fields[1])
      raidVersionNumber = ConvergeFu:SafeText(fields[2])
   
      if i > 1 then
         newVersionGroupList = newVersionGroupList.."@@@"
      end
      
      if raidCharacterName == characterName then
         newVersionGroupList = newVersionGroupList..characterName..":::"..versionNumber      
      else
         newVersionGroupList = newVersionGroupList..raidCharacterName..":::"..raidVersionNumber
      end
      
   end
   
   ConvergeFu.db.profile.vcGroupList = newVersionGroupList
   
end

-- ============================================================================
-- == ListVersionCheckGroupListUnset(channelName)                            ==
-- ==                                                                        ==
-- == This function lists all those characters that do not appear to have a  ==
-- == copy of ConvergeFu installed to the specified channel.                 ==
-- ============================================================================

function ConvergeFu:ListVersionCheckGroupListUnset(channelName)

   local records = self:GetArgs(ConvergeFu.db.profile.vcGroupList, "@@@")
   unsetMemberFound = L["common-data-option-no"]
   
   ConvergeFu:SendChatMessage(L["tools-versioncheck-msg-first"]..L["tools-versioncheck-msg-03"], channelName)
   
   -- ["tools-versioncheck-msg-04"] 
   maxValue = table.getn(records)
   
   for i=1, maxValue, 1 do
      
      local fields = self:GetArgs(records[i], ":::")
      raidCharacterName = fields[1]
      raidVersionNumber = fields[2]
      
      if raidVersionNumber == L["common-data-option-unset"] then
         unsetMemberFound = L["common-data-option-yes"]
         if raidCharacterName ~= UnitName("player") then
           ConvergeFu:SendChatMessage(L["tools-versioncheck-msg-05"]..raidCharacterName..".", channelName)
         end
      end
   end
   
   if unsetMemberFound == L["common-data-option-no"] then
      ConvergeFu:SendChatMessage(L["tools-versioncheck-msg-04"], channelName)
   end
end

-- ============================================================================
-- == OnTextUpdate()                                                         ==
-- ==                                                                        ==
-- == This function is part of the provided API.                             ==
-- ============================================================================

function ConvergeFu:OnTextUpdate() 
   if (self:IsTextShown()) then 
      self:ShowText(); 
      self:SetText(ConvergeFu:ColourTextWhite(L["labelName"]).."|r"); 
   else 
      self:HideText(); 
   end 
end 

-- ============================================================================
-- == OnTooltipUpdate()                                                      ==
-- ==                                                                        ==
-- == This function is part of the provided API. It is called when the user  ==
-- == action requires the tooltip to be displayed.                           ==
-- ============================================================================

function ConvergeFu:OnTooltipUpdate() 

   cat = Tablet:AddCategory(
     'columns', 1,
     'text', L["tablet-cat-01-title"],
     'textR', 1, 'textG', 1, 'textB', 0
   )
   cat:AddLine('text', L["tablet-cat-01-line-01"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-02"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-03"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-04"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-05"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-06"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-07"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-08"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-09"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-10"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-01-line-11"], 'textR', 1, 'textG', 1, 'textB', 1)
   
   cat = Tablet:AddCategory(
     'columns', 1,
     'text', L["tablet-cat-02-title"],
     'textR', 1, 'textG', 1, 'textB', 0
   )  
   cat:AddLine('text', L["tablet-cat-02-line-01"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-02-line-02"]..ConvergeFu:GetNumberOfGuildOfficers()..L["tablet-cat-02-line-03"], 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-02-line-04"], 'textR', 1, 'textG', 1, 'textB', 1)
   
   ConvergeFu:GetGuildOfficerNamesForTooltip(cat)
   
   cat = Tablet:AddCategory(
     'columns', 1,
     'text', L["tablet-cat-03-title"],
     'textR', 1, 'textG', 1, 'textB', 0
   )    
   cat:AddLine('text', L["tablet-cat-03-line-01"]..UnitName("player"), 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-03-line-02"]..ConvergeFu:GetGuildName(), 'textR', 1, 'textG', 1, 'textB', 1)
   cat:AddLine('text', L["tablet-cat-03-line-03"]..ConvergeFu:GetGuildRankName(), 'textR', 1, 'textG', 1, 'textB', 1)
      
   Tablet:SetHint(L["tabletHint"]); 
end 

-- ============================================================================
-- == OnClick()                                                              ==
-- ==                                                                        ==
-- == This function is part of the provided API. It is called when the user  ==
-- == clicks on the addon's icon.                                            ==
-- ==                                                                        ==
-- == <click>           : Toggle RaidBuffStatus Dashboard.                   ==
-- == <alt><click>      : Toggle Buff Monitor Profile.                       ==
-- == <ctrl><click>     : Toggle the BusyResponder tool on/off.              ==
-- == <ctrl><alt><click : Join Active Raid/Wait-List.                        ==
-- ============================================================================

function ConvergeFu:OnClick()
  if IsAltKeyDown() and IsControlKeyDown() then
    ConvergeFu:CheckCurrentGuildActivityStatus()
    return
  elseif IsAltKeyDown() then
    ConvergeFu:ToggleBuffMonitorProfile()
    return
  elseif IsControlKeyDown() then
    ConvergeFu:ToggleBusyResponder()
    ConvergeFu:BusyResponderStatusUpdated()
    return
  end
  ConvergeFu:ExecuteChatCommand("/rbs toggle")  
end

-- ============================================================================
-- == ExecuteChatCommand(arg)                                                ==
-- ==                                                                        ==
-- == This function attempts to execute the supplied argument as though it   ==
-- == were a command entered by the user in the chat window.                 ==
-- ============================================================================

function ConvergeFu:ExecuteChatCommand(arg)
  if( not DEFAULT_CHAT_FRAME ) then return end
  DEFAULT_CHAT_FRAME.editBox:SetText(arg);
  ChatEdit_SendText(DEFAULT_CHAT_FRAME.editBox);
end

-- ============================================================================
-- == GetGuildName()                                                         ==
-- ==                                                                        ==
-- == This function retrieves the Guild name of the user, if they are in a   ==
-- == guild, otherwise it returns "Unguilded".                               ==
-- ============================================================================

function ConvergeFu:GetGuildName()
  if IsInGuild() then
    local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
    return guildName 
  else
    return L["common-guildname-unguilded"]
  end
end

-- ============================================================================
-- == GetGuildRankName()                                                     ==
-- ==                                                                        ==
-- == This function retrieves the rank name of the user, if they are in a    ==
-- == guild, otherwise it returns "Unranked".                                ==
-- ============================================================================
 
function ConvergeFu:GetGuildRankName()
  if IsInGuild() then
    local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
    return guildRankName  
  else
    return L["common-rankname-unguilded"]
  end
end 

-- ============================================================================
-- == GetNumberOfGuildOfficers()                                             ==
-- ==                                                                        ==
-- == This function looks for characters holding the Officer rank and then   ==
-- == simply performs a count to determine how many such characters there    ==
-- == are.                                                                   ==
-- ============================================================================

function ConvergeFu:GetNumberOfGuildOfficers()
  local numOfficers = 0
  if IsInGuild() then
    for index = 1, (GetNumGuildMembers(true)) do
      name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
      if rank == L["common-rankname-officer"] or rank == L["common-rankname-gm"] or rankIndex == 0 or rankIndex == 1 then
        numOfficers = numOfficers + 1
      end
    end
  end
  return numOfficers
end

-- ============================================================================
-- == GetGuildOfficerNamesForTooltip(cat)                                    ==
-- ==                                                                        ==
-- == This function looks for characters holding the Officer rank and then   ==
-- == adds a line to the provided "Category" object, which simply contains   ==
-- == that officer's name.                                                   ==
-- ============================================================================

function ConvergeFu:GetGuildOfficerNamesForTooltip(cat)
  if IsInGuild() then
    for index = 1, (GetNumGuildMembers(true)) do
      name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
      if rank == L["common-rankname-officer"] or rank == L["common-rankname-gm"] or rankIndex == 0 or rankIndex == 1 then
        cat:AddLine('text', ConvergeFu:FindPlayerByCharacterName(name), 'textR', 1, 'textG', 0, 'textB', 1)
      end
    end 
  end
end

-- ============================================================================
-- == FindPlayerByCharacterName(mainCharacterName)                           ==
-- ==                                                                        ==
-- == This function takes a character name as input and searchs through the  ==
-- == guild's roster, looking to find if the player that owns that character ==
-- == is currently online, either on the character named or on an alt        ==
-- == character associated with the character named.                         ==
-- ==                                                                        ==
-- == This assumes that for a given main character, all associated alt       ==
-- == characters will have the main character's name in the public note      ==
-- == field.                                                                 ==
-- ============================================================================

function ConvergeFu:FindPlayerByCharacterName(characterName)

  characterNameToReturn = characterName.." (Offline)"
  
  totalNumberOfGuildMembers = GetNumGuildMembers(true)
  
  for index=1, totalNumberOfGuildMembers, 1 do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index)
    if name == characterName and online == 1 then
      characterNameToReturn = characterName
    elseif note == characterName and online == 1 then
      characterNameToReturn = name.." (aka: "..characterName..")"
    end
  end
  
  return characterNameToReturn

end

-- ============================================================================
-- == GetSimpleCharacterName(complexCharacterName)                           ==
-- ==                                                                        ==
-- == This function takes a string, typically assumed to be the output of    ==
-- == FindPlayerByCharacterName(mainCharacterName) function and attempts to  ==
-- == simplify it back from the complex form it may hold to the more simple  ==
-- == form.                                                                  ==
-- ==                                                                        ==
-- == Examples of complexCharacterName conversions.                          ==
-- ==                                                                        ==
-- == Broliant (Offline)         -> Broliant                                 ==
-- == Balgardner (aka: Broliant) -> Balgardner                               ==
-- == Broliant                   -> Broliant                                 ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:GetSimpleCharacterName(complexCharacterName)

    if ConvergeFu:IsDebugEnabled() then
       ConvergeFu:Debug("ConvergeFu:GetSimpleCharacterName("..complexCharacterName..")")
    end
    
    if not string.match(complexCharacterName, " ") == nil then
       local Args = self:GetArgs(complexCharacterName, " ")
       ConvergeFu:Debug("Returning: "..Args[1]..".")
       return Args[1]
    else
       ConvergeFu:Debug("Returning: "..complexCharacterName..".")
       return complexCharacterName
    end

end

-- ============================================================================
-- == ListAssociatedCharacters(characterName)                                ==
-- ==                                                                        ==
-- == This function outputs a list of characters associated with a single    ==
-- == player. It takes as input the name of any character associated with    ==
-- == the player who is on the guild roster and it then searches the roster  ==
-- == to find the main and alt characters belonging to the same player.      ==
-- ============================================================================

function ConvergeFu:ListAssociatedCharacters(characterName,channelName)

  strMainCharName = characterName;
  
  if ConvergeFu:IsAltRankedCharacter(characterName) then
    for index = 1, (GetNumGuildMembers(true)) do
      name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
      if name == characterName then
        strMainCharName = note
      end
    end
  end

  ConvergeFu:SendChatMessage("Main: "..strMainCharName, channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    if string.match (note, strMainCharName) ~= nil then
       ConvergeFu:SendChatMessage("Alt : "..name, channelName)
    end
  end  
end

-- ============================================================================
-- == ListAllOfficers()                                                      ==
-- ==                                                                        ==
-- == This function iterates through the roster and lists all characters     ==
-- == holding the "Guild Master" or "Officer" rank.                          ==
-- ============================================================================

function ConvergeFu:ListAllOfficers(channelName)

  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  ConvergeFu:SendChatMessage(L["tools-rank-officer-listall-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if    rank == L["common-rankname-gm"]
       or rank == L["common-rankname-officer"] then
      ConvergeFu:SendChatMessage(" "..name, channelName)
    end
  end
  
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
end

-- ============================================================================
-- == ListAllHeroes()                                                        ==
-- ==                                                                        ==
-- == This function iterates through the roster and lists all characters     ==
-- == holding the "Hero Member" rank.                                        ==
-- ============================================================================

function ConvergeFu:ListAllHeroes(channelName)

  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  ConvergeFu:SendChatMessage(L["tools-rank-hero-listall-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-member-hero"] then
      ConvergeFu:SendChatMessage(" "..name, channelName)
    end
  end
  
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
end

-- ============================================================================
-- == ListAllNormals()                                                       ==
-- ==                                                                        ==
-- == This function iterates through the roster and lists all characters     ==
-- == holding the "Normal Member" rank.                                      ==
-- ============================================================================

function ConvergeFu:ListAllNormals(channelName)

  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  ConvergeFu:SendChatMessage(L["tools-rank-normal-listall-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-member-normal"] then
      ConvergeFu:SendChatMessage(" "..name, channelName)
    end
  end
  
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
end

-- ============================================================================
-- == ListAllTrials()                                                        ==
-- ==                                                                        ==
-- == This function iterates through the roster and lists all characters     ==
-- == holding the "Trial Member" rank.                                       ==
-- ============================================================================

function ConvergeFu:ListAllTrials(channelName)

  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  ConvergeFu:SendChatMessage(L["tools-rank-trial-listall-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-member-trial"] then
      ConvergeFu:SendChatMessage(" "..name, channelName)
    end
  end
  
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
end

-- ============================================================================
-- == ListAllBenched()                                                       ==
-- ==                                                                        ==
-- == This function iterates through the roster and lists all characters     ==
-- == holding the "Benched" rank.                                            ==
-- ============================================================================

function ConvergeFu:ListAllBenched(channelName)

  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  ConvergeFu:SendChatMessage(L["tools-rank-benched-listall-01-msg"] , channelName)
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);

    if rank == L["common-rankname-benched"] then
      ConvergeFu:SendChatMessage(" "..name, channelName)
    end
  end
  
  ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], channelName)
end

-- ============================================================================
-- == GetCharacterRank(characterName)                                        ==
-- ==                                                                        ==
-- == This function gets the rank of a named character.                      ==
-- ============================================================================

function ConvergeFu:GetCharacterRank(characterName)
  characterRank = L["common-rankname-benched"]

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
    if name == characterName then
      characterRank = rank
    end
  end  
  
  return characterRank
end

-- ============================================================================
-- == GetCharacterRankForBidding(characterName)                              ==
-- ==                                                                        ==
-- == This function gets the rank of a named character for the purposes of   ==
-- == bidding on loot. Ostensibly, this means that certain ranks are         ==
-- == returned as other ranks as per the guild's rank based loot priority    ==
-- == system.                                                                ==
-- ============================================================================

function ConvergeFu:GetCharacterRankForBidding(characterName)
  
  characterRank = ConvergeFu:GetCharacterRank(characterName)
  
  if characterRank == L["common-rankname-gm"]
  or characterRank == L["common-rankname-officer"] then
     characterRank = L["common-rankname-member-hero"]
  end
  
  if characterRank == L["common-rankname-alt-officer"] then
     characterRank = L["common-rankname-alt-hero"]
  end
  
  return characterRank
end

-- ============================================================================
-- == GetCorrespondingAltRank(rankName)                                      ==
-- ==                                                                        ==
-- == This function gets the name of the alt rank that corresponds to the    ==
-- == supplied rank name, which is assumed to be the rank of a 'main'        ==
-- == character. If it cannot find the corresponding rank, it returns the    ==
-- == name of the lowest guild rank (the 'benched' rank typically) instead.  ==
-- ============================================================================

function ConvergeFu:GetCorrespondingAltRank(rankName)
  correspondingAltRank = L["common-rankname-benched"] 

  if rankName == L["common-rankname-gm"] then
    correspondingAltRank = L["common-rankname-alt-officer"]
    
  elseif rankName == L["common-rankname-officer"] then
    correspondingAltRank = L["common-rankname-alt-officer"]
    
  elseif rankName == L["common-rankname-member-hero"] then
    correspondingAltRank = L["common-rankname-alt-hero"]
    
  elseif rankName == L["common-rankname-member-normal"] then
    correspondingAltRank = L["common-rankname-alt-normal"]
    
  elseif rankName == L["common-rankname-member-trial"] then
    correspondingAltRank = L["common-rankname-alt-trial"]
  end
  
  return correspondingAltRank
end

-- ============================================================================
-- == IsMainRankedCharacter(characterName)                                   ==
-- ==                                                                        ==
-- == This function determines whether a named character is a 'main' ranked  ==
-- == character and returns true if it is, otherwise it returns false.       ==
-- ==                                                                        ==
-- == A specific set of main-class ranks are assumed due to there being      ==
-- == no exacting method to check for "main status" in the provided API      ==
-- == from Blizzard, presumably because the concept of "main status" is not  ==
-- == fixed.                                                                 ==
-- ============================================================================

function ConvergeFu:IsMainRankedCharacter(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    mainName, mainRank, mainRankIndex, mainLevel, mainClass, mainZone, mainNote, mainOfficernote, mainOnline, mainStatus = GetGuildRosterInfo(index);
    if mainName == characterName then
      if    mainRank == L["common-rankname-gm"]
         or mainRank == L["common-rankname-officer"]
         or mainRank == L["common-rankname-member-hero"]
         or mainRank == L["common-rankname-member-normal"]
         or mainRank == L["common-rankname-member-trial"] then
        return true
      end
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsAltRankedCharacter(characterName)                                    ==
-- ==                                                                        ==
-- == This function determines whether the named character is an 'alt'       ==
-- == ranked character and returns true if it is, otherwise it returns false.==
-- ==                                                                        ==
-- == A specific set of alt-class ranks are assumed due to there being       ==
-- == no exacting method to check for "alt status" in the provided API       ==
-- == from Blizzard, presumably because the concept of "alt status" is not   ==
-- == fixed.                                                                 ==
-- ============================================================================

function ConvergeFu:IsAltRankedCharacter(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    altName, altRank, altRankIndex, altLevel, altClass, altZone, altNote, altOfficernote, altOnline, altStatus = GetGuildRosterInfo(index);
    if altName == characterName then
      if    altRank == L["common-rankname-alt-officer"]
         or altRank == L["common-rankname-alt-hero"]
         or altRank == L["common-rankname-alt-normal"]
         or altRank == L["common-rankname-alt-trial"] then
        return true
      end
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsOfficerRankedCharacter(characterName)                                ==
-- ==                                                                        ==
-- == This function determines whether the named character is an 'officer'   ==
-- == ranked character and returns true if it is, otherwise it returns false.==
-- ==                                                                        ==
-- == A specific set of officer-class ranks are assumed due to there being   ==
-- == no exacting method to check for "officer status" in the provided API   ==
-- == from Blizzard, presumably because the concept of "officer status" is   ==
-- == not fixed.                                                             ==
-- ============================================================================

function ConvergeFu:IsOfficerRankedCharacter(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    officerName, officerRank, officerRankIndex, officerLevel, officerClass, officerZone, officerNote, officerOfficernote, officerOnline, officerStatus = GetGuildRosterInfo(index);
    if officerName == characterName then
      if    officerRank == L["common-rankname-gm"]
         or officerRank == L["common-rankname-officer"]
         or officerRank == L["common-rankname-alt-officer"] then
        return true
      end
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsHeroRankedCharacter(characterName)                                   ==
-- ==                                                                        ==
-- == This function determines whether the named character is a 'hero'       ==
-- == ranked character and returns true if it is, otherwise it returns false.==
-- ==                                                                        ==
-- == A specific set of hero-class ranks are assumed due to there being      ==
-- == no exacting method to check for "hero status" in the provided API      ==
-- == from Blizzard, presumably because the concept of "alt status" is not   ==
-- == fixed.                                                                 ==
-- ============================================================================

function ConvergeFu:IsHeroRankedCharacter(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    heroName, heroRank, heroRankIndex, heroLevel, heroClass, heroZone, heroNote, heroOfficernote, heroOnline, heroStatus = GetGuildRosterInfo(index);
    if heroName == characterName then
      if    heroRank == L["common-rankname-member-hero"]
         or heroRank == L["common-rankname-alt-hero"] then
        return true
      end
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsNormalRankedCharacter(characterName)                                 ==
-- ==                                                                        ==
-- == This function determines whether the named character is a 'normal'     ==
-- == ranked character and returns true if it is, otherwise it returns false.==
-- ==                                                                        ==
-- == A specific set of normal-class ranks are assumed due to there being    ==
-- == no exacting method to check for "normal status" in the provided API    ==
-- == from Blizzard, presumably because the concept of "alt status" is not   ==
-- == fixed.                                                                 ==
-- ============================================================================

function ConvergeFu:IsNormalRankedCharacter(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    normalName, normalRank, normalRankIndex, normalLevel, normalClass, normalZone, normalNote, normalOfficernote, normalOnline, normalStatus = GetGuildRosterInfo(index);
    if normalName == characterName then
      if    normalRank == L["common-rankname-member-normal"]
         or normalRank == L["common-rankname-alt-normal"] then
        return true
      end
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsTrialRankedCharacter(characterName)                                  ==
-- ==                                                                        ==
-- == This function determines whether the named character is a 'trial'      ==
-- == ranked character and returns true if it is, otherwise it returns false.==
-- ==                                                                        ==
-- == A specific set of trial-class ranks are assumed due to there being     ==
-- == no exacting method to check for "trial status" in the provided API     ==
-- == from Blizzard, presumably because the concept of "alt status" is not   ==
-- == fixed.                                                                 ==
-- ============================================================================

function ConvergeFu:IsTrialRankedCharacter(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    trialName, trialRank, trialRankIndex, trialLevel, trialClass, trialZone, trialNote, trialOfficernote, trialOnline, trialStatus = GetGuildRosterInfo(index);
    if trialName == characterName then
      if    trialRank == L["common-rankname-member-trial"]
         or trialRank == L["common-rankname-alt-trial"] then
        return true
      end
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsCharacterInGuild(characterName)                                      ==
-- ==                                                                        ==
-- == This function determines whether the named character is in the same    ==
-- == guild as the person running ConvergeFu.                                ==
-- ============================================================================

function ConvergeFu:IsCharacterInGuild(characterName)
  
  for index = 1, (GetNumGuildMembers(true)) do
    guildName, guildRank, guildRankIndex, guildLevel, guildClass, guildZone, guildNote, guildfOfficernote, guildOnline, guildStatus = GetGuildRosterInfo(index);
    if guildName == characterName then
      return true
    end
  end   
  
  return false  
end

-- ============================================================================
-- == IsCharacterInParty(characterName)                                      ==
-- ==                                                                        ==
-- == This function determines whether the named character is in the same    ==
-- == party as the person running ConvergeFu.                                ==
-- ============================================================================

function ConvergeFu:IsCharacterInParty(characterName)
  
  if UnitInParty(characterName) then
     return true
  end
  
  return false  
end

-- ============================================================================
-- == IsCharacterInRaid(characterName)                                       ==
-- ==                                                                        ==
-- == This function determines whether the named character is in the same    ==
-- == raid as the person running ConvergeFu.                                 ==
-- ============================================================================

function ConvergeFu:IsCharacterInRaid(characterName)
  
  if UnitInRaid(characterName) then
     return true
  end
  
  return false  
end

-- ============================================================================
-- == IsCharacterAFriend(characterName)                                      ==
-- ==                                                                        ==
-- == This function determines whether the named character is a friend of    ==
-- == the person running ConvergeFu.                                         ==
-- ============================================================================

function ConvergeFu:IsCharacterAFriend(characterName)
  
  local numFriends = GetNumFriends()
  local name, level, class, zone, online, status, note
  
  for i = 1, numFriends, 1 do
    name, level, class, zone, online, status, note = GetFriendInfo(i)
    if online then
      if name == characterName then
        return true
      end
    end
  end 
  
  return false  
end

-- ============================================================================
-- == SendChatMessage(messageText, channelName)                              ==
-- ==                                                                        ==
-- == This function is ostensibly a simpler wrapper to the more featureful   ==
-- == SendMessage function, this version ignores the language and recipient  ==
-- == parameters.
-- ============================================================================

function ConvergeFu:SendChatMessage(messageText, channelName)
  
  -- == -----------------------------------------------------------------------
  -- == -- Send chat output to 'chat' or to intended channel if not 'NULL'.  --
  -- == -----------------------------------------------------------------------  
  if channelName == "CHAT" then
     self:Print(messageText)
  else
     ConvergeFu:SendMessage(messageText, channelName, " ", " ")
  end
  
end

-- ============================================================================
-- == ConvergeFu:SendMessage(messageText, channelName, language, recipient)  ==
-- ==                                                                        ==
-- == This function is ostensibly a wrapper to the normal SendChatMessage    ==
-- == function with minor changes as follows:                                ==
-- ==                                                                        ==
-- == 1: Language is checked because it may not be passed in.                ==
-- == 2: If channelName = "CHAT", output is routed to self:Print() instead.  ==
-- == 3: If channelName = "NULL", output is muted.                           ==
-- ==                                                                        ==
-- == The intention for the existence of the NULL option for the channel     ==
-- == name is to allow for functions to pass a parameter that can be         ==
-- == switched between a normal channel and null to turn on/off debug mode   ==
-- == features.                                                              ==
-- ============================================================================

function ConvergeFu:SendMessage(messageText, channelName, language, recipient)
  
  -- == -----------------------------------------------------------------------
  -- == -- Check whether the language option has been provided.              --
  -- == -----------------------------------------------------------------------
  if language == nil or language == " " then
    language = nil
  end
  
  channelName = ConvergeFu:SafeChatChannelName(channelName)

  -- == -----------------------------------------------------------------------
  -- == -- Send chat output to 'chat' or to intended channel if not 'NULL'.  --
  -- == -----------------------------------------------------------------------  
  if channelName == "CHAT" then
     print(messageText)
  elseif channelName ~= "NULL" then
     SendChatMessage(messageText, channelName, language, recipient)
  end
  
end

-- ============================================================================
-- == ConvergeFu:SafeChatChannelName(channelName)                            ==
-- ==                                                                        ==
-- == This function simply checks that the supplied channelName parameter    ==
-- == would be safe to use in the context of this user. If the name would be ==
-- == considered unsafe, a safe alternative is substituted.                  ==
-- ============================================================================

function ConvergeFu:SafeChatChannelName(channelName)

  -- == -----------------------------------------------------------------------
  -- == -- Setup variables that will be needed.                              --
  -- == -----------------------------------------------------------------------
  --  local playerName = UnitName("player")
  
  -- == -----------------------------------------------------------------------
  -- == -- [GUILD] Checks...                                                 --
  -- == -----------------------------------------------------------------------
  if channelName == "GUILD" then
     if not IsInGuild() then
        channelName = "CHAT"
     end
  end
  
  -- == -----------------------------------------------------------------------
  -- == -- [RAID] Checks...                                                  --
  -- == -----------------------------------------------------------------------
  if channelName == "RAID" then
     if UnitInRaid(playerName) == -1 then
        channelName = "PARTY"
        print("channelName set to Party")
     end
  end
  
  -- == -----------------------------------------------------------------------
  -- == -- [PARTY] Checks...                                                 --
  -- == -----------------------------------------------------------------------
  if channelName == "PARTY" then
     if UnitInParty(playerName) == -1 then
        channelName = "CHAT"
        print("channelName set to Chat")
     end
  end
  
  -- == -----------------------------------------------------------------------
  -- == -- Return the value, adjusted or otherwise, of channelName.          --
  -- == -----------------------------------------------------------------------  
  return channelName
  
end



-- ============================================================================
-- == ShowAvoidanceForLevel70Rogues()                                        ==
-- ==                                                                        ==
-- == Simply outputs some text to the default chat frame listing the         ==
-- == player's current 'avoidance' level. This version is configured for use ==
-- == by rogues and will not produce accurate values for other classes.      ==
-- ============================================================================

function ConvergeFu:ShowAvoidanceForLevel70Rogues()

  DEFAULT_CHAT_FRAME:AddMessage(L["tools-misc-rogueav-01-msg"],0.8,0.8,1)
  DEFAULT_CHAT_FRAME:AddMessage(GetDodgeChance()+GetParryChance()+12+(GetCombatRating(CR_DEFENSE_SKILL)*150/355)*0.04,1,0.5,0)

end

-- ============================================================================
-- == AnnounceRankChanges(channelName)                                       ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "Guild") to inform players that the   ==
-- == month end processing to update the players that are awarded the hero   ==
-- == status is about to begin.                                              ==
-- ============================================================================

function ConvergeFu:AnnounceRankChanges(channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-02-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-03-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-04-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-05-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-06-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-07-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-08-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-09-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-10-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-11-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-12-msg"], channelName)
  ConvergeFu:SendChatMessage(L["common-rankchange-announce-13-msg"], channelName)
end

-- ============================================================================
-- == AnnounceRaidInvite(officerName,channelName)                            ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "Guild") to inform players that the   ==
-- == invitation period for the next raid has begun and that players should  ==
-- == whisper the character indicated to get an invitation to the raid.      ==
-- ============================================================================

function ConvergeFu:AnnounceRaidInvite(character,channelName)

  strCharacterName = ConvergeFu:FindPlayerByCharacterName(character)
  simpleName       = ConvergeFu:GetSimpleCharacterName(strCharacterName)
  
  strGMOTD = L["common-motd-raidinvites-01"]
          .. strCharacterName
          .. L["common-motd-raidinvites-02"]
          
  ConvergeFu:SetGuildMessageOfTheDay(strGMOTD)
  
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-02-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-03-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-04-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-05-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-06-msg"], channelName)
          
  ConvergeFu:SendChatMessage(" "..strCharacterName, channelName)

  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-07-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-08-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-09-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-raid-invite-10-msg"], channelName)
  
  if ConvergeFu.db.profile.sendRaidInvitations == L["common-data-option-on"] then
     ConvergeFu:SendRCPMessage(L["event-rcp-ras-off"], "RAID")
     SendAddonMessage(L["event-addon-raid-invitation-announce"], simpleName, "GUILD")
  end
  
end

-- ============================================================================
-- == AnnounceWaitList(officerName,channelName)                              ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "Guild") to inform players that the   ==
-- == invitation period for the next raid has closed but that the wait list  ==
-- == is now open and that they should whisper a named officer if they wish  ==
-- == to join the raid's wait list (queue).                                  ==
-- ============================================================================

function ConvergeFu:AnnounceWaitList(officerName,channelName)
  
  strOfficerName = ConvergeFu:FindPlayerByCharacterName(officerName)
  
  strGMOTD = L["common-motd-raidinprogress-01"]
          .. strOfficerName
          .. L["common-motd-raidinprogress-02"]
          
  ConvergeFu:SetGuildMessageOfTheDay(strGMOTD)
  
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-02-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-03-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-04-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-05-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-06-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-07-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-08-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-09-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-10-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-11-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-12-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-13-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-14-msg"], channelName)
  
  ConvergeFu:SendChatMessage(" "..strOfficerName, channelName)
  
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-15-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-guild-wait-list-16-msg"], channelName)
end

-- ============================================================================
-- == AnnounceRaidEnd(channelName)                                           ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "RAID") to inform players that the    ==
-- == raid has now ended.                                                    ==
-- ============================================================================

function ConvergeFu:AnnounceRaidEnd(channelName)
  
  strGMOTD = L["common-motd-raidended-01"]
          
  ConvergeFu:SetGuildMessageOfTheDay(strGMOTD)
  
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-02-msg"], "RAID_WARNING")
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-04-msg"], "RAID_WARNING")
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-10-msg"], "RAID_WARNING")
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-12-msg"], "RAID_WARNING")

  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-01-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-02-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-03-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-04-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-05-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-06-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-07-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-08-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-09-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-10-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-11-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-12-msg"], channelName)
  ConvergeFu:SendChatMessage(L["ann-raid-raid-end-13-msg"], channelName)

  ConvergeFu:BroadcastRaidEnd()
  
end

-- ============================================================================
-- == BroadcastRaidEnd()                                                     ==
-- ==                                                                        ==
-- == This function broadcasts the raid-end notification to all members of   ==
-- == the guild, allowing their copies of ConvergeFu to reset their internal ==
-- == settings until the next raid is announced.                             ==
-- ============================================================================

function ConvergeFu:BroadcastRaidEnd()

   SendAddonMessage(L["event-addon-raid-end-announce"], UnitName("player"), "GUILD")

end

-- ============================================================================
-- == AnnounceCrowdControlTargets(channelName, sender)                       ==
-- ==                                                                        ==
-- == This function outputs an announcement in the channel specified by the  ==
-- == channelName parameter (typically "RAID") to inform players of the      ==
-- == crowd control target responsibilities that have been setup.            ==
-- ============================================================================

function ConvergeFu:AnnounceCrowdControlTargets(channelName, sender)

  countNumberSetup = 0
  
  ConvergeFu:SendMessage(L["tools-crowd-control-announce-01-msg"], channelName, nil, sender)
  ConvergeFu:SendMessage(L["tools-crowd-control-announce-02-msg"], channelName, nil, sender)
  ConvergeFu:SendMessage(L["tools-crowd-control-announce-03-msg"], channelName, nil, sender)
  
  if ConvergeFu.db.profile.skullType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-04-msg"]..ConvergeFu.db.profile.skullType.." - "..ConvergeFu.db.profile.skullName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.crossType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-05-msg"]..ConvergeFu.db.profile.crossType.." - "..ConvergeFu.db.profile.crossName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.squareType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-06-msg"]..ConvergeFu.db.profile.squareType.." - "..ConvergeFu.db.profile.squareName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.moonType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-07-msg"]..ConvergeFu.db.profile.moonType.." - "..ConvergeFu.db.profile.moonName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.triangleType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-08-msg"]..ConvergeFu.db.profile.triangleType.." - "..ConvergeFu.db.profile.triangleName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.diamondType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-09-msg"]..ConvergeFu.db.profile.diamondType.." - "..ConvergeFu.db.profile.diamondName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.circleType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-10-msg"]..ConvergeFu.db.profile.circleType.." - "..ConvergeFu.db.profile.circleName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end

  if ConvergeFu.db.profile.starType ~= L["tools-crowd-control-type-none"] then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-11-msg"]..ConvergeFu.db.profile.starType.." - "..ConvergeFu.db.profile.starName, channelName, nil, sender)
    countNumberSetup = countNumberSetup + 1
  end
  
  if countNumberSetup == 0 then
    ConvergeFu:SendMessage(L["tools-crowd-control-announce-12-msg"], channelName, nil, sender)
  end
  
  ConvergeFu:SendMessage(L["tools-crowd-control-announce-13-msg"], channelName, nil, sender)

end

-- ============================================================================
-- == GetCharacterClass(characterName)                                       ==
-- ==                                                                        ==
-- == This function returns the name of the class corresponding to the name  ==
-- == of the character supplied or it returns a default value if the class   ==
-- == cannot be determined. (eg: when an invalid name is supplied.)          ==
-- ============================================================================

function ConvergeFu:GetCharacterClass(characterName)

   if characterName == L["tools-crowd-control-common-clear-name-unset"] then
      return L["tools-crowd-control-common-clear-class-unset"]
   end
   
   localizedClass, englishClass = UnitClass(characterName)
   
   if localizedClass == nil then
      localizedClass = L["tools-crowd-control-classtype-unknown"]
   end
   
   return localizedClass

end

-- ============================================================================
-- == GetCCTypeByClass(classType)                                            ==
-- ==                                                                        ==
-- == This function returns the name the standard crowd-control type for a   ==
-- == given class.                                                           ==
-- ============================================================================

function ConvergeFu:GetCCTypeByClass(classType)

   ccType = L["tools-crowd-control-type-none"]
   
   if classType == L["tools-crowd-control-common-clear-class-unset"] then
      ccType = L["tools-crowd-control-type-none"]
   end

   if classType == L["common-data-class-name-death-knight"] then
      ccType = ConvergeFu.db.profile.defaultCCDeathKnight      
   elseif classType == L["common-data-class-name-druid"] then
      ccType = ConvergeFu.db.profile.defaultCCDruid
   elseif classType == L["common-data-class-name-mage"] then
      ccType = ConvergeFu.db.profile.defaultCCMage
   elseif classType == L["common-data-class-name-hunter"] then
      ccType = ConvergeFu.db.profile.defaultCCHunter
   elseif classType == L["common-data-class-name-paladin"] then
      ccType = ConvergeFu.db.profile.defaultCCPaladin
   elseif classType == L["common-data-class-name-priest"] then
      ccType = ConvergeFu.db.profile.defaultCCPriest
   elseif classType == L["common-data-class-name-rogue"] then
      ccType = ConvergeFu.db.profile.defaultCCRogue
   elseif classType == L["common-data-class-name-shaman"] then
      ccType = ConvergeFu.db.profile.defaultCCShaman
   elseif classType == L["common-data-class-name-warlock"] then
      ccType = ConvergeFu.db.profile.defaultCCWarlock
   elseif classType == L["common-data-class-name-warrior"] then
      ccType = ConvergeFu.db.profile.defaultCCWarrior      
   end

   return ccType
   
end


-- ============================================================================
-- == CCTakeMyTarget()                                                       ==
-- ==                                                                        ==
-- == This function attempts to return the name of your current target for   ==
-- == the purposes of assigning this name to a CC target icon. If you do not ==
-- == currently have a target, it returns <unset>                            ==
-- ============================================================================

function ConvergeFu:CCTakeMyTarget()

   ccOwnerName = UnitName("target")
   
   if ccOwnerName == nil then
      ccOwnerName = L["tools-crowd-control-common-clear-name-unset"]
   end
   
   return ccOwnerName
   
end

-- ============================================================================
-- == AutoSetCCTypes()                                                       ==
-- ==                                                                        ==
-- == This function attempts to autoset the crowd-control types based on the ==
-- == names set in the corresponding cc-names fields.                        ==
-- ============================================================================

function ConvergeFu:AutoSetCCTypes()

   messageString = ConvergeFu:ColourTextPurple(L["tools-crowd-control-autoset-msg-first"])
                 ..ConvergeFu:ColourTextWhite(L["tools-crowd-control-autoset-msg-01"])
   
   ConvergeFu.db.profile.skullType    = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.skullName))
   ConvergeFu.db.profile.crossType    = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.crossName))
   ConvergeFu.db.profile.squareType   = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.squareName))
   ConvergeFu.db.profile.moonType     = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.moonName))
   ConvergeFu.db.profile.triangleType = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.triangleName))
   ConvergeFu.db.profile.diamondType  = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.diamondName))
   ConvergeFu.db.profile.circleType   = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.circleName))
   ConvergeFu.db.profile.starType     = ConvergeFu:GetCCTypeByClass(ConvergeFu:GetCharacterClass(ConvergeFu.db.profile.starName))

   ConvergeFu:AnnounceCrowdControlTargets("CHAT")
   self:Print(messageString)
end

-- ============================================================================
-- == ClearAllCCSettings()                                                   ==
-- ==                                                                        ==
-- == This function clears all the current CC settings.                      ==
-- ============================================================================

function ConvergeFu:ClearAllCCSettings()

   ConvergeFu.db.profile.skullType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.skullName = L["tools-crowd-control-common-clear-name-default"]
   ConvergeFu.db.profile.crossType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.crossName = L["tools-crowd-control-common-clear-name-default"]
   ConvergeFu.db.profile.squareType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.squareName = L["tools-crowd-control-common-clear-name-default"]
   ConvergeFu.db.profile.moonType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.moonName = L["tools-crowd-control-common-clear-name-default"]
   ConvergeFu.db.profile.triangleType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.triangleName = L["tools-crowd-control-common-clear-name-default"]   
   ConvergeFu.db.profile.diamondType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.diamondName = L["tools-crowd-control-common-clear-name-default"]   
   ConvergeFu.db.profile.circleType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.circleName = L["tools-crowd-control-common-clear-name-default"]
   ConvergeFu.db.profile.starType = L["tools-crowd-control-common-clear-type-default"]
   ConvergeFu.db.profile.starName = L["tools-crowd-control-common-clear-name-default"]

   clearedAllText = ConvergeFu:ColourTextPurple(L["tools-crowd-control-autoset-msg-first"])
                  ..ConvergeFu:ColourTextWhite(L["tools-crowd-control-clearall-msg-01"])

   self:Print(clearedAllText)

end

-- ============================================================================
-- == DoBroadcastCCTargets(channelName)                                      ==
-- ==                                                                        ==
-- == This function outputs a series of inter-addon messages to broadcast    ==
-- == the user's currently configured CC targets to all other users of       ==
-- == ConvergeFu that are listening on the given channel. (Typically RAID)   ==
-- ==                                                                        ==
-- == Broadcast Message Structure:                                           ==
-- ==                                                                        ==
-- == Prefix....: "CFUCCU"                                                   ==
-- == Message...: "skullName:::skullType:::...:::starName:::starType"        ==
-- == Example...: "Epidemic:::Tank:::...:::Broliant:::Sap"                   ==
-- ============================================================================

function ConvergeFu:DoBroadcastCCTargets(channelName)

   separator = ":::"
   myName    = UnitName("player")

   ConvergeFu:CleanseCCTargets()
   
   skullMessage    = ConvergeFu.db.profile.skullName..separator..ConvergeFu.db.profile.skullType                
   crossMessage    = ConvergeFu.db.profile.crossName..separator..ConvergeFu.db.profile.crossType                
   squareMessage   = ConvergeFu.db.profile.squareName..separator..ConvergeFu.db.profile.squareType                
   moonMessage     = ConvergeFu.db.profile.moonName..separator..ConvergeFu.db.profile.moonType                
   triangleMessage = ConvergeFu.db.profile.triangleName..separator..ConvergeFu.db.profile.triangleType                
   diamondMessage  = ConvergeFu.db.profile.diamondName..separator..ConvergeFu.db.profile.diamondType                
   circleMessage   = ConvergeFu.db.profile.circleName..separator..ConvergeFu.db.profile.circleType                
   starMessage     = ConvergeFu.db.profile.starName..separator..ConvergeFu.db.profile.starType    
   
   combinedMessage = skullMessage
                   ..separator
                   ..crossMessage
                   ..separator
                   ..squareMessage
                   ..separator
                   ..moonMessage
                   ..separator
                   ..triangleMessage
                   ..separator
                   ..diamondMessage
                   ..separator
                   ..circleMessage
                   ..separator
                   ..starMessage

   SendAddonMessage(L["event-addon-cc-update"], combinedMessage, channelName)

   messageText1 = ConvergeFu:ColourTextPurple(L["tools-crowd-control-autoset-msg-first"])
   messageText2 = ConvergeFu:ColourTextWhite(L["tools-crowd-control-broadcast-msg-01"]..channelName..".")
   
   self:Print(messageText1..messageText2)
   
end

-- ============================================================================
-- == CleanseCCTargets()                                                     ==
-- ==                                                                        ==
-- == This function cleanses the CC target data, replacing values known to   ==
-- == problematic or unacceptable with standard default values.              ==
-- ============================================================================

function ConvergeFu:CleanseCCTargets()

   ConvergeFu.db.profile.skullName      = ConvergeFu:SafeCCName(ConvergeFu.db.profile.skullName)
   ConvergeFu.db.profile.skullType      = ConvergeFu:SafeCCType(ConvergeFu.db.profile.skullType)
   ConvergeFu.db.profile.crossName      = ConvergeFu:SafeCCName(ConvergeFu.db.profile.crossName)
   ConvergeFu.db.profile.crossType      = ConvergeFu:SafeCCType(ConvergeFu.db.profile.crossType)
   ConvergeFu.db.profile.squareName     = ConvergeFu:SafeCCName(ConvergeFu.db.profile.squareName)
   ConvergeFu.db.profile.squareType     = ConvergeFu:SafeCCType(ConvergeFu.db.profile.squareType)
   ConvergeFu.db.profile.moonName       = ConvergeFu:SafeCCName(ConvergeFu.db.profile.moonName)
   ConvergeFu.db.profile.moonType       = ConvergeFu:SafeCCType(ConvergeFu.db.profile.moonType)
   ConvergeFu.db.profile.triangleName   = ConvergeFu:SafeCCName(ConvergeFu.db.profile.triangleName)
   ConvergeFu.db.profile.triangleType   = ConvergeFu:SafeCCType(ConvergeFu.db.profile.triangleType)
   ConvergeFu.db.profile.diamondName    = ConvergeFu:SafeCCName(ConvergeFu.db.profile.diamondName)
   ConvergeFu.db.profile.diamondType    = ConvergeFu:SafeCCType(ConvergeFu.db.profile.diamondType)
   ConvergeFu.db.profile.circleName     = ConvergeFu:SafeCCName(ConvergeFu.db.profile.circleName)
   ConvergeFu.db.profile.circleType     = ConvergeFu:SafeCCType(ConvergeFu.db.profile.circleType)
   ConvergeFu.db.profile.starName       = ConvergeFu:SafeCCName(ConvergeFu.db.profile.starName)
   ConvergeFu.db.profile.starType       = ConvergeFu:SafeCCType(ConvergeFu.db.profile.starType)   

end

-- ============================================================================
-- == SafeCCName(unsafeCCName)                                               ==
-- ==                                                                        ==
-- == This function ensures that the CC name value is considered safe.       ==
-- ============================================================================

function ConvergeFu:SafeCCName(unsafeCCName)

   if unsafeCCName == nil
   or unsafeCCName == "" then
      return L["tools-crowd-control-common-clear-name-default"]
   end
   
   return unsafeCCName

end

-- ============================================================================
-- == SafeCCType(unsafeCCType)                                               ==
-- ==                                                                        ==
-- == This function ensures that the CC type value is considered safe.       ==
-- ============================================================================

function ConvergeFu:SafeCCType(unsafeCCType)

   if unsafeCCType == nil
   or unsafeCCType == "" then
      return L["tools-crowd-control-common-clear-type-default"]
   end
   
   return unsafeCCType
   
end


-- ============================================================================
-- == DoProcessCCUpdateMessage(msg, channel, sender)                         ==
-- ==                                                                        ==
-- == This function processes a received CC (ie: Crowd Control) update       ==
-- == message. The message should have the format described below and it is  ==
-- == therefore quite simple to unpack the message and then update the       ==
-- == corresponding raid symbol attributes with the supplied data.           ==
-- ==                                                                        ==
-- == Broadcast Message Structure:                                           ==
-- ==                                                                        ==
-- == Prefix....: "CFUCCU"                                                   ==
-- == Message...: "skullName:::skullType:::...:::starName:::starType"        ==
-- == Example...: "Epidemic:::Tank:::...:::Broliant:::Sap"                   ==
-- ============================================================================

function ConvergeFu:DoProcessCCUpdateMessage(msg, channel, sender)

   myName = UnitName("player")
   
   if sender == myName then
      return
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Decode the message text into its component parts.                --
   -- == ----------------------------------------------------------------------
   local Args                           = self:GetArgs(msg, ":::")
   ConvergeFu.db.profile.skullName      = Args[1]
   ConvergeFu.db.profile.skullType      = Args[2]
   ConvergeFu.db.profile.crossName      = Args[3]
   ConvergeFu.db.profile.crossType      = Args[4]
   ConvergeFu.db.profile.squareName     = Args[5]
   ConvergeFu.db.profile.squareType     = Args[6]
   ConvergeFu.db.profile.moonName       = Args[7]
   ConvergeFu.db.profile.moonType       = Args[8]
   ConvergeFu.db.profile.triangleName   = Args[9]
   ConvergeFu.db.profile.triangleType   = Args[10]
   ConvergeFu.db.profile.diamondName    = Args[11]
   ConvergeFu.db.profile.diamondType    = Args[12]
   ConvergeFu.db.profile.circleName     = Args[13]
   ConvergeFu.db.profile.circleType     = Args[14]
   ConvergeFu.db.profile.starName       = Args[15]
   ConvergeFu.db.profile.starType       = Args[16]

   messageText1 = ConvergeFu:ColourTextPurple(L["tools-crowd-control-autoset-msg-first"])
   messageText2 = ConvergeFu:ColourTextWhite(L["tools-crowd-control-update-msg-01"])
   messageText3 = ConvergeFu:ColourTextGreen(sender)
   messageText4 = ConvergeFu:ColourTextWhite(".")
                  
   self:Print(messageText1..messageText2..messageText3..messageText4)

end

-- ============================================================================
-- == GetSpecialMenu()                                                       ==
-- ==                                                                        ==
-- == This function is a work-in-progress. For now, it should be paid little ==
-- == heed and unscrupulously ignored, except where circumstance and urgent  ==
-- == necessity demand otherwise.                                            ==
-- ============================================================================

function ConvergeFu:GetSpecialMenu()
  return { 
    threat = { 
       name = L["ann-say-threat-title"], 
       desc = L["ann-say-threat-descr"], 
       type = 'execute', 
       func = function() ConvergeFu:SendChatMessage(L["ann-say-threat-msg"], "SAY") end
    }
  }
end

-- ============================================================================
-- == ColourTextRed(text)                                                    ==
-- ==                                                                        ==
-- == This function simply colours text in red.                              ==
-- ============================================================================

function ConvergeFu:ColourTextRed(text)
   return "|cffff0000"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextGreen(text)                                                  ==
-- ==                                                                        ==
-- == This function simply colours text in green.                            ==
-- ============================================================================

function ConvergeFu:ColourTextGreen(text)
   return "|cff00ff00"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextBlue(text)                                                   ==
-- ==                                                                        ==
-- == This function simply colours text in blue.                             ==
-- ============================================================================

function ConvergeFu:ColourTextBlue(text)
   return "|cff0000ff"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextWhite(text)                                                  ==
-- ==                                                                        ==
-- == This function simply colours text in white.                            ==
-- ============================================================================

function ConvergeFu:ColourTextWhite(text)
   return "|cffffffff"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextYellow(text)                                                 ==
-- ==                                                                        ==
-- == This function simply colours text in yellow.                           ==
-- ============================================================================

function ConvergeFu:ColourTextYellow(text)
   return "|cffffff00"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextPurple(text)                                                 ==
-- ==                                                                        ==
-- == This function simply colours text in purple.                           ==
-- ============================================================================

function ConvergeFu:ColourTextPurple(text)
   return "|cffff00ff"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextBlizzard(text)                                               ==
-- ==                                                                        ==
-- == This function simply colours text in Blizzard blue.                    ==
-- ============================================================================

function ConvergeFu:ColourTextBlizzard(text)
   return "|cff00c0ff"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextStory(text)                                                  ==
-- ==                                                                        ==
-- == This function simply colours text used to display "Story" content in   ==
-- == the chat window. (eg: Instance welcome text.)                          ==
-- ============================================================================

function ConvergeFu:ColourTextStory(text)
   return "|cffecd672"..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourTextByCharacterClass(text, characterName)                        ==
-- ==                                                                        ==
-- == This function simply colours text according to the class of the        ==
-- == supplied characterName parameter.                                      ==
-- ============================================================================

function ConvergeFu:ColourTextByCharacterClass(text, characterName)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine the classType from the characterName parameter.        --
   -- == ----------------------------------------------------------------------
   classType = UnitClass(characterName)
   if classType == nil then
      classType = L["common-data-option-unset"]
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine the correct color to apply to the text.                --
   -- == ----------------------------------------------------------------------
   classColour = "|cffffffff"
   if classType == L["common-data-class-name-death-knight"] then
      classColour = L["common-data-class-colour-death-knight"]
   elseif classType == L["common-data-class-name-druid"] then
      classColour = L["common-data-class-colour-druid"]
   elseif classType == L["common-data-class-name-hunter"] then
      classColour = L["common-data-class-colour-hunter"]
   elseif classType == L["common-data-class-name-mage"] then
      classColour = L["common-data-class-colour-mage"]
   elseif classType == L["common-data-class-name-paladin"] then
      classColour = L["common-data-class-colour-paladin"]
   elseif classType == L["common-data-class-name-priest"] then
      classColour = L["common-data-class-colour-priest"]
   elseif classType == L["common-data-class-name-rogue"] then
      classColour = L["common-data-class-colour-rogue"]
   elseif classType == L["common-data-class-name-shaman"] then
      classColour = L["common-data-class-colour-shaman"]
   elseif classType == L["common-data-class-name-warlock"] then
      classColour = L["common-data-class-colour-warlock"]
   elseif classType == L["common-data-class-name-warrior"] then
      classColour = L["common-data-class-colour-warrior"]
   end
  
   -- == ----------------------------------------------------------------------
   -- == -- Apply the formatting and return.                                 --
   -- == ----------------------------------------------------------------------   
   return classColour..ConvergeFu:SafeText(text)
end

-- ============================================================================
-- == ColourStatusOnOff(text)                                                ==
-- ==                                                                        ==
-- == This function simply colours a status flag to an appropriate colour.   ==
-- ==                                                                        ==
-- == Green = On                                                             ==
-- == Red   = Off                                                            ==
-- == White = All other values.                                              ==
-- ============================================================================

function ConvergeFu:ColourStatusOnOff(text)
   if text == L["common-data-option-on"] then
      return ConvergeFu:ColourTextGreen(ConvergeFu:SafeText(text))
   elseif text == L["common-data-option-off"] then
      return ConvergeFu:ColourTextRed(ConvergeFu:SafeText(text))
   else
      return ConvergeFu:ColourTextWhite(ConvergeFu:SafeText(text))
   end
end

-- ============================================================================
-- == ColourStatusOneZero(text)                                              ==
-- ==                                                                        ==
-- == This function simply colours a status flag to an appropriate colour.   ==
-- ==                                                                        ==
-- == Green = 1                                                              ==
-- == Red   = 0                                                              ==
-- == White = All other values.                                              ==
-- ============================================================================

function ConvergeFu:ColourStatusOneZero(text)
   if text == L["common-data-option-one"] then
      return ConvergeFu:ColourTextGreen(ConvergeFu:SafeText(text))
   elseif text == L["common-data-option-zero"] then
      return ConvergeFu:ColourTextRed(ConvergeFu:SafeText(text))
   else
      return ConvergeFu:ColourTextWhite(ConvergeFu:SafeText(text))
   end
end

-- ============================================================================
-- == ColourTextForReportTitle(text, channelName)                            ==
-- ==                                                                        ==
-- == This function simply colours the supplied text for use as a report     ==
-- == title, using the supplied channelName parameter value to determine     ==
-- == whether or not to colour the text.                                     ==
-- ==                                                                        ==
-- == channelName = "CHAT", colour the text.                                 ==
-- == channelName = {any other value}, do not colour the text.               ==
-- ==                                                                        ==
-- == To colour text for the 'CHAT' channel, this function assumes the text  ==
-- == will be in the following format:                                       ==
-- ==                                                                        ==
-- == Format: "[FunctionTitle] - Some message..."                            ==
-- ==         ||Colour Purple||^||Colour White||         ( ^ = split-point.) ==
-- ============================================================================

function ConvergeFu:ColourTextForReportTitle(text, channelName)

   if channelName == nil then
      channelName = "CHAT"
   end
   
   ConvergeFu:Debug("ConvergeFu:ColourTextForReportTitle("..text..", "..channelName..")")
   
   if channelName ~= "CHAT" then
      return ConvergeFu:SafeText(text)
   end

   local Args = self:GetArgs(text, "-")
   toolNameText = Args[1].." - "
   actionText   = Args[2]
   
   colouredText = ConvergeFu:ColourTextPurple(toolNameText)
                ..ConvergeFu:ColourTextWhite(actionText)
   
   ConvergeFu:Debug(" - colouredText: ["..colouredText.."]")
   
   return colouredText
   
end

-- ============================================================================
-- == ColourTextForReportContent(text, channelName)                          ==
-- ==                                                                        ==
-- == This function simply colours the supplied text for use as report       ==
-- == content, using the supplied channelName parameter value to determine   ==
-- == whether or not to colour the text.                                     ==
-- ==                                                                        ==
-- == channelName = "CHAT", colour the text.                                 ==
-- == channelName = {any other value}, do not colour the text.               ==
-- ==                                                                        ==
-- == This is because regular channels like GUILD, RAID, PARTY etc do not    ==
-- == permit colouring of the text.                                          ==
-- ==                                                                        ==
-- == To colour text for the 'CHAT' channel, this function assumes the text  ==
-- == will be in the following format:                                       ==
-- ==                                                                        ==
-- == Format: "- Section Heading: Textual Content"                           ==
-- ==          ||Colour Yellow||^||Colour Green||        ( ^ = split-point.) ==
-- ============================================================================

function ConvergeFu:ColourTextForReportContent(text, channelName)

   if channelName == nil then
      channelName = "CHAT"
   end
   
   ConvergeFu:Debug("ConvergeFu:ColourTextForReportTitle("..text..", "..channelName..")")

   if channelName ~= "CHAT" then
      return ConvergeFu:SafeText(text)
   end
   
   local Args = self:GetArgs(text, ":")
   contentKeywordText = Args[1]..": "
   contentValueText   = Args[2]
   
   colouredText = ConvergeFu:ColourTextYellow(contentKeywordText)
                ..ConvergeFu:ColourTextGreen(contentValueText)
   
   ConvergeFu:Debug(" - colouredText: ["..colouredText.."]")

   return colouredText
   
end

-- ============================================================================
-- == SafeText(text)                                                         ==
-- ==                                                                        ==
-- == This function simply ensures a string of text is not nil.              ==
-- ============================================================================

function ConvergeFu:SafeText(text)

  if text == nil then
     return ""
  else
     return text
  end

end

-- ============================================================================
-- == SafeNumber(number)                                                     ==
-- ==                                                                        ==
-- == This function simply ensures a number is not nil.                      ==
-- ============================================================================

function ConvergeFu:SafeNumber(number)

  if number == nil then
     return 0
  else
     return number
  end

end

-- ============================================================================
-- == CaseCorrectedNameString(nameString)                                    ==
-- ==                                                                        ==
-- == This function processes a supplied name 'name-string' to ensure that   ==
-- == it is formatted correctly in terms of its character case. This means,  ==
-- == the first character should be capitalised, the remaining characters    ==
-- == should be lower case.                                                  ==
-- ============================================================================

function ConvergeFu:CaseCorrectedNameString(nameString)

   -- == ----------------------------------------------------------------------
   -- == -- First of all, ensure that the supplied nameString is not null.   --
   -- == ---------------------------------------------------------------------- 
   nameString = ConvergeFu:SafeText(nameString)

   -- == ----------------------------------------------------------------------
   -- == -- If the length of nameString is greater than 1, we can perform    --
   -- == -- the full character-case correction procedure. If it is either    --
   -- == -- zero or one character in length, simply upper-case the value.    --
   -- == ---------------------------------------------------------------------- 
   local caseCorrectedNameString = nameString
   
   if strlen (nameString) > 1 then
      local firstCharacter  = strsub(nameString, 1, 1)
      local otherCharacters = strsub(nameString, 2)

      caseCorrectedNameString = strupper(firstCharacter)..strlower(otherCharacters)
   else
      caseCorrectedNameString = strupper(nameString)
   end
   
   return caseCorrectedNameString

end

-- ============================================================================
-- == RecruitCharacter()                                                     ==
-- ==                                                                        ==
-- == This function is the 'gatekeeper' function for the character           ==
-- == recruitment functionality. Its job is to ensure that several key       ==
-- == pieces of information have been gathered before it kicks off the       ==
-- == actual invitation process.                                             ==
-- ============================================================================

function ConvergeFu:RecruitCharacter()

   if ConvergeFu.db.profile.recruitCharName == "" then
      ConvergeFu.db.profile.recruitStatus = L["tools-recruiter-status-getname"]
      ConvergeFu:RecruitNameFetch()
      return
   end

   if ConvergeFu.db.profile.recruitCharRank == "" then
      ConvergeFu.db.profile.recruitStatus = L["tools-recruiter-status-getrank"]
      ConvergeFu:RecruitRankFetch()
      return
   end
   
   if  ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-alt"]
   and ConvergeFu.db.profile.recruitCharMain == "" then
      ConvergeFu.db.profile.recruitStatus = L["tools-recruiter-status-getmain"]
      ConvergeFu:RecruitMainFetch()
      return
   end   

   if  ConvergeFu.db.profile.recruitStatus == L["tools-recruiter-status-checkok"] then
      ConvergeFu:RecruitConfirmContinue()
   end
   
   if ConvergeFu.db.profile.recruitStatus == L["tools-recruiter-status-recruit"] then
      ConvergeFu:DoRecruitCharacter() 
   end
   
end

-- ============================================================================
-- == RecruitCharacterCancel()                                               ==
-- ==                                                                        ==
-- == This function is called when, for some reason, the user has cancelled  ==
-- == out of the character recruitment process. It performs simple 'tidying' ==
-- == operations to undo whatever changes the process may have been in the   ==
-- == middle of.                                                             ==
-- ============================================================================

function ConvergeFu:RecruitCharacterCancel()

   ConvergeFu.db.profile.recruitCharName    = ""
   ConvergeFu.db.profile.recruitCharRank    = ""
   ConvergeFu.db.profile.recruitCharMain    = ""
   ConvergeFu.db.profile.recruitStatus      = L["tools-recruiter-status-dormant"]
   ConvergeFu.db.profile.recruitPromotes    = L["common-data-option-zero"]
   ConvergeFu.db.profile.recruitPromoteText = ""
 
end

-- ============================================================================
-- == RecruitReportStatus()                                                  ==
-- ==                                                                        ==
-- == This function reports the current status of the Recruiter tool to the  ==
-- == chat window. It enables to the user to understand if the recruitment   ==
-- == process has stalled, which may them prompt them to choose to reset the ==
-- == tool, via the RecruitCharacterCancel() function.                       ==
-- ============================================================================

function ConvergeFu:RecruitReportStatus()

   self:Print(L["tools-recruiter-report-01-msg"]..ConvergeFu.db.profile.recruitStatus)
   
   if ConvergeFu.db.profile.recruitStatus ~= L["tools-recruiter-status-dormant"] then
     self:Print(L["tools-recruiter-report-02-msg"]..ConvergeFu.db.profile.recruitCharName)
     self:Print(L["tools-recruiter-report-03-msg"]..ConvergeFu.db.profile.recruitCharRank)
     if ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-alt"] then
        self:Print(L["tools-recruiter-report-04-msg"]..ConvergeFu.db.profile.recruitCharMain)
     end
     self:Print(L["tools-recruiter-report-05-msg"]..ConvergeFu.db.profile.recruitPromotes)
   end

end

-- ============================================================================
-- == RecruitNameFetch()                                                     ==
-- ==                                                                        ==
-- == This function creates a simple dialog box which it uses to request the ==
-- == value of the name of the character to be recruited.                    ==
-- ============================================================================

function ConvergeFu:RecruitNameFetch()
   
   StaticPopupDialogs[L["tools-recruiter-window-getname"]] = {
      
      text         = L["tools-recruiter-window-title-getname"],
      button1      = L["tools-recruiter-button-continue"],
      button2      = L["tools-recruiter-button-cancel"],
      timeout      = 0,
      whileDead    = 1,
      hideOnEscape = 1,
      hasEditBox   = 1,

      OnShow = function()
         getglobal(this:GetName().."EditBox"):SetText("")
      end,

      OnAccept = function()
         ConvergeFu.db.profile.recruitCharName = ConvergeFu:CaseCorrectedNameString(getglobal(this:GetParent():GetName().."EditBox"):GetText())
         ConvergeFu:RecruitCharacter()
      end,

      OnCancel = function()
         ConvergeFu:RecruitCharacterCancel()
      end
   }

   StaticPopup_Show (L["tools-recruiter-window-getname"])
   
end

-- ============================================================================
-- == RecruitRankFetch()                                                     ==
-- ==                                                                        ==
-- == This function creates a simple dialog box which it uses to request the ==
-- == value of the intended rank of the character to be recruited.           ==
-- ==                                                                        ==
-- == ie: 'Alt' or 'Main'                                                    ==
-- ============================================================================

function ConvergeFu:RecruitRankFetch()

   StaticPopupDialogs[L["tools-recruiter-window-getrank"]] = {
      
      text         = L["tools-recruiter-window-title-getrank"],
      button1      = L["tools-recruiter-button-main"],
      button2      = L["tools-recruiter-button-alt"],
      timeout      = 0,
      whileDead    = 1,
      hideOnEscape = 1,

      OnAccept = function()
         ConvergeFu.db.profile.recruitCharRank = L["tools-recruiter-button-main"]
         ConvergeFu.db.profile.recruitStatus   = L["tools-recruiter-status-checkok"]
         ConvergeFu:RecruitCharacter()
      end,

      OnCancel = function()
         ConvergeFu.db.profile.recruitCharRank = L["tools-recruiter-button-alt"]
         ConvergeFu:RecruitCharacter()
      end
   }

   StaticPopup_Show (L["tools-recruiter-window-getrank"])

end

-- ============================================================================
-- == RecruitMainFetch()                                                     ==
-- ==                                                                        ==
-- == This function creates a simple dialog box which it uses to request the ==
-- == value of the name of the main character to whom the player being       ==
-- == invited will belong.                                                   ==
-- ============================================================================

function ConvergeFu:RecruitMainFetch()

   StaticPopupDialogs[L["tools-recruiter-window-getmain"]] = {
      
      text         = L["tools-recruiter-window-title-getmain"],
      button1      = L["tools-recruiter-button-continue"],
      button2      = L["tools-recruiter-button-cancel"],
      timeout      = 0,
      whileDead    = 1,
      hideOnEscape = 1,
      hasEditBox   = 1,

      OnShow = function()
         getglobal(this:GetName().."EditBox"):SetText("")
      end,

      OnAccept = function()
         ConvergeFu.db.profile.recruitCharMain = ConvergeFu:CaseCorrectedNameString(getglobal(this:GetParent():GetName().."EditBox"):GetText())
         ConvergeFu.db.profile.recruitStatus   = L["tools-recruiter-status-checkok"]
         ConvergeFu:RecruitCharacter()
      end,

      OnCancel = function()
         ConvergeFu:RecruitCharacterCancel()
      end
   }

   StaticPopup_Show (L["tools-recruiter-window-getmain"])
   
end

-- ============================================================================
-- == RecruitConfirmContinue()                                               ==
-- ==                                                                        ==
-- == This function asks the user to confirm the information collected is    ==
-- == correct before continuing with the recruitment process.                ==
-- ============================================================================

function ConvergeFu:RecruitConfirmContinue()

   local winText = L["tools-recruiter-window-title-getconf-01"]
                 ..ConvergeFu.db.profile.recruitCharName
                 
   if ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-alt"] then
      winText = winText
              ..L["tools-recruiter-window-title-getconf-03"]
              ..ConvergeFu:GetCorrespondingAltRank(ConvergeFu:GetCharacterRank(ConvergeFu.db.profile.recruitCharMain))
              ..L["tools-recruiter-window-title-getconf-04"]
              ..ConvergeFu.db.profile.recruitCharMain
              .."?"
   else
      winText = winText
              ..L["tools-recruiter-window-title-getconf-02"]
              ..L["common-rankname-member-trial"]
              .."?"   
   end

   StaticPopupDialogs[L["tools-recruiter-window-getconf"]] = {
      
      text         = winText,
      button1      = L["tools-recruiter-button-continue"],
      button2      = L["tools-recruiter-button-cancel"],
      timeout      = 0,
      whileDead    = 1,
      hideOnEscape = 1,

      OnAccept = function()
         ConvergeFu.db.profile.recruitStatus = L["tools-recruiter-status-recruit"]
         ConvergeFu:RecruitCharacter()
      end,

      OnCancel = function()
         ConvergeFu:RecruitCharacterCancel()
      end
   }

   StaticPopup_Show (L["tools-recruiter-window-getconf"])

end

-- ============================================================================
-- == DoRecruitCharacter()                                                   ==
-- ==                                                                        ==
-- == This function kicks off the actual recruitment process and is called   ==
-- == once all the required information has been properly collected.         ==
-- ============================================================================

function ConvergeFu:DoRecruitCharacter()

   ConvergeFu:DoRecruitGuildAnnouncement()
      
   messageText1 = ConvergeFu:ColourTextPurple(L["tools-recruiter-tag"])
                ..ConvergeFu:ColourTextWhite(" - ")
                ..L["tools-recruiter-commentary-01-msg"]
                ..ConvergeFu:ColourTextYellow(ConvergeFu.db.profile.recruitCharName)
                ..ConvergeFu:ColourTextWhite("...")
                
   self:Print(messageText1)
   ConvergeFu:ExecuteChatCommand("/ginvite "..ConvergeFu.db.profile.recruitCharName)
   self:RegisterEvent("CHAT_MSG_SYSTEM")

end

-- ============================================================================
-- == DoRecruitGuildAnnouncement()                                           ==
-- ==                                                                        ==
-- == This function makes an announcement in guild chat, warning players to  ==
-- == be ready to welcome the new recruit.                                   ==
-- ============================================================================

function ConvergeFu:DoRecruitGuildAnnouncement()

   -- == ----------------------------------------------------------------------
   -- == -- Make an announcement in guild chat...                            --
   -- == ----------------------------------------------------------------------
   ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], "GUILD")
   ConvergeFu:SendChatMessage(L["tools-recruiter-getready-01-msg"], "GUILD")
   ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], "GUILD")
   ConvergeFu:SendChatMessage(L["tools-recruiter-getready-02-msg"], "GUILD")
   ConvergeFu:SendChatMessage(L["tools-recruiter-getready-03-msg"], "GUILD")
   ConvergeFu:SendChatMessage(L["common-separator-empty-line"], "GUILD")
   ConvergeFu:SendChatMessage(" "..ConvergeFu.db.profile.recruitCharName, "GUILD")
   ConvergeFu:SendChatMessage(L["common-separator-empty-line"], "GUILD")
   ConvergeFu:SendChatMessage(L["tools-recruiter-getready-04-msg"], "GUILD")
   
   if ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-main"] then
      ConvergeFu:SendChatMessage(L["tools-recruiter-getready-05-msg"], "GUILD")
   else
      ConvergeFu:SendChatMessage(L["tools-recruiter-getready-06-msg"]..ConvergeFu.db.profile.recruitCharMain..".", "GUILD")
   end
   ConvergeFu:SendChatMessage(L["common-separator-dashed-line"], "GUILD")
   
end

-- ============================================================================
-- == RecruitConfirmPostJoin()                                               ==
-- ==                                                                        ==
-- == This function asks the user to confirm they should continue to process ==
-- == the recruit who has just joined. Really, this step exists only to give ==
-- == the server time to update the guild roster.                            ==
-- ============================================================================

function ConvergeFu:RecruitConfirmPostJoin()

   StaticPopupDialogs[L["tools-recruiter-window-getcont"]] = {
      
      text         = L["tools-recruiter-window-title-getcont"],
      timeout      = 5,
      whileDead    = 1,
      hideOnEscape = 1,

      OnAccept = function()
         ConvergeFu:DoRecruitPostJoinActions("first")
      end,
      
      OnCancel = function()
         ConvergeFu:DoRecruitPostJoinActions("first")
      end      
   }

   StaticPopup_Show (L["tools-recruiter-window-getcont"])

end

-- ============================================================================
-- == DoRecruitPostJoinActions(task)                                         ==
-- ==                                                                        ==
-- == This function performs several tasks after a recruit has joined the    ==
-- == guild in order to configure their character correctly.                 ==
-- ==                                                                        ==
-- == 1: Set the character's rank.                                           ==
-- == 2: Set the character's officer note if a trial member.                 ==
-- == 3: Set the character's public note if an alt member.                   ==
-- == 4: Whisper some 'welcome text' if the recruit is a trial.              ==
-- == 5: Reset all 'recruitXXX' properties, set status to 'Dormant'.         ==
-- ============================================================================

function ConvergeFu:DoRecruitPostJoinActions(task)

   -- == ----------------------------------------------------------------------
   -- == -- Set the recruited character's rank.                              --
   -- == ----------------------------------------------------------------------
   local numberOfRankIncreases = 5
   if ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-alt"] then
      local mainCharRank = ConvergeFu:GetCharacterRank(ConvergeFu.db.profile.recruitCharMain)
      local thisCharRank = ConvergeFu:GetCorrespondingAltRank(mainCharRank)
  
      if thisCharRank == L["common-rankname-alt-trial"] then
         numberOfRankIncreases = 1
      elseif thisCharRank == L["common-rankname-alt-normal"] then
         numberOfRankIncreases = 2
      elseif thisCharRank == L["common-rankname-alt-hero"] then
         numberOfRankIncreases = 3
      elseif thisCharRank == L["common-rankname-alt-officer"] then
         numberOfRankIncreases = 4
      end
   end
      
   ConvergeFu.db.profile.recruitPromotes = numberOfRankIncreases
   
   promotionText = ConvergeFu:ColourTextPurple(L["tools-recruiter-tag"])
                 .." "
                 ..ConvergeFu:ColourTextWhite(L["tools-recruiter-num-promotions"])
                 ..ConvergeFu:ColourTextYellow(numberOfRankIncreases)
             
  self:Print(promotionText)
  
   
   promotedByOneText = ConvergeFu:ColourTextPurple(L["tools-recruiter-tag"])
                     .." "
                     ..ConvergeFu:ColourTextWhite(L["tools-recruiter-promoted-by-one"])
   
   -- == ----------------------------------------------------------------------
   -- == -- Set the recruited character's public or officer note.            --
   -- == ----------------------------------------------------------------------   
   if ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-main"] then
      officerNoteText = "Trial "..date("%d.%m.%Y");
      noteSettingText = ConvergeFu:ColourTextPurple(L["tools-recruiter-tag"])
                      .." "
                      ..ConvergeFu:ColourTextWhite(L["tools-recruiter-set-note-officer"])
                      ..ConvergeFu:ColourTextYellow(officerNoteText)
      self:Print(noteSettingText)
      ConvergeFu:SetCharacterOfficerNote(ConvergeFu.db.profile.recruitCharName, officerNoteText)
   else
      noteSettingText = ConvergeFu:ColourTextPurple(L["tools-recruiter-tag"])
                      .." "
                      ..ConvergeFu:ColourTextWhite(L["tools-recruiter-set-note-public"])
                      ..ConvergeFu:ColourTextYellow(ConvergeFu.db.profile.recruitCharMain)
      self:Print(noteSettingText)
      ConvergeFu:SetCharacterPublicNote(ConvergeFu.db.profile.recruitCharName, ConvergeFu.db.profile.recruitCharMain)
   end

   -- == ----------------------------------------------------------------------
   -- == -- Whisper some 'welcome text' if the recruit is a trial.           --
   -- == ---------------------------------------------------------------------- 
   if ConvergeFu.db.profile.recruitCharRank == L["tools-recruiter-rank-main"] then
      ConvergeFu:SendMessage(L["tools-recruiter-keyword-01-msg"], "WHISPER", nil, ConvergeFu.db.profile.recruitCharName)
      ConvergeFu:SendMessage(L["tools-recruiter-keyword-02-msg"], "WHISPER", nil, ConvergeFu.db.profile.recruitCharName)
      ConvergeFu:SendMessage(L["tools-recruiter-keyword-03-msg"], "WHISPER", nil, ConvergeFu.db.profile.recruitCharName)
      ConvergeFu:SendMessage(L["tools-recruiter-keyword-04-msg"], "WHISPER", nil, ConvergeFu.db.profile.recruitCharName)
      ConvergeFu:SendMessage(L["tools-recruiter-keyword-05-msg"], "WHISPER", nil, ConvergeFu.db.profile.recruitCharName)
      ConvergeFu:SendMessage(L["tools-recruiter-keyword-06-msg"], "WHISPER", nil, ConvergeFu.db.profile.recruitCharName)
   end

   ConvergeFu:RecruitRankChange()

end

-- ============================================================================
-- == ConvergeFu:RecruitRankChange()                                         ==
-- ==                                                                        ==
-- == This function promotes the new recruit if he/she still needs to be     ==
-- == promoted.                                                              ==
-- ==                                                                        ==
-- == Instead of simply looping around the "GuildPromote" the required       ==
-- == number of times, it performs one GuildPromote call, then appears to    ==
-- == to finish. However, when the CHAT_MSG_SYSTEM event fires, it watches   ==
-- == for a message matching the pattern below to be reported and when that  ==
-- == happens, it calls this method again. This method checks to see if      ==
-- == another call of GuildPromote is required and either makes the call or  ==
-- == passes control to the next function in the chain if the required rank  ==
-- == for the character being promoted has already been achieved.
-- ============================================================================

function ConvergeFu:RecruitRankChange()

  ConvergeFu.db.profile.recruitStatus = L["tools-recruiter-status-setrank"]
  
  local promotionsRemaining = ConvergeFu.db.profile.recruitPromotes
  
  if promotionsRemaining > 0 then
    self:Print("Promoting: "..promotionsRemaining.." left to do...")
    GuildPromote(ConvergeFu.db.profile.recruitCharName)
    ConvergeFu.db.profile.recruitPromotes = promotionsRemaining - 1
    promotionsRemaining = promotionsRemaining - 1
  else
     ConvergeFu:RecruitAllDone()
  end
end

-- ============================================================================
-- == ConvergeFu:RecruitAllDone()                                            ==
-- ==                                                                        ==
-- == This function promotes the new recruit if he/she still needs to be     ==
-- == promoted.                                                              ==
-- ============================================================================

function ConvergeFu:RecruitAllDone()

   -- == ----------------------------------------------------------------------
   -- == -- Reset all internal properties so that we can finish cleanly.     --
   -- == ---------------------------------------------------------------------- 
   completionText = ConvergeFu:ColourTextPurple(L["tools-recruiter-tag"])
                  .." "
                  ..ConvergeFu:ColourTextWhite(L["tools-recruiter-all-done"])
   
   self:Print(completionText)
   PlaySound("DwarfExploration")
   ConvergeFu:RecruitCharacterCancel()
end

-- ============================================================================
-- == SetCharacterPublicNote(characterName, messageText)                     ==
-- ==                                                                        ==
-- == This function sets the public note field of the named character.       ==
-- ============================================================================

function ConvergeFu:SetCharacterPublicNote(characterName, messageText)

  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
    if name == characterName then
       GuildRosterSetPublicNote(index, messageText)  
    end
    
    index = index + 1
  end
end

-- ============================================================================
-- == SetCharacterOfficerNote(characterName, messageText)                    ==
-- ==                                                                        ==
-- == This function sets the public note field of the named character.       ==
-- ============================================================================

function ConvergeFu:SetCharacterOfficerNote(characterName, messageText)
  
  for index = 1, (GetNumGuildMembers(true)) do
    name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index);
    
    if name == characterName then
       GuildRosterSetOfficerNote(index, messageText)  
    end
    
    index = index + 1
  end
end

-- ============================================================================
-- == CalculateItemLevelDKP()                                                ==
-- ==                                                                        ==
-- == This function calculates the Item Level DKP of the item described by   ==
-- == the internal DB properties stored in this application.
-- ============================================================================

function ConvergeFu:CalculateItemLevelDKP()
  
   rarityEqn = 0
   
   if ConvergeFu.db.profile.itemLevelType == L["tools-itemleveldkp-rarity-rare"] then
      rarityEqn = ((ConvergeFu.db.profile.itemLevelValue - 1.84) / 1.84)
   end
   
   if ConvergeFu.db.profile.itemLevelType == L["tools-itemleveldkp-rarity-epic"] then
      rarityEqn = ((ConvergeFu.db.profile.itemLevelValue - 1.3) / 1.3)
   end
   
   if ConvergeFu.db.profile.itemLevelType == L["tools-itemleveldkp-rarity-legendary"] then
      rarityEqn = ConvergeFu.db.profile.itemLevelValue
   end   
   
   slotMultiplier = 1
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-neck"]
   or ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-wrist"]
   or ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-finger"]
   or ConvergeFu.db.profile.itemLevelSlot ==L["tools-itemleveldkp-slot-back"] then
      slotMultiplier = 0.54
   end
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-shoulder"]
   or ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-waist"]
   or ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-feet"]
   or ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-hands"] then
      slotMultiplier = 0.74
   end
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-trinket"] then
      slotMultiplier = 0.68
   end      
  
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-shield"] then
      slotMultiplier = 0.65
   end
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-twohander"]
   or ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-bowcrossgun"] then
      slotMultiplier = 1.5
   end
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-offhand"] then
      slotMultiplier = 0.52
   end
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-wand"] then
      slotMultiplier = 0.5
   end
   
   if ConvergeFu.db.profile.itemLevelSlot == L["tools-itemleveldkp-slot-relictotem"] then
      slotMultiplier = 0.3
   end   
  
   dkpValue = rarityEqn * slotMultiplier
   
   local mult = 10^(0 or 0)
   dkpValue = math.floor(dkpValue * mult + 0.5) / mult
   
   textToPrint = ConvergeFu:ColourTextPurple(L["tools-itemleveldkp-tag"])
               ..":  "
               ..ConvergeFu:ColourTextWhite(ConvergeFu.db.profile.itemLevelType)
               .." / "
               ..ConvergeFu:ColourTextWhite(ConvergeFu.db.profile.itemLevelSlot)
               .." / "
               ..ConvergeFu:ColourTextWhite(ConvergeFu.db.profile.itemLevelValue)
               .." = "
               ..ConvergeFu:ColourTextGreen(dkpValue)
               .." "
               ..ConvergeFu:ColourTextWhite(L["tools-itemleveldkp-summary-dkpvalue"])
   self:Print(textToPrint)

end

-- ============================================================================
-- == CHAT_MSG_SYSTEM(msg)                                                   ==
-- ==                                                                        ==
-- == This function performs actions when the CHAT_MSG_SYSTEM event is       ==
-- == triggered. It is triggered when the player's character receives a      ==
-- == message via the system 'channel.'                                      ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CHAT_MSG_SYSTEM(msg)

   recruitHasJoinedText = ConvergeFu.db.profile.recruitCharName
                        ..L["tools-recruiter-system-message"]
   
   if msg == recruitHasJoinedText then
      GuildRoster()
      ConvergeFu:RecruitConfirmPostJoin()
      -- ConvergeFu:DoRecruitPostJoinActions()
   end

   -- == ----------------------------------------------------------------------
   -- == -- If the Recruiter Tool has a status of "SettingRank"...           --
   -- == ----------------------------------------------------------------------
   if ConvergeFu.db.profile.recruitStatus == L["tools-recruiter-status-setrank"] then
      rankMessageAltTrial   = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-alt-trial"]   
      rankMessageAltNormal  = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-alt-normal"]  
      rankMessageAltHero    = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-alt-hero"]    
      rankMessageAltOfficer = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-alt-officer"] 
      rankMessageTrial      = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-trial"]       
      rankMessageNormal     = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-normal"]      
      rankMessageHero       = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-hero"]        
      rankMessageOfficer    = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-officer"]     
      rankMessageGM         = UnitName("player")..L["tools-recruiter-change-rank-msg-01"]..ConvergeFu.db.profile.recruitCharName..L["tools-recruiter-change-rank-gm"]          

      if msg == rankMessageAltTrial
      or msg == rankMessageAltNormal
      or msg == rankMessageAltHero
      or msg == rankMessageAltOfficer
      or msg == rankMessageTrial
      or msg == rankMessageNormal
      or msg == rankMessageHero
      or msg == rankMessageOfficer
      or msg == rankMessageGM then
         ConvergeFu:RecruitRankChange()   
      end
   end
end

-- ============================================================================
-- == CHAT_MSG_EMOTE(msg)                                                    ==
-- ==                                                                        ==
-- == This function performs actions when the CHAT_MSG_EMOTE event is        ==
-- == triggered. It is triggered when the player's character receives a      ==
-- == message via the emote 'channel.'                                       ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CHAT_MSG_EMOTE(msg)

   if ConvergeFu.db.profile.fishFeastStatus == L["common-data-option-on"] then
      if string.match(msg,ConvergeFu.db.profile.fishFeastMatch) then
   
         PlaySoundFile("Sound\\interface\\PickUp\\PutDownMeat.wav")
         
         if ConvergeFu.db.profile.fishFeastChannel == "RAID" then
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID")
         end
      
         if ConvergeFu.db.profile.fishFeastChannel == "RAID_WARNING" then
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID_WARNING")
         end      
         
         if ConvergeFu.db.profile.fishFeastChannel == "BOTH" then
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID")
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID_WARNING")
         end
      end
   end
   
end

-- ============================================================================
-- == CHAT_MSG_MONSTER_EMOTE(msg)                                            ==
-- ==                                                                        ==
-- == This function performs actions when the CHAT_MSG_MONSTER_EMOTE event   ==
-- == is triggered. It is triggered when the player's character receives a   ==
-- == message via the emote 'channel.'                                       ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CHAT_MSG_MONSTER_EMOTE(msg)

   if ConvergeFu.db.profile.fishFeastStatus == L["common-data-option-on"] then
      if string.match(msg,ConvergeFu.db.profile.fishFeastMatch) then
   
         PlaySoundFile("Sound\\interface\\PickUp\\PutDownMeat.wav")
         
         if ConvergeFu.db.profile.fishFeastChannel == "RAID" then
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID")
         end
      
         if ConvergeFu.db.profile.fishFeastChannel == "RAID_WARNING" then
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID_WARNING")
         end      
         
         if ConvergeFu.db.profile.fishFeastChannel == "BOTH" then
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID")
            ConvergeFu:SendChatMessage(ConvergeFu.db.profile.fishFeastText, "RAID_WARNING")
         end
      end
   end
   
end

-- ============================================================================
-- == RaidInstanceWelcomeStatusUpdated()                                     ==
-- ==                                                                        ==
-- == This function simply reports the state of the Raid Instance Welcome    ==
-- == messaging, indicating whether or not the player will receive messages  ==
-- == when entering selected raid instances.                                 ==
-- ============================================================================

function ConvergeFu:RaidInstanceWelcomeStatusUpdated()

   statusMessage1 = ConvergeFu:ColourTextPurple(L["tools-riw-msg-first"])
                  ..ConvergeFu:ColourTextWhite(L["tools-riw-status-msg-01"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.riwStatus)
             
   self:Print(statusMessage1)
   
end

-- ============================================================================
-- == LOOT_OPENED(msg)                                                       ==
-- ==                                                                        ==
-- == This function performs actions when the LOOT_OPENED event is           ==
-- == triggered. It is triggered when the player's character opens a loot    ==
-- == window.                                                                ==
-- ==                                                                        ==
-- == If the player satisfies a number of conditions, an addon message is    ==
-- == fired corresponding to the trigger event.                              ==
-- ==                                                                        ==
-- == Conditions:                                                            ==
-- ==                                                                        ==
-- == Player character is in a raid.                                         ==
-- == Player target holds "worldboss" classification.                        ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:LOOT_OPENED()

   playerName = UnitName("player")
   targetName = UnitName("target")
   targetType = UnitClassification("target")
      
   if playerName == nil then
      playerName = L["tools-loot-monitor-unit-player-unknown"]
   end
   
   if targetName == nil then
      targetName = L["tools-loot-monitor-unit-target-unknown"]
   end
   
   if targetType == nil then
      targetType = L["tools-loot-monitor-unit-ttype-unknown"]
   end

   channelName = "RAID"
   messageText = playerName..L["tools-loot-monitor-trigger-01-msg"]..targetName.."."
   
   if targetType == "worldboss" then
      SendAddonMessage(L["event-addon-lm-trigger"], messageText, channelName)
   end

end

-- ============================================================================
-- == LootMonitorStatusUpdated()                                             ==
-- ==                                                                        ==
-- == This function simply reports the state of the LootMonitor's current    ==
-- == operational state.                                                     ==
-- ============================================================================

function ConvergeFu:LootMonitorStatusUpdated()

   statusMessage1 = ConvergeFu:ColourTextPurple(L["tools-loot-monitor-msg-first"])
                  ..ConvergeFu:ColourTextWhite(L["tools-loot-monitor-status-01-msg"])
                  ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.lootMonitorStatus)
             
   self:Print(statusMessage1)
   
end

-- ============================================================================
-- == ToggleLootMonitor()                                                    ==
-- ==                                                                        ==
-- == This function simply toggles the LootMonitor tool on or off.           ==
-- ============================================================================

function ConvergeFu:ToggleLootMonitor()

  if ConvergeFu.db.profile.lootMonitorStatus == L["common-data-option-on"] then
    ConvergeFu.db.profile.lootMonitorStatus = L["common-data-option-off"]
  else
    ConvergeFu.db.profile.lootMonitorStatus = L["common-data-option-on"]
  end
  
end

-- ============================================================================
-- == DoNotifyLootMonitorTriggered(msg, channel, sender)                     ==
-- ==                                                                        ==
-- == This function responds when it receives a trigger-message from the     ==
-- == LootMonitor tool built into CFU by notifying the event in the normal   ==
-- == manner.                                                                ==
-- ============================================================================

function ConvergeFu:DoNotifyLootMonitorTriggered(msg, channel, sender)

   local masterLooterName        = ConvergeFu:SafeText(ConvergeFu:GetMasterLooterCharacterName())
   local notificationMessage     = L["tools-loot-monitor-msg-first"]..msg
  
   if ConvergeFu.db.profile.lootMonitorStatus == L["common-data-option-on"] then
      if UnitPlayerOrPetInRaid(sender) then
         if  ConvergeFu:IsOfficerRankedCharacter(UnitName("player"))
         and ConvergeFu.db.profile.lootMonitorMLSeen == L["common-data-option-no"] then
            ConvergeFu:SendChatMessage(notificationMessage, "OFFICER")
            if sender == masterLooterName then
               ConvergeFu:SetLootMonitorMLSeen()
            else
               SendAddonMessage(L["event-addon-lm-stoplooting"], "NULL", "WHISPER", sender)
            end
         end
      end
   end
  
end

-- ============================================================================
-- == DoWarnLootMonitorStopLooting(msg, channel, sender)                     ==
-- ==                                                                        ==
-- == This function responds when it receives a message from another member  ==
-- == who is running the loot-monitor tool and has detected that this user   ==
-- == has opened a loot window on a boss mob/chest/cache before the master   ==
-- == looter has done so. A warning message is printed to the chat window to ==
-- == inform the player of this and to request them to avoid doing so again. ==
-- ============================================================================
function ConvergeFu:DoWarnLootMonitorStopLooting(msg, channel, sender)

   local masterLooterName = ConvergeFu:SafeText(ConvergeFu:GetMasterLooterCharacterName())
   
   PlaySound("DwarfExploration")
   
   print(" ")         
   print(ConvergeFu:ColourTextRed(L["tools-loot-monitor-warning-msg-warning"])..ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-01"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-02"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-03"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-04"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-05"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-06"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-07"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-08"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-09"]))
   print(ConvergeFu:ColourTextYellow(L["tools-loot-monitor-warning-msg-10"])..ConvergeFu:ColourTextGreen(masterLooterName))
   print(" ")
   
end

-- ============================================================================
-- == SetLootMonitorMLSeen()                                                 ==
-- ==                                                                        ==
-- == This function sets the value of the db-variable 'lootMonitorMLSeen' to ==
-- == "Yes" indicating that the ML has been successfully detected.           ==
-- ============================================================================

function ConvergeFu:SetLootMonitorMLSeen()

   local statusUpdateMessage = L["tools-loot-monitor-msg-first"]..L["tools-loot-monitor-msg-ml-detected"]
   
   ConvergeFu.db.profile.lootMonitorMLSeen = L["common-data-option-yes"]
   
   ConvergeFu:SendChatMessage(statusUpdateMessage, "OFFICER")
   
end

-- ============================================================================
-- == SetLootMonitorMLNotSeen()                                              ==
-- ==                                                                        ==
-- == This function sets the value of the db-variable 'lootMonitorMLSeen' to ==
-- == "No", effectively resetting the tool ready for the next major looting  ==
-- == event.                                                                 ==
-- ============================================================================

function ConvergeFu:SetLootMonitorMLNotSeen()

   local statusUpdateMessage = L["tools-loot-monitor-msg-first"]..L["tools-loot-monitor-msg-ml-reset"]
   
   ConvergeFu.db.profile.lootMonitorMLSeen = L["common-data-option-no"]
   
   ConvergeFu:Debug(statusUpdateMessage)
   
end

-- ============================================================================
-- == LootMonitorTest()                                                      ==
-- ==                                                                        ==
-- == This function tests the LootMonitor functionality by firing a trigger  ==
-- == message much as one would expect it would if the user had actually     ==
-- == opened a loot window for themselves.                                   ==
-- ============================================================================

function ConvergeFu:LootMonitorTest()

   playerName = UnitName("player")
   targetName = UnitName("target")
   targetType = UnitClassification("target")
   
   ConvergeFu:Debug("targetType: "..targetType)
   
   ConvergeFu:LOOT_OPENED()
  
end

-- ============================================================================
-- == CheckGuildAdminStatus()                                                ==
-- ==                                                                        ==
-- == This function conducts all tests related to measuring the status of    ==
-- == the guild in terms of outstanding admin tasks that require to be done. ==
-- ============================================================================

function ConvergeFu:CheckGuildAdminStatus()

   messageText1 = ConvergeFu:ColourTextPurple(L["tools-guildstatus-msg-first"])
                ..ConvergeFu:ColourTextWhite(L["tools-guildstatus-msg-01"])

   messageText2 = ConvergeFu:ColourTextPurple(L["tools-guildstatus-msg-first"])
                ..ConvergeFu:ColourTextWhite(L["tools-guildstatus-msg-02"])
                
   messageText3 = ConvergeFu:ColourTextPurple(L["tools-guildstatus-msg-first"])
                ..ConvergeFu:ColourTextWhite(L["tools-guildstatus-msg-03"])
                
   if not ConvergeFu:IsOfficerRankedCharacter(UnitName("player")) then
      self:Print(messageText3)
      return
   end
   
   self:Print(messageText1)
   
   ConvergeFu:CheckTrialCharacterOfficerNotes()
   ConvergeFu:CheckMainCharacterOfficerNotes()
   ConvergeFu:CheckAltCharacterPublicNotes()
   ConvergeFu:CheckAltCharacterRanks()
   
   self:Print(messageText2)
end

-- ============================================================================
-- == CheckTrialCharacterOfficerNotes()                                      ==
-- ==                                                                        ==
-- == This function checks that all trial ranked characters have their       ==
-- == officer note field set correctly. The proper format for the officer    ==
-- == note of a trial ranked member is as follows:                           ==
-- ==                                                                        ==
-- == Trial dd.mm.yyyy                                                       ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CheckTrialCharacterOfficerNotes()

   messageText = ConvergeFu:ColourTextYellow(L["tools-gs-trial-officer-note-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["tools-gs-trial-officer-note-msg-01"])
               
   self:Print(messageText)
   
   trialOfficerNoteErrors = L["common-data-option-no"]
  
   totalNumberOfGuildMembers = GetNumGuildMembers(true)
  
   for index=1, totalNumberOfGuildMembers, 1 do
     name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index)
      if ConvergeFu:IsMainRankedCharacter(name) then
         if ConvergeFu:IsTrialRankedCharacter(name) then
            if not ConvergeFu:IsTrialMemberOfficerNoteValid(officernote) then
               messageText = ConvergeFu:ColourTextWhite(L["tools-gs-trial-officer-note-msg-02"])
                           ..ConvergeFu:ColourTextRed(name)
                           ..ConvergeFu:ColourTextWhite(L["tools-gs-trial-officer-note-msg-03"])
                           ..ConvergeFu:ColourTextYellow(officernote)
               self:Print(messageText)
               trialOfficerNoteErrors = L["common-data-option-yes"]
            end
         end
      end
   end
   
   if trialOfficerNoteErrors == L["common-data-option-yes"] then
     trialOfficerNoteErrorText = ConvergeFu:ColourTextWhite(L["tools-gs-trial-officer-note-msg-04"])
                               ..ConvergeFu:ColourTextGreen(L["tools-gs-trial-officer-note-msg-05"])
     self:Print(trialOfficerNoteErrorText)
   end
end

-- ============================================================================
-- == IsTrialMemberOfficerNoteValid(officernote)                             ==
-- ==                                                                        ==
-- == This function checks that the supplied officer note is valid for a     ==
-- == trial member for whom the officer note should be of the format:        ==
-- ==                                                                        ==
-- == Trial dd.mm.yyyy                                                       ==
-- == 1234567890123456                                                       ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:IsTrialMemberOfficerNoteValid(officernote)

   if officernote == nil then
      return false
   end
   
   if string.len(officernote) ~= 16 then
      return false
   end
   
   if string.sub(officernote, 1, 6) ~= "Trial " then
      return false
   end
   
   if string.sub(officernote, 9, 9) ~= "." then
      return false
   end
   
   if string.sub(officernote, 12, 12) ~= "." then
      return false
   end   
   
   if not tonumber(string.sub(officernote, 7,8)) then
      return false
   end
   
   if not tonumber(string.sub(officernote, 10,11)) then
      return false
   end   

   if not tonumber(string.sub(officernote, 13,16)) then
      return false
   end
   
   dateNumber  = tonumber(string.sub(officernote, 7,8))
   monthNumber = tonumber(string.sub(officernote, 10,11))
   yearNumber  = tonumber(string.sub(officernote, 13,16))
   
   if dateNumber < 0 or dateNumber > 31 then
      return false
   end
   
   if monthNumber < 0 or monthNumber > 12 then
      return false
   end
   
   if yearNumber < 0 or yearNumber > 2000000 then
      return false
   end
   
   return true
   
end

-- ============================================================================
-- == CheckAltCharacterPublicNotes()                                         ==
-- ==                                                                        ==
-- == This function checks that all alt ranked characters have their public  ==
-- == note field set correctly. The proper format for the public note of an  ==
-- == alt ranked member is as follows:                                       ==
-- ==                                                                        ==
-- == {name-of-main-character}                                               ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CheckAltCharacterPublicNotes()
  
   messageText = ConvergeFu:ColourTextYellow(L["tools-gs-alt-public-note-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-public-note-msg-01"])
               
   self:Print(messageText)
   
   totalNumberOfGuildMembers = GetNumGuildMembers(true)
  
   for index=1, totalNumberOfGuildMembers, 1 do
     name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index)
     
      if ConvergeFu:IsAltRankedCharacter(name) then
         if not ConvergeFu:IsMainRankedCharacter(note)
         and string.match(note, L["tools-gs-alt-public-note-bank-character"]) == nil then
            messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-public-note-msg-02"])
                        ..ConvergeFu:ColourTextRed(name)
                        ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-public-note-msg-03"])
                        ..ConvergeFu:ColourTextYellow(note)
                        ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-public-note-msg-04"])                         
            self:Print(messageText)         
         end
      end
   end

   messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-public-note-msg-last"])
   
end

-- ============================================================================
-- == CheckMainCharacterOfficerNotes()                                       ==
-- ==                                                                        ==
-- == This function checks that all main ranked characters have had their    ==
-- == officer note field cleared of its 'Trial dd.mm.yyyy' string which is   ==
-- == no longer relevant once the member has been promoted above the rank of ==
-- == Trial Member. Since the officer note is sometimes used to record other ==
-- == information on a member-by-member adhoc basis, we cannot check that it ==
-- == has a specific value, only that it does not match the 'Trial...'       ==
-- == format.                                                                ==
-- ==                                                                        ==
-- == Note: This function uses the "IsTrialMemberOfficerNoteValid(...)       ==
-- ==       function to determine if the officernote of a main character     ==
-- ==       that is not a trial member has an officer note that would be     ==
-- ==       valid for a trial member. (ie: Trial dd.mm.yyyy) If a trial      ==
-- ==       member had an invalid officer note whilst holding the trial rank ==
-- ==       and was promoted before the officer note was corrected, this     ==
-- ==       test will not detect that condition. For example, if the trial   ==
-- ==       member had an officer note of "Trial yyyy.mm.dd".                ==
-- ============================================================================

function ConvergeFu:CheckMainCharacterOfficerNotes()
  
   messageText = ConvergeFu:ColourTextYellow(L["tools-gs-main-officer-note-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["tools-gs-main-officer-note-msg-01"])
               
   self:Print(messageText)
   
   totalNumberOfGuildMembers = GetNumGuildMembers(true)
  
   for index=1, totalNumberOfGuildMembers, 1 do
     name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(index)
     
      if ConvergeFu:IsMainRankedCharacter(name) then
         if not ConvergeFu:IsTrialRankedCharacter(name)
         and ConvergeFu:IsTrialMemberOfficerNoteValid(officernote) then
            messageText = ConvergeFu:ColourTextWhite(L["tools-gs-main-officer-note-msg-02"])
                        ..ConvergeFu:ColourTextRed(name)
                        ..ConvergeFu:ColourTextWhite(L["tools-gs-main-officer-note-msg-03"])
                        ..ConvergeFu:ColourTextYellow(officernote)
                        ..ConvergeFu:ColourTextWhite(L["tools-gs-main-officer-note-msg-04"])                         
            self:Print(messageText)
         end
      end
   end

   messageText = ConvergeFu:ColourTextWhite(L["tools-gs-main-officer-note-msg-last"])
   
end

-- ============================================================================
-- == CheckAltCharacterRanks()                                               ==
-- ==                                                                        ==
-- == This function checks that all alt ranked characters have their rank    ==
-- == set correctly. The correct rank for an alt character is the alt rank   ==
-- == that corresponds to their main character.                              ==
-- ==                                                                        ==
-- == Alt-Officer Characters -> Main character holds the Officer/GM rank.    ==
-- == Alt-Hero    Characters -> Main character holds the Hero Member rank.   ==
-- == Alt-Normal  Characters -> Main character holds the Normal Member rank. ==
-- == Alt-Trial   Characters -> Main character holds the Trial Member rank.  ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:CheckAltCharacterRanks()

   messageText = ConvergeFu:ColourTextYellow(L["tools-gs-alt-ranks-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-01"])
               
   self:Print(messageText)  
   
   totalNumberOfGuildMembers = GetNumGuildMembers(true)
  
   for index=1, totalNumberOfGuildMembers, 1 do
     gsName, gsRank, gsRankIndex, gsLevel, gsClass, gsZone, gsNote, gsOfficernote, gsOnline, gsStatus = GetGuildRosterInfo(index)
    
     if ConvergeFu:IsAltRankedCharacter(gsName) then
        if ConvergeFu:IsOfficerRankedCharacter(gsNote) then
           if gsRank ~= L["common-rankname-alt-officer"] then
             messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-02"])
                         ..ConvergeFu:ColourTextRed(gsName)
                         ..ConvergeFu:ColourTextYellow(" ("..gsRank..")")
                         ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-03"])
                         ..ConvergeFu:ColourTextGreen(L["common-rankname-alt-officer"])
             self:Print(messageText)
           end
        end
        
        if ConvergeFu:IsHeroRankedCharacter(gsNote) then
           if gsRank ~= L["common-rankname-alt-hero"] then
             messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-02"])
                         ..ConvergeFu:ColourTextRed(gsName)
                         ..ConvergeFu:ColourTextYellow(" ("..gsRank..")")
                         ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-03"])
                         ..ConvergeFu:ColourTextGreen(L["common-rankname-alt-hero"])
             self:Print(messageText)
           end
        end
        
        if ConvergeFu:IsNormalRankedCharacter(gsNote) then
           if gsRank ~= L["common-rankname-alt-normal"] then
             messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-02"])
                         ..ConvergeFu:ColourTextRed(gsName)
                         ..ConvergeFu:ColourTextYellow(" ("..gsRank..")")
                         ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-03"])
                         ..ConvergeFu:ColourTextGreen(L["common-rankname-alt-normal"])
             self:Print(messageText)           
           end
        end        
        
        if ConvergeFu:IsTrialRankedCharacter(gsNote) then
           if gsRank ~= L["common-rankname-alt-trial"] then
             messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-02"])
                         ..ConvergeFu:ColourTextRed(gsName)
                         ..ConvergeFu:ColourTextYellow(" ("..gsRank..")")
                         ..ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-03"])
                         ..ConvergeFu:ColourTextGreen(L["common-rankname-alt-trial"])
             self:Print(messageText)           
           end
        end        
        
     end

   end
   
   messageText = ConvergeFu:ColourTextWhite(L["tools-gs-alt-ranks-msg-last"])

   -- self:Print(messageText)
  
end

-- ============================================================================
-- == CheckCurrentGuildActivityStatus()                                      ==
-- ==                                                                        ==
-- == This function checks the guild's current activity status by inspecting ==
-- == the in-game Guild Message of the Day (GMOTD) field which is used       ==
-- == within the guild to advise members on raiding activities.              ==
-- ============================================================================

function ConvergeFu:CheckCurrentGuildActivityStatus()

   -- == ----------------------------------------------------------------------
   -- == -- Setup text-message strings.                                      --
   -- == ----------------------------------------------------------------------
   mainMessageText = ConvergeFu:ColourTextPurple(L["tools-activity-monitor-msg-first"])
                   ..ConvergeFu:ColourTextWhite(L["tools-activity-monitor-msg-01"])

   invitesOpenText = ConvergeFu:ColourTextWhite(L["tools-am-raid-invitations-msg-01"])
   invitesFromText = ConvergeFu:ColourTextWhite(L["tools-am-raid-invitations-msg-02"])

   raidInProgressText = ConvergeFu:ColourTextWhite(L["tools-am-raid-in-progress-msg-01"])
   queueManagerText   = ConvergeFu:ColourTextWhite(L["tools-am-raid-in-progress-msg-02"])
   
   noActivityText  = ConvergeFu:ColourTextPurple(L["tools-activity-monitor-msg-first"])
                   ..ConvergeFu:ColourTextWhite(L["tools-activity-monitor-msg-03"])

   warningText1 = ConvergeFu:ColourTextPurple(L["tools-activity-monitor-msg-first"])
                ..ConvergeFu:ColourTextWhite(L["tools-am-already-grouped-msg-01"])
   warningText2 = ConvergeFu:ColourTextWhite(L["tools-am-already-grouped-msg-02"])
   
   -- == ----------------------------------------------------------------------
   -- == -- Since this method is only run when the user ctrl-alt-clicks on   --
   -- == -- the ConvergeFu icon, we know they WANT to attempt to join a raid --
   -- == -- or wait list therefore we need to ensure that the flag for       --
   -- == -- showing raid activities is switched on.                          --
   -- == ----------------------------------------------------------------------                   
   ConvergeFu.db.profile.showRaidActivities = L["common-data-option-on"]
   
   -- == ----------------------------------------------------------------------
   -- == -- Check whether the player is already in a party or raid group and --
   -- == -- cease processing the checks if they are, outputting a message    --
   -- == -- informing the player that they are in a party/raid and need to   --
   -- == -- leave the party/raid before they can proceed.                    --
   -- == ----------------------------------------------------------------------
   local numRaidMembers  = ConvergeFu:SafeNumber(GetNumGroupMembers())
   local numPartyMembers = ConvergeFu:SafeNumber(GetNumGroupMembers())
   
   if numRaidMembers  > 0
   or numPartyMembers > 0 then
      self:Print(warningText1)
      self:Print(warningText2)
      return  
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Retrieve the GMOTD, decode into component parts. (ie: Words.)    --
   -- == ----------------------------------------------------------------------
   self:Print(mainMessageText)
   currentGMOTDText     = ConvergeFu:SafeText(GetGuildRosterMOTD())
   local Args           = self:GetArgs(currentGMOTDText, " ")
   currentRaidActivity  = L["common-data-option-no"]
   
   ConvergeFu:Debug("GMOTD: "..currentGMOTDText)
   
   -- == ----------------------------------------------------------------------
   -- == -- Test the GMOTD: Is the raid invitation period open?              --
   -- == ----------------------------------------------------------------------
   if string.len(currentGMOTDText) > 43 then
      if string.sub(currentGMOTDText, 1, 44) == L["common-motd-raidinvites-01"] then
         ConvergeFu.db.profile.raidInviter = Args[7]
         self:Print(invitesOpenText)
         self:Print(invitesFromText..ConvergeFu:ColourTextGreen(ConvergeFu.db.profile.raidInviter)..".")
         currentRaidActivity  = L["common-data-option-yes"]
         ConvergeFu:DoProcessRaidInvitationAnnouncement(ConvergeFu.db.profile.raidInviter, "GUILD", UnitName("player"))         
      end
   end

   -- == ----------------------------------------------------------------------
   -- == -- Test the GMOTD: Is a raid currently in progress?                 --
   -- == ----------------------------------------------------------------------
   if string.len(currentGMOTDText) > 37 then
      if string.sub(currentGMOTDText, 1, 38) == L["common-motd-raidinprogress-01"] then
         ConvergeFu.db.profile.raidQueueManager = Args[8]
         self:Print(raidInProgressText)
         self:Print(queueManagerText..ConvergeFu:ColourTextGreen(ConvergeFu.db.profile.raidQueueManager)..".")
         currentRaidActivity  = L["common-data-option-yes"]
         ConvergeFu:ConfirmJoinWaitlist()
      end
   end   

   if currentRaidActivity == L["common-data-option-no"] then
      self:Print(noActivityText)
   end
end

-- ============================================================================
-- == ConfirmJoinWaitlist()                                                  ==
-- ==                                                                        ==
-- == This function confirms whether or not the player wishes to join the    ==
-- == raid wait-list, by whispering 'wl add' to the current raid queue       ==
-- == manager.                                                               ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:ConfirmJoinWaitlist()

   -- == ----------------------------------------------------------------------
   -- == -- Do not proceed if you are already in the same raid.              --
   -- == ----------------------------------------------------------------------
   if UnitName("player") == ConvergeFu.db.profile.raidQueueManager
   or UnitInRaid(ConvergeFu.db.profile.raidQueueManager)  == 1 
   or UnitInParty(ConvergeFu.db.profile.raidQueueManager) == 1 then
      return
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Configure the text strings...                                    --
   -- == ----------------------------------------------------------------------
   characterToWhisper = ConvergeFu.db.profile.raidQueueManager
   windowTitle        = L["event-raid-queue-window-msg-01"]..characterToWhisper.."?"
   
   joinMessage        = ConvergeFu:ColourTextPurple(L["event-raid-queue-msg-first"])
                      ..ConvergeFu:ColourTextWhite(L["event-raid-queue-join-msg-01"])
                      
   cancelMessage      = ConvergeFu:ColourTextPurple(L["event-raid-queue-msg-first"])
                      ..ConvergeFu:ColourTextWhite(L["event-raid-queue-cancel-msg-01"])
                      ..ConvergeFu:ColourTextYellow(L["event-raid-queue-keyword-add"])
                      ..ConvergeFu:ColourTextWhite(L["event-raid-queue-cancel-msg-02"])
                      ..ConvergeFu:ColourTextGreen(characterToWhisper)
                      ..ConvergeFu:ColourTextWhite(L["event-raid-queue-cancel-msg-03"])
   
   -- == ----------------------------------------------------------------------
   -- == -- Configure the popup window...                                    --
   -- == ----------------------------------------------------------------------
   StaticPopupDialogs[L["event-raid-queue-window-title"]] = {
      
      text         = windowTitle,
      button1      = L["event-raid-queue-window-btn-yes"],
      button2      = L["event-raid-queue-window-btn-no"],      
      timeout      = 30,
      whileDead    = 1,
      hideOnEscape = 0,

      OnAccept = function()
         ConvergeFu:SendMessage(L["event-raid-queue-keyword-add"], "WHISPER", nil, characterToWhisper)
         ConvergeFu:SendMessage(L["event-raid-queue-keyword-who"], "WHISPER", nil, characterToWhisper)
         ConvergeFu.db.profile.showRaidActivities = L["common-data-option-off"]
         self:Print(joinMessage)
      end,
      
      OnCancel = function()
         ConvergeFu.db.profile.showRaidActivities = L["common-data-option-on"]
         self:Print(cancelMessage)
      end      
   }

   -- == ----------------------------------------------------------------------
   -- == -- Display the popup window...                                      --
   -- == ----------------------------------------------------------------------
   if ConvergeFu.db.profile.showQueueRequests == L["common-data-option-on"] then
      StaticPopup_Show (L["event-raid-queue-window-title"])
      PlaySound("DwarfExploration")
   end
end

-- ============================================================================
-- == CreateVersionCheckFrame(sender, versionText)                           ==
-- ==                                                                        ==
-- == This function creates the version check frame and populates it with    ==
-- == the details of the player whose version is more up-to-date than the    ==
-- == one being used by the user.                                            ==
-- ==                                                                        ==
-- == This function was adapted from the similar function provided in the    ==
-- == ACE library API for creating an 'About' information window for a FuBar ==
-- == compatible plugin addon.                                               ==
-- ============================================================================

function ConvergeFu:CreateVersionCheckFrame(sender, versionText)
  
   -- == ----------------------------------------------------------------------
   -- == -- Create the window frame object and configure its properties.     --
   -- == ----------------------------------------------------------------------
   versionCheckFrame = CreateFrame("Frame", "AceAddon20versionCheckFrame", UIParent, "DialogBoxFrame")
   versionCheckFrame:SetWidth(500)
   versionCheckFrame:SetHeight(400)
   versionCheckFrame:SetPoint("CENTER")
   versionCheckFrame:SetBackdrop({
      bgFile   = [[Interface\DialogFrame\UI-DialogBox-Background]],
      edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
      tile     = true, tileSize = 16, edgeSize = 16,
      insets   = { left = 5, right = 5, top = 5, bottom = 5 }
   })
   versionCheckFrame:SetBackdropColor(0,0,0,1)

   -- == ----------------------------------------------------------------------
   -- == -- Set the window's title text.                                     --
   -- == ----------------------------------------------------------------------
   local text = versionCheckFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLarge")
   versionCheckFrame.title = text
   text:SetPoint("TOP", 0, -5)

   -- == ----------------------------------------------------------------------
   -- == -- Initialise the window's text arrays.                             --
   -- == ----------------------------------------------------------------------
   versionCheckFrame.lefts = {}
   versionCheckFrame.rights = {}
   versionCheckFrame.textLefts = {}
   versionCheckFrame.textRights = {}

   -- == ----------------------------------------------------------------------
   -- == -- Object function: Clear the window.                               --
   -- == ----------------------------------------------------------------------
   function versionCheckFrame:Clear()
      self.title:SetText("")
      for i = 1, #self.lefts do
         self.lefts[i] = nil
         self.rights[i] = nil
      end
   end
  
   -- == ----------------------------------------------------------------------
   -- == -- Object function: Prepare the window for a new version check.     --
   -- == ----------------------------------------------------------------------
   function versionCheckFrame:PrepareForVersionCheck()
      versionCheckFrame.rights[1] = L["event-addon-vc-uptodate-02-msg"]
      
      for i = 4, #self.lefts do
         self.lefts[i] = nil
         self.rights[i] = nil
      end
   end  

   -- == ----------------------------------------------------------------------
   -- == -- Object function: Add a line of text to the window.               --
   -- == ----------------------------------------------------------------------
   function versionCheckFrame:AddLine(left, right)
      versionCheckFrame.lefts[#versionCheckFrame.lefts+1] = left
      versionCheckFrame.rights[#versionCheckFrame.rights+1] = right
   end

   -- == ----------------------------------------------------------------------
   -- == -- Object function: Show the window.                                --
   -- == ----------------------------------------------------------------------
   local versionCheckFrame_Show = versionCheckFrame.Show
   function versionCheckFrame:Show(...)
      local maxLeftWidth = 0
      local maxRightWidth = 0
      local textHeight = 0
      for i = 1, #self.lefts do
         if not self.textLefts[i] then
            local left = versionCheckFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
            self.textLefts[i] = left
            local right = versionCheckFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
            self.textRights[i] = right
            if i == 1 then
              -- left:SetPoint("TOPRIGHT", versionCheckFrame, "TOPLEFT", 75, -35)
              left:SetPoint("TOPRIGHT", versionCheckFrame, "TOPLEFT", 100, -35)
            else
              left:SetPoint("TOPRIGHT", self.textLefts[i-1], "BOTTOMRIGHT", 0, -5)
            end
            right:SetPoint("LEFT", left, "RIGHT", 5, 0)
         end
         if self.lefts[i] == "@NULL@" then
            self.textLefts[i]:SetText(" ")
         else
            self.textLefts[i]:SetText(self.lefts[i] .. ":")
         end
      
         -- self.textLefts[i]:SetText(self.lefts[i] .. ":")
         self.textRights[i]:SetText(self.rights[i])
         local leftWidth = self.textLefts[i]:GetWidth()
         local rightWidth = self.textRights[i]:GetWidth()
         textHeight = self.textLefts[i]:GetHeight()
         if maxLeftWidth < leftWidth then
            maxLeftWidth = leftWidth
         end
         if maxRightWidth < rightWidth then
            maxRightWidth = rightWidth
         end
      end
      for i = #self.lefts+1, #self.textLefts do
         self.textLefts[i]:SetText('')
         self.textRights[i]:SetText('')
      end
      -- versionCheckFrame:SetWidth(75 + maxRightWidth + 20)
      versionCheckFrame:SetWidth(100 + maxRightWidth + 20)
      versionCheckFrame:SetHeight(#self.lefts * (textHeight + 5) + 100)

      versionCheckFrame_Show(self, ...)
   end

   -- == ----------------------------------------------------------------------
   -- == -- Initialise the window configuration.                             --
   -- == ----------------------------------------------------------------------
   myVersionText = ConvergeFu:ColourTextBlizzard(L["versionName"]..": ")
                 ..ConvergeFu:ColourTextYellow(L["versionNumber"])

   versionCheckFrame.title:SetText(tostring(self.title))
   versionCheckFrame:AddLine(L["event-addon-vc-uptodate-title"], L["event-addon-vc-uptodate-01-msg"])
   versionCheckFrame:AddLine("@NULL@", " ")
   versionCheckFrame:AddLine(UnitName("player"), myVersionText)
  
   if sender ~= nil and sender ~= "@NULL@" then 
      versionCheckFrame:AddLine(sender, versionText)
   end

   -- == ----------------------------------------------------------------------
   -- == -- Set a flag indicating that the window has been created.          --
   -- == ----------------------------------------------------------------------
   versionCheckFrameCreated = L["common-data-option-one"]
end

-- ============================================================================
-- == ListRaidersWithMissingConsumables(channelName)                         ==
-- ==                                                                        ==
-- == This function will output the names of raiders that have missing       ==
-- == consumables.                                                           ==
-- ============================================================================

function ConvergeFu:ListRaidersWithMissingConsumables(channelName)

   -- == ----------------------------------------------------------------------
   -- == -- Configure Text Strings...                                        --
   -- == ----------------------------------------------------------------------
   buffMonitorText  = L["tools-bm-msg-first"]..L["tools-bm-msg-looking"]
                   
   checkingRaidText = L["tools-bm-raid-members-checking-msg-01"]            

   allDoneText      = L["tools-bm-msg-first"]..L["tools-bm-msg-completed"]
   
   -- == ----------------------------------------------------------------------
   -- == -- Proceed with processing the current raid members.                --
   -- == ----------------------------------------------------------------------
   ConvergeFu:SendChatMessage(buffMonitorText, channelName)
   -- print(checkingRaidText)

   numberOfRaidMembers = GetNumGroupMembers()   
   
   for index=1, numberOfRaidMembers, 1 do
      name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(index)

      checkThisCharacter = L["common-data-option-yes"]
      
      -- == -------------------------------------------------------------------
      -- == -- Do we really need to check this character?                    --
      -- == -------------------------------------------------------------------
      if isDead == 1 then
         if ConvergeFu.db.profile.bmReportDead == L["common-data-option-on"] then
            ConvergeFu:SendChatMessage(" - "..name..L["tools-bm-is-dead-msg-01"], channelName)
         end
         checkThisCharacter = L["common-data-option-no"]
      end
      
      if online == nil then
         if ConvergeFu.db.profile.bmReportOffline == L["common-data-option-on"] then
            ConvergeFu:SendChatMessage(" - "..name..L["tools-bm-is-offline-msg-01"], channelName)
         end
         checkThisCharacter = L["common-data-option-no"]
      end
      
      -- == -------------------------------------------------------------------
      -- == -- If we need to check this character, perform the checks.       --
      -- == -------------------------------------------------------------------
      if checkThisCharacter == L["common-data-option-yes"] then
         ConvergeFu:CheckCharacterForMissingConsumables(name, channelName)
      end
   end
   
   ConvergeFu:SendChatMessage(allDoneText, channelName)
   
end

-- ============================================================================
-- == CheckCharacterForMissingConsumables(characterName, channelName)        ==
-- ==                                                                        ==
-- == This function will output the names of raiders that have missing       ==
-- == consumables.                                                           ==
-- ============================================================================

function ConvergeFu:CheckCharacterForMissingConsumables(characterName, channelName)

   ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-no"]

   hasSuitableFlask             = ConvergeFu:IsCharacterBuffedWithSuitableFlask(characterName)
   hasSuitableBattleElixir      = ConvergeFu:IsCharacterBuffedWithSuitableBattleElixir(characterName)
   hasSuitableGuardianElixir    = ConvergeFu:IsCharacterBuffedWithSuitableGuardianElixir(characterName)
   hasSuitableFoodBuff          = ConvergeFu:IsCharacterBuffedWithSuitableFood(characterName)
   hasSuitableRoguePoisonBuffs  = ConvergeFu:IsCharacterBuffedWithSuitableRoguePoisons(characterName)
   
   -- == ----------------------------------------------------------------------
   -- == -- Check if character has a flask or two elixirs activated.         --
   -- == ----------------------------------------------------------------------
   if not hasSuitableFlask then

      -- == -------------------------------------------------------------------
      -- == -- Has guardian elixir but suitable battle elixir missing.       --
      -- == -------------------------------------------------------------------
      if  not hasSuitableBattleElixir
      and     hasSuitableGuardianElixir then
         if ConvergeFu.db.profile.bmReportElixirs == L["common-data-option-on"] then
            ConvergeFu:SendChatMessage(" - "..characterName..L["tools-bm-has"]..L["tools-bm-no-battle-elixir-msg-01"], channelName)
            ConvergeFu:SendBMNotificationByAddon(characterName, L["tools-bm-you-have"]..L["tools-bm-no-battle-elixir-msg-01"])
            ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-yes"]
         end
      end

      -- == -------------------------------------------------------------
      -- == -- Has battle elixir but suitable guardian elixir missing. --
      -- == -------------------------------------------------------------
      if      hasSuitableBattleElixir
      and not hasSuitableGuardianElixir then
         if ConvergeFu.db.profile.bmReportElixirs == L["common-data-option-on"] then
            ConvergeFu:SendChatMessage(" - "..characterName..L["tools-bm-has"]..L["tools-bm-no-guardian-elixir-msg-01"], channelName)
            ConvergeFu:SendBMNotificationByAddon(characterName, L["tools-bm-you-have"]..L["tools-bm-no-guardian-elixir-msg-01"])
            ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-yes"]
         end
      end 

      -- == -------------------------------------------------------------
      -- == -- No flask, no battle elixir, no guardian elixir.         --
      -- == -------------------------------------------------------------            
      if  not hasSuitableBattleElixir
      and not hasSuitableGuardianElixir then
         if ConvergeFu.db.profile.bmReportFlasks == L["common-data-option-on"] then
            ConvergeFu:SendChatMessage(" - "..characterName..L["tools-bm-has"]..L["tools-bm-no-flask-or-elixir-msg-01"], channelName)
            ConvergeFu:SendBMNotificationByAddon(characterName, L["tools-bm-you-have"]..L["tools-bm-no-flask-or-elixir-msg-01"])
            ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-yes"]
         end
      end            
   
   end

   -- == ----------------------------------------------------------------
   -- == -- Check if character has a food-buff activated.              --
   -- == ----------------------------------------------------------------
   if not hasSuitableFoodBuff then
      if ConvergeFu.db.profile.bmReportFood == L["common-data-option-on"] then
         ConvergeFu:SendChatMessage(" - "..characterName..L["tools-bm-has"]..L["tools-bm-food-buff-missing-msg-01"], channelName)
         ConvergeFu:SendBMNotificationByAddon(characterName, L["tools-bm-you-have"]..L["tools-bm-food-buff-missing-msg-01"])
         ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-yes"]
      end
   end

   -- == ----------------------------------------------------------------
   -- == -- Check if character has suitable rogue poisons activated.   --
   -- == ----------------------------------------------------------------
   if UnitClass(characterName) == L["common-data-class-name-rogue"] then
      if not hasSuitableRoguePoisonBuffs then
         if ConvergeFu.db.profile.bmReportRoguePoisons == L["common-data-option-on"] then
            ConvergeFu:SendChatMessage(" - "..characterName..L["tools-bm-has"]..L["tools-bm-rogue-poison-missing-msg-01"], channelName)
            ConvergeFu:SendBMNotificationByAddon(characterName, L["tools-bm-you-have"]..L["tools-bm-rogue-poison-missing-msg-01"])
            ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-yes"]
         end
      end
   end
   
   -- == ----------------------------------------------------------------
   -- == -- Check if character buffs are nearing expiry.               --
   -- == ----------------------------------------------------------------
   if ConvergeFu.db.profile.bmReportExpiry == L["common-data-option-on"] then
      ConvergeFu:CheckBuffExpiryTimes(characterName, channelName)
   end
   
end

-- ============================================================================
-- == SendBMNotificationByWhisper(characterName, message)                    ==
-- ==                                                                        ==
-- == This function will send a BuffMonitor whisper message to a nominated   ==
-- == character if the bmNotifyStatus flag is switched on.                   ==
-- ============================================================================

function ConvergeFu:SendBMNotificationByWhisper(characterName, message)

   if ConvergeFu.db.profile.bmNotifyStatus == L["common-data-option-on"] then
      ConvergeFu:SendMessage(message, "WHISPER", " ", characterName)
   end
   
end

-- ============================================================================
-- == SendBMNotificationByAddon(characterName, message)                      ==
-- ==                                                                        ==
-- == This function will send a BuffMonitor inter-addon message to a         ==
-- == nominated character if the bmNotifyStatus flag is switched on.         ==
-- ============================================================================

function ConvergeFu:SendBMNotificationByAddon(characterName, message)
   
   if ConvergeFu.db.profile.bmNotifyStatus == L["common-data-option-on"] then
      SendAddonMessage(L["event-addon-buff-monitor-notification"], message, "WHISPER", characterName)
   end
   
end

-- ============================================================================
-- == DoProcessBMNotification(msg, sender)                                   ==
-- ==                                                                        ==
-- == This function processes the BuffMonitor notification message received  ==
-- == via the addon channel, indicating this player is missing some buffs.   ==
-- ============================================================================

function ConvergeFu:DoProcessBMNotification(msg, sender)

   -- bmNotificationText1 = L["tools-bm-msg-first"]..msg.." ["..L["tools-bm-msg-from"]..sender.."]"
   -- Above is same as line below but with " [From: Broliant]" tag at end.
   
   bmNotificationText1 = L["tools-bm-msg-first"]..msg
   bmNotificationText1 = ConvergeFu:ColourTextForReportTitle(bmNotificationText1, "CHAT")
   
   -- print(bmNotificationText1)
   
   UIErrorsFrame:AddMessage(bmNotificationText1, 0, 1.0, 1.0, 1.0, 1)
   
end

-- ============================================================================
-- == IsCharacterBuffedWithSuitableFlask(characterName)                      ==
-- ==                                                                        ==
-- == This function will return true if the character being tested has a     ==
-- == suitable flask activated.                                              ==
-- ============================================================================
function ConvergeFu:IsCharacterBuffedWithSuitableFlask(characterName)

   -- == ----------------------------------------------------------------------
   -- == -- Get the array of 'suitable' flasks.                              --
   -- == ----------------------------------------------------------------------
   local suitableArray = ConvergeFu:GetSuitableFlasksArray()
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the test.                                                --
   -- == ----------------------------------------------------------------------
   for b = 1, 64 do
      local buffName = UnitBuff(characterName, b)
      if buffName then
         for i,v in ipairs(suitableArray) do
            if suitableArray[i] == buffName then
               return true
            end
         end
      end
   end
   
   return false
   
end

-- ============================================================================
-- == IsCharacterBuffedWithSuitableBattleElixir(characterName)               ==
-- ==                                                                        ==
-- == This function will return true if the character being tested has a     ==
-- == suitable battle elixir activated.                                      ==
-- ============================================================================
function ConvergeFu:IsCharacterBuffedWithSuitableBattleElixir(characterName)

   -- == ----------------------------------------------------------------------
   -- == -- Get the array of 'suitable' battle elixirs.                      --
   -- == ----------------------------------------------------------------------
   local suitableArray = ConvergeFu:GetSuitableBattleElixirsArray()
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the test.                                                --
   -- == ----------------------------------------------------------------------
   for b = 1, 64 do
      local buffName = UnitBuff(characterName, b)
      if buffName then
         for i,v in ipairs(suitableArray) do
            if suitableArray[i] == buffName then
               return true
            end
         end
      end
   end
   
   return false
   
end

-- ============================================================================
-- == IsCharacterBuffedWithSuitableGuardianElixir(characterName)             ==
-- ==                                                                        ==
-- == This function will return true if the character being tested has a     ==
-- == suitable guardian elixir activated.                                    ==
-- ============================================================================
function ConvergeFu:IsCharacterBuffedWithSuitableGuardianElixir(characterName)

   -- == ----------------------------------------------------------------------
   -- == -- Get the array of 'suitable' guardian elixirs.                    --
   -- == ----------------------------------------------------------------------
   local suitableArray = ConvergeFu:GetSuitableGuardianElixirsArray()
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the test.                                                --
   -- == ----------------------------------------------------------------------
   for b = 1, 64 do
      local buffName = UnitBuff(characterName, b)
      if buffName then
         for i,v in ipairs(suitableArray) do
            if suitableArray[i] == buffName then
               return true
            end
         end
      end
   end
   
   return false
   
end

-- ============================================================================
-- == IsCharacterBuffedWithSuitableFood(characterName)                       ==
-- ==                                                                        ==
-- == This function will return true if the character being tested has a     ==
-- == suitable food buff activated.                                          ==
-- ============================================================================
function ConvergeFu:IsCharacterBuffedWithSuitableFood(characterName)

   -- == ----------------------------------------------------------------------
   -- == -- Get the array of 'suitable' foods.                               --
   -- == ----------------------------------------------------------------------
   local suitableArray = ConvergeFu:GetSuitableFoodArray()
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the test.                                                --
   -- == ----------------------------------------------------------------------
   for b = 1, 64 do
      local buffName = UnitBuff(characterName, b)
      if buffName then
         for i,v in ipairs(suitableArray) do
            if suitableArray[i] == buffName then
               return true
            end
         end
      end
   end
   
   return false
   
end

-- ============================================================================
-- == IsCharacterBuffedWithSuitableRoguePoisons(characterName)               ==
-- ==                                                                        ==
-- == This function will return true if the character being tested has two   ==
-- == suitable rogue poison buffs activated.                                 ==
-- ============================================================================
function ConvergeFu:IsCharacterBuffedWithSuitableRoguePoisons(characterName)

   -- == ----------------------------------------------------------------------
   -- == -- If it is impossible to inspect the player, return the default    --
   -- == -- response. This is currently 'true' because we do not want an     --
   -- == -- inability to inspect to trigger 'false-positives'.               --
   -- == ----------------------------------------------------------------------
   if not CanInspect(characterName) then
      return true
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Get the array of 'suitable' rogue poisons.                       --
   -- == ----------------------------------------------------------------------
   local suitableArray = ConvergeFu:GetSuitableRoguePoisonsArray()

   -- == ----------------------------------------------------------------------
   -- == -- Initialise a counter for rogue poison buffs.                     --
   -- == ----------------------------------------------------------------------
   local poisonBuffCount = 0

   -- == ----------------------------------------------------------------------
   -- == -- Advise server of imminent character inspection.                  --
   -- == ----------------------------------------------------------------------
   NotifyInspect(characterName)
   
   -- == ----------------------------------------------------------------------
   -- == -- Check the character's mainhand weapon.                           --
   -- == ----------------------------------------------------------------------   
   TooltipScanner:ClearLines()
   TooltipScanner:SetInventoryItem(characterName, 16)
   
   if TooltipScanner:NumLines() < 1 then
      ConvergeFu:Debug("tooltipscanner numlines is <1")
   else
      for i,v in ipairs(suitableArray) do
         
         if ConvergeFu:FindInTooltips(v) then
            poisonBuffCount = poisonBuffCount + 1
         end
      end   
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Check the character's offhand weapon.                           --
   -- == ----------------------------------------------------------------------   
   TooltipScanner:ClearLines()
   TooltipScanner:SetInventoryItem(characterName, 17)
   
   if TooltipScanner:NumLines() < 1 then
      ConvergeFu:Debug("tooltipscanner numlines is <1")
   else
      for i,v in ipairs(suitableArray) do
         
         if ConvergeFu:FindInTooltips(v) then
            poisonBuffCount = poisonBuffCount + 1
         end
      end   
   end   
   
   if poisonBuffCount == 2 then
      return true
   else
      return false
   end
   
end

-- ============================================================================
-- == FindInTooltips(textToFind)                                             ==
-- ==                                                                        ==
-- == This function simply examines an item's tooltip looking for the text   ==
-- == string supplied.                                                       ==
-- ============================================================================

function ConvergeFu:FindInTooltips(textToFind)
 
   textToFind = ConvergeFu:SafeText(textToFind)
   
   local numTooltipLines = TooltipScanner:NumLines()
   for tooltipLineNumber = 1, numTooltipLines do
      local tooltipTextLine = getglobal('TooltipScannerTextLeft' .. tooltipLineNumber):GetText()
      if tooltipTextLine then
         if string.find(tooltipTextLine, textToFind) then
            return true
         end
      else
         return false
      end
   end
   return false   
end

-- ============================================================================
-- == GetSuitableFlasksArray()                                               ==
-- ==                                                                        ==
-- == This function simply returns the currently valid array of suitable     ==
-- == flasks with respect to PVE raid usage.                                 ==
-- ============================================================================

function ConvergeFu:GetSuitableFlasksArray()

   -- == ----------------------------------------------------------------------
   -- == -- Suitable flasks are identified by their spell-IDs.               --
   -- == ----------------------------------------------------------------------
   local suitableFlasks = {
      GetSpellInfo(53760), -- Wrath - Flask of Endless Rage.
      GetSpellInfo(53755), -- Wrath - Flask of the Frost Wyrm.
      GetSpellInfo(54212), -- Wrath - Flask of Pure Mojo.
      GetSpellInfo(53758), -- Wrath - Flask of Stoneblood.
      GetSpellInfo(62380), -- Wrath - Lesser Flask of Resistance.
   }
   
   return suitableFlasks
   
end

-- ============================================================================
-- == GetSuitableBattleElixirsArray()                                        ==
-- ==                                                                        ==
-- == This function simply returns the currently valid array of suitable     ==
-- == battle elixirs with respect to PVE raid usage.                         ==
-- ============================================================================

function ConvergeFu:GetSuitableBattleElixirsArray()

   -- == ----------------------------------------------------------------------
   -- == -- Suitable battle elixirs are identified by their spell-IDs.       --
   -- == ----------------------------------------------------------------------
   local suitableBattleElixirs = {
      GetSpellInfo(60340), -- Wrath - Accuracy.
      GetSpellInfo(60345), -- Wrath - Armor Piercing.
      GetSpellInfo(60341), -- Wrath - Deadly Strikes.
      GetSpellInfo(60344), -- Wrath - Expertise.
      GetSpellInfo(53749), -- Wrath - Guru's Elixir.
      GetSpellInfo(60346), -- Wrath - Lightning Speed.
      GetSpellInfo(28497), -- Wrath - Mighty Agility.
      GetSpellInfo(53748), -- Wrath - Mighty Strength.
      GetSpellInfo(33721), -- Wrath - Spellpower Elixir.
      GetSpellInfo(53746), -- Wrath - Wrath Elixir.
   }
   
   return suitableBattleElixirs
   
end

-- ============================================================================
-- == GetSuitableGuardianElixirsArray()                                      ==
-- ==                                                                        ==
-- == This function simply returns the currently valid array of suitable     ==
-- == guardian elixirs with respect to PVE raid usage.                       ==
-- ============================================================================

function ConvergeFu:GetSuitableGuardianElixirsArray()

   -- == ----------------------------------------------------------------------
   -- == -- Suitable guardian elixirs are identified by their spell-IDs.     --
   -- == ----------------------------------------------------------------------
   local suitableGuardianElixirs = {
      GetSpellInfo(53763), -- Wrath - Elixir of Protection.
      GetSpellInfo(53747), -- Wrath - Elixir of Spirit.
      GetSpellInfo(60343), -- Wrath - Mighty Defense.
      GetSpellInfo(53751), -- Wrath - Mighty Fortitude.
      GetSpellInfo(53764), -- Wrath - Mighty Mageblood.
      GetSpellInfo(60347), -- Wrath - Mighty Thoughts.
   }
   
   return suitableGuardianElixirs
   
end

-- ============================================================================
-- == GetSuitableFoodArray()                                                 ==
-- ==                                                                        ==
-- == This function simply returns the currently valid array of suitable     ==
-- == food related buffs with respect to PVE raid usage.                     ==
-- ============================================================================

function ConvergeFu:GetSuitableFoodArray()

   -- == ----------------------------------------------------------------------
   -- == -- Suitable food buffs are identified by their spell-IDs.           --
   -- == ----------------------------------------------------------------------
   local suitableFoods = {
      GetSpellInfo(35272), -- Well Fed
      -- GetSpellInfo(44106), -- "Well Fed" from Brewfest
   }
   
   return suitableFoods
   
end

-- ============================================================================
-- == GetSuitableRoguePoisonsArray()                                         ==
-- ==                                                                        ==
-- == This function simply returns the currently valid array of suitable     ==
-- == rogue poisons for end-game content.                                    ==
-- ============================================================================

function ConvergeFu:GetSuitableRoguePoisonsArray()

   -- == ----------------------------------------------------------------------
   -- == -- Suitable rogue poisons are identified by their spell-IDs.        --
   -- == ----------------------------------------------------------------------
   local suitableRoguePoisons = {

      ConvergeFu:GetSpellNameFromSpellInfo(3408),  -- Classic -  Crippling Poison
      ConvergeFu:GetSpellNameFromSpellInfo(5760),  -- Classic -  Mind Numbing Poison
      
      ConvergeFu:GetSpellNameFromSpellInfo(57981), -- Wrath   -  Anaesthetic Poison II
      ConvergeFu:GetSpellNameFromSpellInfo(57970), -- Wrath   -  Deadly Poison IX
      ConvergeFu:GetSpellNameFromSpellInfo(57965), -- Wrath   -  Instant Poison IX
      ConvergeFu:GetSpellNameFromSpellInfo(57975), -- Wrath   -  Wound Poison VII
      
      -- "Anaesthetic Poison II",
      -- "Deadly Poison IX",
      -- "Instant Poison IX",
     
      -- GetSpellInfo(57981)[1], -- Wrath -  Anaesthetic Poison II
      -- GetSpellInfo(3408)[1],  -- Wrath -  Crippling Poison
      -- GetSpellInfo(57970)[1], -- Wrath -  Deadly Poison IX
      -- GetSpellInfo(57965)[1], -- Wrath -  Instant Poison IX
      -- GetSpellInfo(5760)[1],  -- Wrath -  Mind Numbing Poison
      -- GetSpellInfo(57975)[1], -- Wrath -  Wound Poison VII
   }
   
   return suitableRoguePoisons
   
end

-- ============================================================================
-- == GetSpellNameFromSpellInfo(spellId)                                     ==
-- ==                                                                        ==
-- == This function simply returns the name of a spell when supplied with    ==
-- == a spellId by using the standard API function GetSpellInfo(spellId) and ==
-- == retrieving the name from the data returned.                            ==
-- ============================================================================
function ConvergeFu:GetSpellNameFromSpellInfo(spellId)

   spellName, spellRank, spellIcon, spellPowerCost, spellIsFunnel, spellPowerType, spellCastingTime, spellMinRange, spellMaxRange = GetSpellInfo(spellId) 
   
   spellName = ConvergeFu:SafeText(spellName)
   
   return spellName
   
end

-- ============================================================================
-- == CheckBuffExpiryTimes(characterName, channelName)                       ==
-- ==                                                                        ==
-- == This function simply checks the expiry times of the buff-types that    ==
-- == ConvergeFu monitors and reports any buffs that will expire within a    ==
-- == prescribed time-limit to the nominated channel.                        ==
-- ============================================================================

function ConvergeFu:CheckBuffExpiryTimes(characterName, channelName)

   ConvergeFu:Debug("ConvergeFu:CheckBuffExpiryTimes("..characterName..", "..channelName..")")
   
   -- == ----------------------------------------------------------------------
   -- == -- Setup the 'suitable' buff array and other required properties.   --
   -- == ----------------------------------------------------------------------
   local suitableFlasksArray          = ConvergeFu:GetSuitableFlasksArray()
   local suitableBattleElixirsArray   = ConvergeFu:GetSuitableBattleElixirsArray()
   local suitableGuardianElixirsArray = ConvergeFu:GetSuitableGuardianElixirsArray()
   local suitableFoodArray            = ConvergeFu:GetSuitableFoodArray()
   local suitableRoguePoisonsArray    = ConvergeFu:GetSuitableRoguePoisonsArray()
   
   local timeLimitMinutes             = ConvergeFu.db.profile.bmExpiryTimeMinutes
   
   local suitableBuffsArray           = {}
   
   if ConvergeFu.db.profile.bmReportFlasks == L["common-data-option-on"] then
      suitableBuffsArray = ConvergeFu:JoinTables(suitableBuffsArray, suitableFlasksArray)
   end
   
   if ConvergeFu.db.profile.bmReportElixirs == L["common-data-option-on"] then
      suitableBuffsArray = ConvergeFu:JoinTables(suitableBuffsArray, suitableBattleElixirsArray)
      suitableBuffsArray = ConvergeFu:JoinTables(suitableBuffsArray, suitableGuardianElixirsArray)
   end
   
   if ConvergeFu.db.profile.bmReportFood == L["common-data-option-on"] then
      suitableBuffsArray = ConvergeFu:JoinTables(suitableBuffsArray, suitableFoodArray)
   end
   
   if ConvergeFu.db.profile.bmReportRoguePoisons == L["common-data-option-on"] then
      suitableBuffsArray = ConvergeFu:JoinTables(suitableBuffsArray, suitableRoguePoisonsArray)
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Perform the tests.                                               --
   -- == ----------------------------------------------------------------------
   for b = 1, 64 do
     local buffName, buffRank, buffIcon, buffCount, buffDispelType, buffDuration, buffExpires, buffCaster, buffIsStealable = UnitBuff(characterName, b)
      if buffName then
         if buffDuration then
            for i,v in ipairs(suitableBuffsArray) do
               if suitableBuffsArray[i] == buffName then
                  
                  remainingTime = ConvergeFu:SafeNumber(tonumber(format("%.2f",-1*(GetTime()-buffExpires)/60)))
                  
                  ConvergeFu:Debug("Buff: "..buffName)
                  ConvergeFu:Debug("Remaining Time: "..remainingTime..", timeLimitMinutes: "..ConvergeFu:SafeNumber(timeLimitMinutes))

                  if remainingTime < timeLimitMinutes then
                     ConvergeFu:SendChatMessage(" - "..characterName.."'s "..buffName..L["tools-bm-buff-expiry-msg-01"]..timeLimitMinutes..L["tools-bm-buff-expiry-msg-02"], channelName)
                     ConvergeFu:SendBMNotificationByAddon(characterName, L["tools-bm-your"].." "..buffName..L["tools-bm-buff-expiry-msg-01"]..timeLimitMinutes..L["tools-bm-buff-expiry-msg-02"])
                     ConvergeFu.db.profile.bmIssuesFound = L["common-data-option-yes"]
                  end
               end
            end
         end
      end
   end
   
end

-- ============================================================================
-- == JoinTables(table1, table2)                                             ==
-- ==                                                                        ==
-- == This function simply joins two tables together and returns the result. ==
-- ============================================================================
function ConvergeFu:JoinTables(table1, table2)
   
   for k,v in ipairs(table2) do
      table.insert(table1, v)
   end
   
   return table1   
   
end

-- ============================================================================
-- == ConfigureBuffMonitorBossMode()                                         ==
-- ==                                                                        ==
-- == This function simply provides a quick mechanism for setting up the     ==
-- == Buff Monitor options for 'boss-mode' operation.                        ==
-- ==                                                                        ==
-- == Settings:                                                              ==
-- ==                                                                        ==
-- == Combat-Monitor......: Global On, Enter On, Exit Off                    ==
-- == Personal Notifier...: On                                               ==
-- == Reporting Options...: All On.                                          ==
-- == Reporting Channel...: Raid                                             ==
-- ============================================================================

function ConvergeFu:ConfigureBuffMonitorBossMode()

   ConvergeFu.db.profile.bmCurrentProfile     = L["tools-bm-current-profile-boss"]

   ConvergeFu.db.profile.bmCMGlobalStatus     = L["common-data-option-on"]
   ConvergeFu.db.profile.bmCMEnterStatus      = L["common-data-option-on"]
   ConvergeFu.db.profile.bmCMExitStatus       = L["common-data-option-off"]

   ConvergeFu.db.profile.bmNotifyStatus       = L["common-data-option-on"]
   
   ConvergeFu.db.profile.bmReportFlasks       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportElixirs      = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportFood         = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportRoguePoisons = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportExpiry       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportDead         = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportOffline      = L["common-data-option-on"]
   
   ConvergeFu.db.profile.bmOutputChannel      = "RAID"
   
   titleText = ConvergeFu:ColourTextPurple(L["tools-bm-msg-first"])
             ..ConvergeFu:ColourTextWhite(L["tools-bm-profile-msg-boss-mode"])
             
   print(titleText)
   
   ConvergeFu:ShowBuffMonitorStatus(true, true, true, true)
   
end

-- ============================================================================
-- == ConfigureBuffMonitorTrashMode()                                        ==
-- ==                                                                        ==
-- == This function simply provides a quick mechanism for setting up the     ==
-- == Buff Monitor options for 'boss-mode' operation.                        ==
-- ==                                                                        ==
-- == Settings:                                                              ==
-- ==                                                                        ==
-- == Combat-Monitor......: Global Off                                       ==
-- == Personal Notifier...: Off                                              ==
-- == Reporting Options...: Flasks, Elixirs, Food, Expiry.                   ==
-- == Reporting Channel...: Chat                                             ==
-- ============================================================================

function ConvergeFu:ConfigureBuffMonitorTrashMode()

   ConvergeFu.db.profile.bmCurrentProfile     = L["tools-bm-current-profile-trash"]
   
   ConvergeFu.db.profile.bmCMGlobalStatus     = L["common-data-option-off"]

   ConvergeFu.db.profile.bmNotifyStatus       = L["common-data-option-off"]
   
   ConvergeFu.db.profile.bmReportFlasks       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportElixirs      = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportFood         = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportRoguePoisons = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportExpiry       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportDead         = L["common-data-option-off"]
   ConvergeFu.db.profile.bmReportOffline      = L["common-data-option-off"]

   ConvergeFu.db.profile.bmOutputChannel      = "CHAT"
   
   titleText = ConvergeFu:ColourTextPurple(L["tools-bm-msg-first"])
             ..ConvergeFu:ColourTextWhite(L["tools-bm-profile-msg-trash-mode"])
             
   print(titleText)
   
   ConvergeFu:ShowBuffMonitorStatus(true, true, true, true)
   
end

-- ============================================================================
-- == ToggleBuffMonitorProfile()                                             ==
-- ==                                                                        ==
-- == This function simply toggles between the various profile modes of the  ==
-- == buff monitor tool, enabling a quick and easy way to reconfigure the    ==
-- == tool's settings.                                                       ==
-- ==                                                                        ==
-- == Known Profiles:                                                        ==
-- ==                                                                        ==
-- == BOSS   - Standard configuration for use on boss encounters.            ==
-- == TRASH  - Standard configuration for use on trash encounters.           ==
-- == CUSTOM - Custom configuration set by the user.                         ==
-- ============================================================================

function ConvergeFu:ToggleBuffMonitorProfile()

   if ConvergeFu.db.profile.bmCurrentProfile == L["tools-bm-current-profile-custom"] then
      ConvergeFu:ConfigureBuffMonitorTrashMode()
      return
   end

   if ConvergeFu.db.profile.bmCurrentProfile == L["tools-bm-current-profile-trash"] then
      ConvergeFu:ConfigureBuffMonitorBossMode()
      return
   end
   
   if ConvergeFu.db.profile.bmCurrentProfile == L["tools-bm-current-profile-boss"] then
      ConvergeFu:ConfigureBuffMonitorTrashMode()
      return
   end   
   
end

-- ============================================================================
-- == ShowBuffMonitorStatus(showCombatStatus, showWhisperStatus,             ==
-- ==                       showReportingStatus, showOutputStatus)           ==
-- ==                                                                        ==
-- == This function will display the current status of the BuffMonitor tool  ==
-- == with the display varying according to the supplied flags.              ==
-- ============================================================================

function ConvergeFu:ShowBuffMonitorStatus(showCombatStatus, showWhisperStatus, showReportingStatus, showOutputStatus)

   -- == ----------------------------------------------------------------------
   -- == -- Configure the text strings that will comprise the display.       --
   -- == ----------------------------------------------------------------------
   titleText   = ConvergeFu:ColourTextPurple(L["tools-bm-msg-first"])
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-msg-first"])

   profileText = ConvergeFu:ColourTextYellow(L["tools-bm-profile-current-msg-first"])
               ..ConvergeFu:ColourTextWhite(ConvergeFu.db.profile.bmCurrentProfile)
               
   cmText      = ConvergeFu:ColourTextYellow(L["tools-bm-status-cm-msg-01"])
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-cm-msg-02"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmCMGlobalStatus)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-cm-msg-03"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmCMEnterStatus)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-cm-msg-04"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmCMExitStatus)
               
   waText      = ConvergeFu:ColourTextYellow(L["tools-bm-status-wa-msg-01"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmNotifyStatus)
             
   repText1    = ConvergeFu:ColourTextYellow(L["tools-bm-status-reporting-msg-01"])
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-02"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportFlasks)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-03"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportElixirs)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-04"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportFood)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-05"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportRoguePoisons)               
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-06"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportExpiry)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-07"])
               ..ConvergeFu:ColourTextGreen(ConvergeFu.db.profile.bmExpiryTimeMinutes)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-08"])
             
   repText2    = ConvergeFu:ColourTextYellow(L["tools-bm-status-reporting-msg-01"])
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-09"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportDead)
               ..ConvergeFu:ColourTextWhite(L["tools-bm-status-reporting-msg-10"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmReportOffline)
              
  outputText   = ConvergeFu:ColourTextYellow(L["tools-bm-status-output-msg-01"])
               ..ConvergeFu:ColourStatusOnOff(ConvergeFu.db.profile.bmOutputChannel)
             
   -- == ----------------------------------------------------------------------
   -- == -- Output the text that is required.                                --
   -- == ----------------------------------------------------------------------
   print(titleText)
   print(profileText)
   if showCombatStatus    then print(cmText) end
   if showWhisperStatus   then print(waText) end
   if showReportingStatus then print(repText1) print(repText2) end
   if showOutputStatus    then print(outputText) end

end

-- ============================================================================
-- == BuffsReminder                                                          ==
-- ==                                                                        ==
-- == This function simply reminds the player to check their buffs.          ==
-- ============================================================================

function ConvergeFu:BuffsReminder()

   UIErrorsFrame:AddMessage(L["tools-bm-buff-reminder-02"], 0, 1.0, 1.0, 1.0, 1)
   UIErrorsFrame:AddMessage(L["tools-bm-buff-reminder-01"], 0, 1.0, 1.0, 1.0, 1)
   
end

-- ============================================================================
-- == CheckMyBuffs(textMessage)                                              ==
-- ==                                                                        ==
-- == This function checks a player's own buffs and reminds them via their   ==
-- == own chat window.                                                       ==
-- ==                                                                        ==
-- == The parameter textMessage simply allows the calling code to supply a   ==
-- == text message to be displayed as checking begins.                       ==
-- ============================================================================

function ConvergeFu:CheckMyBuffs(textMessage)

   -- == ----------------------------------------------------------------------
   -- == -- Ensure textMessage has a value otherwise default it.             --
   -- == ----------------------------------------------------------------------
   if ConvergeFu:SafeText(textMessage) == "" then
      textMessage = L["tools-bm-checkmybuffs-msg-default"]
   end

   -- == ----------------------------------------------------------------------
   -- == -- Since the most common reason to perform a ready check is to see  --
   -- == -- if members are ready for a pull, let's run a quick buff-check on --
   -- == -- this player only and let them know if anything is missing. They  --
   -- == -- can then fix it before someone mentions it, no fuss, no muss!    --
   -- == ----------------------------------------------------------------------   
   local myName = UnitName("player")
   
   local bmReportFlasks       = ConvergeFu.db.profile.bmReportFlasks    
   local bmReportElixirs      = ConvergeFu.db.profile.bmReportElixirs   
   local bmReportFood         = ConvergeFu.db.profile.bmReportFood
   local bmReportRoguePoisons = ConvergeFu.db.profile.bmReportRoguePoisons
   
   local bmReportExpiry       = ConvergeFu.db.profile.bmReportExpiry
   local bmNotifyStatus       = ConvergeFu.db.profile.bmNotifyStatus
   
   ConvergeFu.db.profile.bmReportFlasks       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportElixirs      = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportFood         = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportRoguePoisons = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportExpiry       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmNotifyStatus       = L["common-data-option-on"]
   
   rcText1 = L["event-bm-msg-first"]..textMessage
   rcText1 = ConvergeFu:ColourTextForReportTitle(rcText1, "CHAT")
   
   rcText2 = L["tools-bm-ready-check-msg-01"]..myName
   rcText2 = ConvergeFu:ColourTextForReportContent(rcText2, "CHAT")
   
   rcText3 = ConvergeFu:ColourTextYellow(L["tools-bm-ready-check-msg-02"])
 
   issuesSomeText = ConvergeFu:ColourTextYellow(L["tools-bm-ready-check-msg-issues-some"])
   issuesNoneText = ConvergeFu:ColourTextYellow(L["tools-bm-ready-check-msg-issues-none"])
   
   ConvergeFu:SendChatMessage(rcText1, "CHAT")
   ConvergeFu:SendChatMessage(rcText2, "CHAT")
   
   ConvergeFu:CheckCharacterForMissingConsumables(myName, "CHAT")
   
   if ConvergeFu.db.profile.bmIssuesFound == L["common-data-option-yes"] then
      ConvergeFu:SendChatMessage(issuesSomeText, "CHAT")
   else
      ConvergeFu:SendChatMessage(issuesNoneText, "CHAT")
   end
   
   ConvergeFu:SendChatMessage(rcText3, "CHAT")
   
   ConvergeFu.db.profile.bmReportFlasks       = bmReportFlasks
   ConvergeFu.db.profile.bmReportElixirs      = bmReportElixirs
   ConvergeFu.db.profile.bmReportFood         = bmReportFood
   ConvergeFu.db.profile.bmReportRoguePoisons = bmReportRoguePoisons
   ConvergeFu.db.profile.bmReportExpiry       = bmReportExpiry
   ConvergeFu.db.profile.bmNotifyStatus       = bmNotifyStatus

end

-- ============================================================================
-- == PLAYER_REGEN_DISABLED()                                                ==
-- ==                                                                        ==
-- == This function is triggered when the player enters combat.              ==
-- ==                                                                        ==
-- == Important Note: Since the release of patch 3.2, certain fights in the  ==
-- == game fire the "PLAYER_REGEN_DISABLED" event continuously during        ==
-- == combat causing any subsequent events we might trigger as a result to   ==
-- == also fire continuously. It is recommended therefore to use a checking  == 
-- == variable that is set to 'on/1/etc' when entering combat and back to    ==
-- == 'off/0/etc' only when exiting combat and then use this as the final    ==
-- == determinant on whether or not to action a subsequent event.            ==
-- ============================================================================

function ConvergeFu:PLAYER_REGEN_DISABLED()

   -- == ----------------------------------------------------------------------
   -- == -- Buff Monitor: If enabled for reporting when entering combat.     --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu.db.profile.bmCMGlobalStatus == L["common-data-option-on"]
   and ConvergeFu.db.profile.bmCMEnterStatus  == L["common-data-option-on"] 
   and ConvergeFu.db.profile.bmCMDoneOnce     == L["common-data-option-no"] then
      
      combatEnteredText = L["event-bm-msg-first"]..L["event-bm-combat-entered"]
                        
      ConvergeFu:SendChatMessage(combatEnteredText, ConvergeFu.db.profile.bmOutputChannel)
      
      ConvergeFu:ListRaidersWithMissingConsumables(ConvergeFu.db.profile.bmOutputChannel)
      
      -- == -------------------------------------------------------------------
      -- == -- Set combat entry token to 'yes' to prevent unwanted repeat    --
      -- == -- occurances should the "combat entered" event fire repeatedly. --
      -- == -------------------------------------------------------------------
      ConvergeFu.db.profile.bmCMDoneOnce = L["common-data-option-yes"]
   
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Loot Monitor: Reset tool ready for the next major looting event. --
   -- == ----------------------------------------------------------------------
   ConvergeFu:SetLootMonitorMLNotSeen()
   
end

-- ============================================================================
-- == PLAYER_REGEN_ENABLED()                                                 ==
-- ==                                                                        ==
-- == This function is triggered when the player leaves combat.              ==
-- ============================================================================

function ConvergeFu:PLAYER_REGEN_ENABLED()

   -- == ----------------------------------------------------------------------
   -- == -- Buff Monitor: If enabled for reporting when exiting combat.      --
   -- == ----------------------------------------------------------------------
   if  ConvergeFu.db.profile.bmCMGlobalStatus == L["common-data-option-on"]
   and ConvergeFu.db.profile.bmCMExitStatus   == L["common-data-option-on"] then

      -- == -------------------------------------------------------------------
      -- == -- Since players can die in combat, we cannot determine if the   --
      -- == -- lack of certain buffs that expire upon death occurred because --
      -- == -- of death or via natural means. Thus, we do not need these     --
      -- == -- items included in the exiting combat report. Therefore, we    --
      -- == -- disable them temporarily.                                     --
      -- == --                                                               --
      -- == -- Disabled Checks: Elixirs, Food, Dead, Offline                 --
      -- == -------------------------------------------------------------------
      local reportElixirs       = ConvergeFu.db.profile.bmReportElixirs
      local reportFood          = ConvergeFu.db.profile.bmReportFood
      local reportRoguePoisons  = ConvergeFu.db.profile.bmReportRoguePoisons
      local reportDead          = ConvergeFu.db.profile.bmReportDead
      local reportOffline       = ConvergeFu.db.profile.bmReportOffline
   
      ConvergeFu.db.profile.bmReportElixirs      = L["common-data-option-off"]
      ConvergeFu.db.profile.bmReportFood         = L["common-data-option-off"]
      ConvergeFu.db.profile.bmReportRoguePoisons = L["common-data-option-off"]
      ConvergeFu.db.profile.bmReportDead         = L["common-data-option-off"]
      ConvergeFu.db.profile.bmReportOffline      = L["common-data-option-off"]
      
      combatExitedText = L["event-bm-msg-first"]..L["event-bm-combat-exited"]
                        
      ConvergeFu:SendChatMessage(combatExitedText, ConvergeFu.db.profile.bmOutputChannel)
      
      ConvergeFu:ListRaidersWithMissingConsumables(ConvergeFu.db.profile.bmOutputChannel)
      
      ConvergeFu.db.profile.bmReportElixirs       = reportElixirs
      ConvergeFu.db.profile.bmReportFood          = reportFood
      ConvergeFu.db.profile.bmReportRoguePoisons  = reportRoguePoisons
      ConvergeFu.db.profile.bmReportDead          = reportDead
      ConvergeFu.db.profile.bmReportOffline       = reportOffline
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Reset any 'combat entered' variables used to combat the bug      --
   -- == -- where the PLAYER_REGEN_DISABLED event fires continously in some  --
   -- == -- encounters instead of just once as combat is entered.            --
   -- == ----------------------------------------------------------------------   
   ConvergeFu:ResetCombatEntryTokens()
   
end

-- ============================================================================
-- == DoReadyCheck()                                                         ==
-- ==                                                                        ==
-- == This function sets an internal variable that monitors whether or not   ==
-- == a ready check is active from the current player and then issues the    ==
-- == ready check command to the chat console.                               ==
-- ============================================================================
function ConvergeFu:DoReadyCheck()

   ConvergeFu.db.profile.bmPostRCReportStatus = L["common-data-status-active"]
   ConvergeFu:ExecuteChatCommand("/raready")

end

-- ============================================================================
-- == READY_CHECK(sender)                                                    ==
-- ==                                                                        ==
-- == This function is triggered when a ready check is fired.                ==
-- ============================================================================
function ConvergeFu:READY_CHECK(sender)

   -- == ----------------------------------------------------------------------
   -- == -- Record whether this ready check was fired by current user or by  --
   -- == -- another player.                                                  --
   -- == ----------------------------------------------------------------------
   if UnitName("player") == sender then
      ConvergeFu.db.profile.bmLastReadyCheckByMe = L["common-data-option-yes"]
   else
      ConvergeFu.db.profile.bmLastReadyCheckByMe = L["common-data-option-no"]
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Sometimes the ready-check sound does not fire properly, so we'll --
   -- == -- fire it explicitly here to ensure there is at least one audio    --
   -- == -- cue. There may indeed be two now, overlapping slightly now for   --
   -- == -- some users.                                                      --
   -- == ----------------------------------------------------------------------
   PlaySoundFile("Sound\\interface\\ReadyCheck.wav")
   
   -- == ----------------------------------------------------------------------
   -- == -- Reset the combat entry tokens since it is incredibly rare to do  --
   -- == -- ready checks during combat.                                      --
   -- == ----------------------------------------------------------------------
   ConvergeFu:ResetCombatEntryTokens()
   
   -- == ----------------------------------------------------------------------
   -- == -- Since ready-checks are often fired just before a boss encounter  --
   -- == -- is attempted, it's worth checking buffs now.                     --
   -- == ----------------------------------------------------------------------   
   ConvergeFu:BuffsReminder()
   ConvergeFu:CheckMyBuffs(L["tools-bm-checkmybuffs-msg-readycheck"])
   
end

-- ============================================================================
-- == READY_CHECK_FINISHED()                                                 ==
-- ==                                                                        ==
-- == This function is triggered when a ready check completes.               ==
-- ============================================================================
function ConvergeFu:READY_CHECK_FINISHED()

   -- == ----------------------------------------------------------------------
   -- == -- Backup the existing BM options, then configure as needed.        --
   -- == ----------------------------------------------------------------------
   local bmReportFlasks       = ConvergeFu.db.profile.bmReportFlasks    
   local bmReportElixirs      = ConvergeFu.db.profile.bmReportElixirs   
   local bmReportFood         = ConvergeFu.db.profile.bmReportFood
   local bmReportRoguePoisons = ConvergeFu.db.profile.bmReportRoguePoisons
   local bmReportExpiry       = ConvergeFu.db.profile.bmReportExpiry
   local bmReportDead         = ConvergeFu.db.profile.bmReportDead
   local bmReportOffline      = ConvergeFu.db.profile.bmReportOffline
   local bmNotifyStatus       = ConvergeFu.db.profile.bmNotifyStatus
   local bmOutputChannel      = ConvergeFu.db.profile.bmOutputChannel
   local bmCurrentProfile     = ConvergeFu.db.profile.bmCurrentProfile
   
   ConvergeFu.db.profile.bmReportFlasks       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportElixirs      = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportFood         = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportRoguePoisons = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportExpiry       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportDead         = L["common-data-option-on"]
   ConvergeFu.db.profile.bmReportOffline      = L["common-data-option-on"]
   ConvergeFu.db.profile.bmNotifyStatus       = L["common-data-option-on"]
   ConvergeFu.db.profile.bmOutputChannel      = "RAID"
   ConvergeFu.db.profile.bmCurrentProfile     = L["tools-bm-current-profile-custom"] 
   
   -- == ----------------------------------------------------------------------
   -- == -- If the ready check that just finished was one issued by the      --
   -- == -- current user and the current user has the 'run post ready check  --
   -- == -- reports' option enabled, then run a post ready check report.     --
   -- == ----------------------------------------------------------------------
   if ConvergeFu.db.profile.bmLastReadyCheckByMe == L["common-data-option-yes"] then
      if ConvergeFu.db.profile.bmRunPostRCReport == L["common-data-option-on"] then
         if ConvergeFu.db.profile.bmPostRCReportStatus == L["common-data-status-active"] then
            ConvergeFu.db.profile.bmPostRCReportStatus = L["common-data-status-dormant"]
            if IsRaidLeader() then
               ConvergeFu:SendChatMessage(L["tools-bm-post-ready-check-msg-01"], ConvergeFu.db.profile.bmOutputChannel)
               ConvergeFu:ListRaidersWithMissingConsumables(ConvergeFu.db.profile.bmOutputChannel)
            end
         end
      end
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Now restore the previous BM option settings.                     --
   -- == ----------------------------------------------------------------------
   ConvergeFu.db.profile.bmReportFlasks       = bmReportFlasks
   ConvergeFu.db.profile.bmReportElixirs      = bmReportElixirs
   ConvergeFu.db.profile.bmReportFood         = bmReportFood
   ConvergeFu.db.profile.bmReportRoguePoisons = bmReportRoguePoisons
   ConvergeFu.db.profile.bmReportExpiry       = bmReportExpiry
   ConvergeFu.db.profile.bmReportDead         = bmReportDead
   ConvergeFu.db.profile.bmReportOffline      = bmReportOffline
   ConvergeFu.db.profile.bmNotifyStatus       = bmNotifyStatus
   ConvergeFu.db.profile.bmOutputChannel      = bmOutputChannel
   ConvergeFu.db.profile.bmCurrentProfile     = bmCurrentProfile 
   
end

-- ============================================================================
-- == ResetCombatEntryTokens()                                               ==
-- ==                                                                        ==
-- == This function simply resets any tokens used to record properties that  ==
-- == are related to the so-called combat-entry event PLAYER_REGEN_DISABLED. ==
-- == This event should normally fire just once as a player enters combat    ==
-- == but in some scenarios, it fires continously after combat is entered    ==
-- == and until combat is exited. Tokens are therefore commonly used to      ==
-- == record an action being performed once (or a limited number of times)   ==
-- == when that action hangs off of the combat entry event.                  ==
-- == Once combat is exited, these tokens can be reset ready for the next    ==
-- == time combat is entered and this function provides that functionality.  ==
-- ============================================================================

function ConvergeFu:ResetCombatEntryTokens()
   
   -- == ----------------------------------------------------------------------
   -- == -- Reset the Buff Monitor's Combat Monitor token.                   --
   -- == ----------------------------------------------------------------------
   ConvergeFu.db.profile.bmCMDoneOnce = L["common-data-option-no"]
   
   -- == ----------------------------------------------------------------------
   -- == -- Output a notification that tokens have been reset.               --
   -- == ----------------------------------------------------------------------
   tokensResetText = L["event-ready-check-msg-first"]..L["event-ready-check-msg-tokens-reset"]
   tokensResetText = ConvergeFu:ColourTextForReportTitle(tokensResetText, "CHAT")
   
   ConvergeFu:Debug(tokensResetText)
   
end

-- ============================================================================
-- == AnnounceBiddingInstructions(channelName)                               ==
-- ==                                                                        ==
-- == This function simply announces the standard bidding instructions.      ==
-- ============================================================================
function ConvergeFu:AnnounceBiddingInstructions(channelName)

   local masterLooterName = ConvergeFu:GetMasterLooterCharacterName()
   
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-01-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-02-msg"]..masterLooterName, channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-03-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-04-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-05-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-06-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-07-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-08-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-09-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-10-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-11-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-12-msg"], channelName)
   
end

-- ============================================================================
-- == AnnounceBiddingInstructions(channelName)                               ==
-- ==                                                                        ==
-- == This function simply announces the PUG-style bidding instructions.     ==
-- ============================================================================
function ConvergeFu:AnnouncePUGStyleBiddingInstructions(channelName)

   local masterLooterName = ConvergeFu:GetMasterLooterCharacterName()
   
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-01-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-02-msg"]..masterLooterName, channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-03-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-04-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-05-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-06-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-07-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-08-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-09-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-10-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-11-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-12-msg"], channelName)
   ConvergeFu:SendChatMessage(L["ann-raid-loot-bidding-13-msg"], channelName)
   
end

-- ============================================================================
-- == GetMasterLooterCharacterName()                                         ==
-- ==                                                                        ==
-- == This function attempts to locate the name of the current master looter ==
-- == and will return the name if it locates it, otherwise it returns the    ==
-- == standard '<unset>' value.                                              ==
-- ============================================================================

function ConvergeFu:GetMasterLooterCharacterName()

   ConvergeFu:Debug("ConvergeFu:GetMasterLooterCharacterName()")
   
   local numberOfRaidMembers = GetNumGroupMembers()
   local masterLooterName    = L["common-data-option-unset"]
   
   ConvergeFu:Debug("numberOfRaidMembers = "..numberOfRaidMembers)
   for index=1, numberOfRaidMembers, 1 do
      name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(index)
      
      ConvergeFu:Debug("- Checking: "..ConvergeFu:SafeText(name))
      
      if isML then
         ConvergeFu:Debug("- "..name.." is the Master Looter!")
         masterLooterName = name
         return masterLooterName 
      end
   end

   ConvergeFu:Debug("- No Master Looter found.")
   
   return masterLooterName   
end

-- ============================================================================
-- == MakeBidToMasterLooter(bidType, requestedAltStatus)                     ==
-- ==                                                                        ==
-- == This function attempts to send a bid of the specified bidType to the   ==
-- == current Master Looter. If no Master Looter can be found, the bid is    ==
-- == not sent.                                                              ==
-- ==                                                                        ==
-- == Bids should be sent in the following format:                           ==
-- ==                                                                        ==
-- == {Bid Type} - {Bidding Rank}                                            ==
-- ==                                                                        ==
-- == Example Bids:                                                          ==
-- ==                                                                        ==
-- == MAIN - Hero Member     MAIN - Normal Member     MAIN - Trial Member    ==
-- == MAIN - Alt-Hero        MAIN - Alt-Normal        MAIN - Alt-Trial       ==
-- ==                                                                        ==
-- == RESIST - Hero Member   RESIST - Normal Member   RESIST - Trial Member  ==
-- == RESIST - Alt-Hero      RESIST - Alt-Normal      RESIST - Alt-Trial     ==
-- ==                                                                        ==
-- == OFFSPEC - Hero Member  OFFSPEC - Normal Member  OFFSPEC - Trial Member ==
-- == OFFSPEC - Alt-Hero     OFFSPEC - Alt-Normal     OFFSPEC - Alt-Trial    ==
-- ==                                                                        ==
-- == Note: Requested alts will show 'Requested' in their rank.              ==
-- ==                                                                        ==
-- == Example: Requested-Alt-Hero                                            ==
-- ==          Requested-Alt-Normal                                          ==
-- ==          Requested-Alt-Trial.                                          ==
-- ==                                                                        ==
-- ============================================================================

function ConvergeFu:MakeBidToMasterLooter(bidType, requestedAltStatus)

   -- == ----------------------------------------------------------------------
   -- == -- Configure some standard text strings.                            --
   -- == ----------------------------------------------------------------------
   bidManagerInitialText = ConvergeFu:ColourTextPurple(L["tools-bidmgr-msg-first"])
                         ..ConvergeFu:ColourTextWhite(L["tools-bidmgr-msg-finding-ml"])
   
   bidManagerFinalText   = ConvergeFu:ColourTextPurple(L["tools-bidmgr-msg-first"])
                         ..ConvergeFu:ColourTextWhite(L["tools-bidmgr-msg-alldone"])
                         
   bidManagerReqAltText  = ""
   
   if requestedAltStatus then
      bidManagerReqAltText = L["tools-bidmgr-bid-type-requested"]
   end
   
   print(bidManagerInitialText)

   -- == ----------------------------------------------------------------------
   -- == -- Ensure a Master Looter can be found, exit if not.                --
   -- == ----------------------------------------------------------------------
   local masterLooterName = ConvergeFu:GetMasterLooterCharacterName()
   
   if masterLooterName == L["common-data-option-unset"] then
      print(ConvergeFu:ColourTextWhite(L["tools-bidmgr-master-looter-not-found"]))
      print(bidManagerFinalText)
      return
   else
      print(ConvergeFu:ColourTextYellow(L["tools-bidmgr-msg-found-ml"])..ConvergeFu:ColourTextGreen(masterLooterName))      
   end

   -- == ----------------------------------------------------------------------
   -- == -- Compose the bid.                                                 --
   -- == ----------------------------------------------------------------------   
   bidMessageText  = bidType.." - "..bidManagerReqAltText..ConvergeFu:GetCharacterRankForBidding(UnitName("player"))
   bidAnnounceText = ConvergeFu:ColourTextYellow(L["tools-bidmgr-msg-sending-ml"])
                   ..ConvergeFu:ColourTextGreen(bidMessageText)
             
   -- == ----------------------------------------------------------------------
   -- == -- Ensure the bid is valid before sending.                          --
   -- == ----------------------------------------------------------------------  
   if not ConvergeFu:IsThisARecognisedBid(bidMessageText) then
      print(L["tools-bidmgr-bid-format-invalid-01"]..ConvergeFu:ColourTextRed(bidMessageText).."|r"..L["tools-bidmgr-bid-format-invalid-02"])
      print(bidManagerFinalText)
      return
   end
    
   -- == ----------------------------------------------------------------------
   -- == -- Make the bid.                                                    --
   -- == ----------------------------------------------------------------------  
   print(bidAnnounceText) 
   
   if ConvergeFu.db.profile.bidmgrSendingChannel == "ADDON" then
      SendAddonMessage(L["event-addon-bid-manager-bid-transmit"], bidMessageText, "WHISPER", masterLooterName)
   else
      ConvergeFu:SendMessage(bidMessageText, "WHISPER", " ", masterLooterName)
   end
   
   print(bidManagerFinalText)
   
end

-- ============================================================================
-- == IsThisARecognisedBid(bidText)                                          ==
-- ==                                                                        ==
-- == This function will check the supplied bidText parameter to determine   ==
-- == whether or not it represents a valid bid. If so, the function returns  ==
-- == true, otherwise it returns false.                                      ==
-- ============================================================================

function ConvergeFu:IsThisARecognisedBid(bidText)

   ConvergeFu:Debug("ConvergeFu:IsThisARecognisedBid("..bidText..")")
   
   if bidText == L["tools-bidmgr-bid-type-main"].." - "..L["common-rankname-member-hero"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["common-rankname-member-normal"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["common-rankname-member-trial"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["common-rankname-alt-hero"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-hero"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["common-rankname-alt-normal"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-normal"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["common-rankname-alt-trial"]
   or bidText == L["tools-bidmgr-bid-type-main"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-trial"]
   
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["common-rankname-member-hero"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["common-rankname-member-normal"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["common-rankname-member-trial"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["common-rankname-alt-hero"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-hero"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["common-rankname-alt-normal"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-normal"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["common-rankname-alt-trial"]
   or bidText == L["tools-bidmgr-bid-type-resist"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-trial"]   

   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["common-rankname-member-hero"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["common-rankname-member-normal"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["common-rankname-member-trial"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["common-rankname-alt-hero"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-hero"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["common-rankname-alt-normal"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-normal"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["common-rankname-alt-trial"]
   or bidText == L["tools-bidmgr-bid-type-offspec"].." - "..L["tools-bidmgr-bid-type-requested"]..L["common-rankname-alt-trial"]   
   then
      ConvergeFu:Debug(" - Returning true.")
      return true
   else
      ConvergeFu:Debug(" - Returning false.")
      return false
   end
end

-- ============================================================================
-- == InitialiseBidManagerRBPT()                                             ==
-- ==                                                                        ==
-- == This function simply initialises the bidManagerRBPT array.             ==
-- ============================================================================
function ConvergeFu:InitialiseBidManagerRBPT()

   bidManagerBeginText = L["tools-bidmgr-msg-first"]..L["tools-bidmgr-msg-initialising"]
   bidManagerEndText   = L["tools-bidmgr-msg-first"]..L["tools-bidmgr-msg-alldone"]
   
   print(ConvergeFu:ColourTextForReportTitle(bidManagerBeginText, "CHAT"))
   
   bidManagerRBPT    = {}
   
   bidManagerRBPT = {
      ["mainHero"]                  = L["common-data-option-unset"],
      ["mainRequestedAltHero"]      = L["common-data-option-unset"],
      ["mainNormal"]                = L["common-data-option-unset"],
      ["mainRequestedAltNormal"]    = L["common-data-option-unset"],
      ["mainTrial"]                 = L["common-data-option-unset"],
      ["mainRequestedAltTrial"]     = L["common-data-option-unset"],
      ["mainAltHero"]               = L["common-data-option-unset"],
      ["mainAltNormal"]             = L["common-data-option-unset"],
      ["mainAltTrial"]              = L["common-data-option-unset"],
    
      ["resistHero"]                = L["common-data-option-unset"],
      ["resistRequestedAltHero"]    = L["common-data-option-unset"],
      ["resistNormal"]              = L["common-data-option-unset"],
      ["resistRequestedAltNormal"]  = L["common-data-option-unset"],
      ["resistTrial"]               = L["common-data-option-unset"],
      ["resistRequestedAltTrial"]   = L["common-data-option-unset"],
      ["resistAltHero"]             = L["common-data-option-unset"],
      ["resistAltNormal"]           = L["common-data-option-unset"],
      ["resistAltTrial"]            = L["common-data-option-unset"],
    
      ["offspecHero"]               = L["common-data-option-unset"],
      ["offspecRequestedAltHero"]   = L["common-data-option-unset"],
      ["offspecNormal"]             = L["common-data-option-unset"],
      ["offspecRequestedAltNormal"] = L["common-data-option-unset"],
      ["offspecTrial"]              = L["common-data-option-unset"],
      ["offspecRequestedAltTrial"]  = L["common-data-option-unset"],
      ["offspecAltHero"]            = L["common-data-option-unset"],
      ["offspecAltNormal"]          = L["common-data-option-unset"],
      ["offspecAltTrial"]           = L["common-data-option-unset"]
   }
   
   print(ConvergeFu:ColourTextForReportTitle(bidManagerEndText, "CHAT"))   

end

-- ============================================================================
-- == DoProcessRecognisedLootBid(msg, sender)                                ==
-- ==                                                                        ==
-- == This function will process the recognised loot bid, storing it         ==
-- == according to its classification.                                       ==
-- ============================================================================

function ConvergeFu:DoProcessRecognisedLootBid(msg, sender)
   
   if UnitName("player") ~= ConvergeFu:GetMasterLooterCharacterName() then
      return
   end
   
   local Args = self:GetArgs(msg, " ")
   bidType = Args[1]
   bidRank = Args[3]
   
   bidRank2 = string.gsub(bidRank, "", "")
   bidRank3 = string.gsub(bidRank2, "-", "")
   bidRank4 = string.gsub(bidRank3, "Member", "")
   
   keyName = string.lower(bidType)..bidRank4
   ConvergeFu:Debug("Keyname = "..keyName)
   if bidManagerRBPT[keyName] == L["common-data-option-unset"] then
      bidManagerRBPT[keyName] = sender
   else
      bidManagerRBPT[keyName] = bidManagerRBPT[keyName]..", "..sender
   end
   
   ConvergeFu:SendAcknowledgementOfBidReceived(msg, sender)
   
   if ConvergeFu:IsDebugEnabled() then
      ConvergeFu:Debug("ConvergeFu:DoProcessRecognisedLootBid("..msg..", "..sender..")")
      ConvergeFu:Debug("- keyName = "..keyName)
      ConvergeFu:Debug("- rbpt = "..bidManagerRBPT[keyName])
   end
   
end

-- ============================================================================
-- == DoProcessManualLootBid(msg, sender)                                    ==
-- ==                                                                        ==
-- == This function will process the manual loot bid, either converting it   ==
-- == to a recognised loot bid or rejecting it.                              ==
-- ==                                                                        ==
-- == Bid Format: bid main requested                                         ==
-- ============================================================================

function ConvergeFu:DoProcessManualLootBid(msg, sender)

   if UnitName("player") ~= ConvergeFu:GetMasterLooterCharacterName() then
      return
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Break msg into component parts, we already know that the first   --
   -- == -- component should be 'bid'. The second part should be the bidtype --
   -- == -- and the third part should be the requested status if it exists.  --
   -- == ----------------------------------------------------------------------
   local Args    = self:GetArgs(msg, " ")
   bidType       = Args[2]
   requestedRank = Args[3]
   
   local rejectBidType     = true
   local rejectBidRank     = true
   local rejectBidModifier = true
   
   -- == ----------------------------------------------------------------------
   -- == -- Check the validity of the bidType. Return if bidType is invalid. --
   -- == ----------------------------------------------------------------------
   if bidType then
      if string.lower(bidType) == string.lower(L["tools-bidmgr-bid-type-main"]) 
      or string.lower(bidType) == string.lower(L["tools-bidmgr-bid-type-resist"])
      or string.lower(bidType) == string.lower(L["tools-bidmgr-bid-type-offspec"]) then
         rejectBidType = false
         bidType       = string.upper(bidType)
      end
   else
      ConvergeFu:SendAcknowledgementOfBidReceived(L["tools-bidmgr-bid-format-incorrect"], sender)
      return
   end

   -- == ----------------------------------------------------------------------
   -- == -- Determine the sender's correct rank for bidding.                 --
   -- == ----------------------------------------------------------------------
   bidRank = ConvergeFu:GetCharacterRankForBidding(sender)
   
   -- == ----------------------------------------------------------------------
   -- == -- Determine if the bidder has claimed to have 'requested' status.  --
   -- == -- If the bid-message had more than two words and the third word    --
   -- == -- was not 'requested' then reject the bid.                         --
   -- == ----------------------------------------------------------------------   
   if ConvergeFu:IsAltRankedCharacter(sender) then
      if requestedRank then
        if string.lower(requestedRank.."-") == string.lower(L["tools-bidmgr-bid-type-requested"]) then
           requestedRank = L["tools-bidmgr-bid-type-requested"]
        else
           ConvergeFu:SendAcknowledgementOfBidReceived(L["tools-bidmgr-bid-format-incorrect"], sender)
           return
        end
      else
         requestedRank = ""  
      end
   else
      requestedRank = ""
   end
   
   -- == ----------------------------------------------------------------------
   -- == -- Main members should only bid with two words, no more. Reject any --
   -- == -- bids from main members with more than two words in the bid.      --
   -- == ----------------------------------------------------------------------
   if ConvergeFu:IsMainRankedCharacter(sender) then
      if requestedRank then
         ConvergeFu:SendAcknowledgementOfBidReceived(L["tools-bidmgr-bid-format-incorrect"], sender)
         return
      end
   end   
   
   -- == ----------------------------------------------------------------------
   -- == -- Compose a proper bid.                                            --
   -- == ----------------------------------------------------------------------   
   local properBid = bidType.." - "..requestedRank..bidRank
   
   if ConvergeFu:IsDebugEnabled() then
      ConvergeFu:Debug("ConvergeFu:DoProcessManualLootBid("..msg..", "..sender..")")
      ConvergeFu:Debug("- properBid = "..properBid)
   end

   -- == ----------------------------------------------------------------------
   -- == -- Send the proper bid for processing.                              --
   -- == ----------------------------------------------------------------------      
   ConvergeFu:DoProcessRecognisedLootBid(properBid, sender)
   
end

-- ============================================================================
-- == SendAcknowledgementOfBidReceived(msg, sender)                          ==
-- ==                                                                        ==
-- == This function will send an acknowledgement of a bid received to the    ==
-- == sender of the received bid.                                            ==
-- ============================================================================

function ConvergeFu:SendAcknowledgementOfBidReceived(msg, sender) 

   acknowledgementText = sender.."@@@"..L["tools-bidmgr-sending-acknowledgement"]..msg
   
   SendAddonMessage(L["event-addon-bid-manager-ack-bid"], acknowledgementText, "RAID", sender)
   
end

-- ============================================================================
-- == DoProcessBidAcknowledgement(msg, sender, channel)                      ==
-- ==                                                                        ==
-- == This function will process the acknowledgement of a bid.               ==
-- ============================================================================

function ConvergeFu:DoProcessBidAcknowledgement(msg, sender, channel)

   -- == ----------------------------------------------------------------------
   -- == -- Return if this user sent the acknowledgement message.            --
   -- == -- This check may be removed at a later date to allow the MLs bids  --
   -- == -- to be properly acknowledged.                                     --
   -- == ----------------------------------------------------------------------
   if UnitName("player") == sender then
      return
   end

   -- == ----------------------------------------------------------------------
   -- == -- Split msg into component parts.                                  --
   -- == ----------------------------------------------------------------------
   local Args        = self:GetArgs(msg, "@@@")
   local recipient   = ConvergeFu:SafeText(Args[1])
   local messageText = ConvergeFu:SafeText(Args[2])
   
   -- == ----------------------------------------------------------------------
   -- == -- Return if this user is not the intended message recipient       .--
   -- == ----------------------------------------------------------------------
   if UnitName("player") ~= recipient then
      return
   end
   
   ackInitialText = ConvergeFu:ColourTextForReportTitle(L["tools-bidmgr-msg-first"]..L["tools-bidmgr-msg-ack-received"], "CHAT")
   ackContentText = ConvergeFu:ColourTextForReportContent(messageText.." ["..sender.."]", "CHAT")
   ackFinalText   = ConvergeFu:ColourTextForReportTitle(L["tools-bidmgr-msg-first"]..L["tools-bidmgr-msg-alldone"], "CHAT")
   
   print(ackInitialText)
   print(ackContentText)
   print(ackFinalText)
   
end

-- ============================================================================
-- == ListWinningBidders(channelName)                                        ==
-- ==                                                                        ==
-- == This function simply attempts to list the winning bidders based on the ==
-- == information stored in the internal 'bidManagerRBPT' data.              ==
-- ==                                                                        ==
-- == The code in this function looks a bit messy but is purposely compacted ==
-- == to keep the 27 'if' clauses as compressed as possible. For each of the ==
-- == rank-based priorities, we simply check if the value is "<unset>" and   ==
-- == if it's not, we print the characters in that category to the output    ==
-- == channel.                                                               ==
-- ============================================================================

function ConvergeFu:ListWinningBidders(channelName)
   
   -- == ----------------------------------------------------------------------
   -- == -- Check that the player is the master-looter. Only the ML receives --
   -- == -- the bids therefore only the ML can output the results.           --
   -- == ----------------------------------------------------------------------
   masterLooterName = ConvergeFu:SafeText(ConvergeFu:GetMasterLooterCharacterName())
   
   if UnitName("player") ~= masterLooterName then
      print(ConvergeFu:ColourTextForReportTitle(L["tools-bidmgr-msg-first"]..L["tools-bidmgr-notml-too-cool-to-list"], channelName))
      return
   end
   
   bidManagerBeginText = ConvergeFu:ColourTextForReportTitle(L["tools-bidmgr-msg-first"]..L["tools-bidmgr-msg-listing"], channelName)
   bidManagerEndText   = ConvergeFu:ColourTextForReportTitle(L["tools-bidmgr-msg-first"]..L["tools-bidmgr-msg-alldone"], channelName)
   
   local categoryText         = L["tools-bidmgr-sorting-top-ranked"]
   
   ConvergeFu:SendChatMessage(bidManagerBeginText, channelName)
      
   if bidManagerRBPT["mainHero"] ~= L["common-data-option-unset"] then
      ConvergeFu:SendChatMessage(categoryText.."(mainHero) - "..bidManagerRBPT["mainHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainRequestedAltHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainRequestedAltHero) - "..bidManagerRBPT["mainRequestedAltHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainNormal) - "..bidManagerRBPT["mainNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainRequestedAltNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainRequestedAltNormal) - "..bidManagerRBPT["mainRequestedAltNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]             
   end
   if bidManagerRBPT["mainTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainTrial) - "..bidManagerRBPT["mainTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainRequestedAltTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainRequestedAltTrial) - "..bidManagerRBPT["mainRequestedAltTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainAltHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainAltHero) - "..bidManagerRBPT["mainAltHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainAltNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainAltNormal) - "..bidManagerRBPT["mainAltNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["mainAltTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(mainAltTrial) - "..bidManagerRBPT["mainAltTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
             
   end
   if bidManagerRBPT["resistHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistHero) - "..bidManagerRBPT["resistHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistRequestedAltHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistRequestedAltHero) - "..bidManagerRBPT["resistRequestedAltHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistNormal) - "..bidManagerRBPT["resistNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistRequestedAltNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistRequestedAltNormal) - "..bidManagerRBPT["resistRequestedAltNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistTrial) - "..bidManagerRBPT["resistTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistRequestedAltTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistRequestedAltTrial) - "..bidManagerRBPT["resistRequestedAltTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistAltHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistAltHero) - "..bidManagerRBPT["resistAltHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistAltNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistAltNormal) - "..bidManagerRBPT["resistAltNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["resistAltTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(resistAltTrial) - "..bidManagerRBPT["resistAltTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
             
   end
   if bidManagerRBPT["offspecHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecHero) - "..bidManagerRBPT["offspecHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecRequestedAltHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecRequestedAltHero) - "..bidManagerRBPT["offspecRequestedAltHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecNormal) - "..bidManagerRBPT["offspecNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecRequestedAltNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecRequestedAltNormal) - "..bidManagerRBPT["offspecRequestedAltNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecTrial) - "..bidManagerRBPT["offspecTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecRequestedAltTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecRequestedAltTrial) - "..bidManagerRBPT["offspecRequestedAltTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecAltHero"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecAltHero) - "..bidManagerRBPT["offspecAltHero"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecAltNormal"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecAltNormal) - "..bidManagerRBPT["offspecAltNormal"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end
   if bidManagerRBPT["offspecAltTrial"] ~= L["common-data-option-unset"] then  
      ConvergeFu:SendChatMessage(categoryText.."(offspecAltTrial) - "..bidManagerRBPT["offspecAltTrial"], channelName)
      categoryText = L["tools-bidmgr-sorting-next-in-line"]
   end

   ConvergeFu:SendChatMessage(bidManagerEndText, channelName)

end

-- ============================================================================
-- == MyTargetOrMeOtherwise()                                                ==
-- ==                                                                        ==
-- == This function attempts to return the name of your current target where ==
-- == you have a target selected, otherwise it returns your own character's  ==
-- == name.                                                                  ==
-- ============================================================================

function ConvergeFu:MyTargetOrMeOtherwise()

   myTargetOrMe = UnitName("target")
   
   if myTargetOrMe == nil then
      myTargetOrMe = UnitName("player")
   end
   
   return myTargetOrMe
   
end

-- ============================================================================
-- == SetGuildMessageOfTheDay(messageText)                                   ==
-- ==                                                                        ==
-- == This function will set the Guild Message of the Day if the player is   ==
-- == an officer of the guild. If the player is not an officer of the guild, ==
-- == the message will be directed to the chat window instead since only     ==
-- == officers of Converge are able to change the Guild Message of the Day.  ==
-- ============================================================================

function ConvergeFu:SetGuildMessageOfTheDay(messageText)

   officerText1    = L["ann-gmotd-setting-msg-first"]..L["ann-gmotd-officer-msg-01"]
   officerText1    = ConvergeFu:ColourTextForReportTitle(officerText1, "CHAT")
   officerText2    = L["ann-gmotd-officer-msg-02"]..messageText
   officerText2    = ConvergeFu:ColourTextForReportContent(officerText2, "CHAT")

   nonOfficerText1 = L["ann-gmotd-setting-msg-first"]..L["ann-gmotd-not-officer-msg-01"]
   nonOfficerText1 = ConvergeFu:ColourTextForReportTitle(nonOfficerText1, "CHAT")
   nonOfficerText2 = L["ann-gmotd-not-officer-msg-02"]..messageText
   nonOfficerText2 = ConvergeFu:ColourTextForReportContent(nonOfficerText2, "CHAT")
   
   if ConvergeFu:IsOfficerRankedCharacter(UnitName("player")) then
      print(officerText1)
      print(officerText2)
      GuildSetMOTD(messageText)
   else
      print(nonOfficerText1)
      print(nonOfficerText2)
   end

end

-- ============================================================================
-- == Debug(messageText)                                                     ==
-- ==                                                                        ==
-- == This function will output the text passed if the debug flag is turned  ==
-- == on.                                                                    ==
-- ============================================================================

function ConvergeFu:Debug(messageText)

   if ConvergeFu.db.profile.debugStatus == L["common-data-option-on"] then
      print(ConvergeFu:ColourTextRed("Debug: |r"..messageText))
   end

end

-- ============================================================================
-- == IsDebugEnabled()                                                       ==
-- ==                                                                        ==
-- == This function returns true if the debug flag is turned on or false     ==
-- == otherwise.                                                             ==
-- ============================================================================

function ConvergeFu:IsDebugEnabled()

   if ConvergeFu.db.profile.debugStatus == L["common-data-option-on"] then
      return true
   else
      return false
   end

end

-- ============================================================================
-- == ShowAPI(channelName)                                                   ==
-- ==                                                                        ==
-- == This function simply lists all the functions of ConvergeFu in order to ==
-- == help the user remind themselves of the functionality that is available ==
-- == through this addon.                                                    ==
-- ============================================================================

function ConvergeFu:ShowAPI(channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:OnEnable()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:Update()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RAID_INSTANCE_WELCOME(instanceName, ttl)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ZONE_CHANGED()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CHAT_MSG_WHISPER(msg, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendWhisperCommandHelp(recipient)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendWhisperGuildInfo(recipient)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetArgs(message, separator)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoBusyResponder(sender, msg)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ToggleBusyResponder()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:BusyResponderShowStatus()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:BusyResponderStatusUpdated()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:BusyResponderExclusionsUpdated()", channelName) 
  ConvergeFu:SendChatMessage("ConvergeFu:BusyResponderMessageUpdated()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:FishFeastAnnouncementsUpdated()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CHAT_MSG_ADDON(prefix, msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendRCPMessage(messageText, channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessRCPMessage(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandReporting(rcpCommand, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandEnableFFA(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandDisableFFA(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandResetFFAMessage(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandEnableBuffMonitorCM(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandDisableBuffMonitorCM(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandEnableRIAShowing(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandDisableRIAShowing(sender)", channelName) 
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandEnableRIAShowing(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandDisableRIAShowing(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandEnableRIASending(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandDisableRIASending(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandEnableRQAShowing(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandDisableRQAShowing(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandMovieMakerSay(rcpCommand, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RCPCommandMovieMakerDo(rcpCommand, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessRaidInvitationAnnouncement(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessRaidEndNotification(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessVersionCheckQuery(msg, channelName, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessVersionCheckResponse(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoVersionCheck(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoUpToDateCheck(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:PrepareVersionCheckGroupList()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:UpdateVersionCheckGroupList(characterName, versionNumber)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListVersionCheckGroupListUnset(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:OnTextUpdate()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:OnTooltipUpdate()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:OnClick()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ExecuteChatCommand(arg)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetGuildName()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetGuildRankName()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetNumberOfGuildOfficers()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetGuildOfficerNamesForTooltip(cat)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:FindPlayerByCharacterName(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSimpleCharacterName(complexCharacterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListAssociatedCharacters(characterName,channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListAllOfficers(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListAllHeroes(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListAllNormals(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListAllTrials(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListAllBenched(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetCharacterRank(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetCharacterRankForBidding(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetCorrespondingAltRank(rankName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsMainRankedCharacter(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsAltRankedCharacter(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsOfficerRankedCharacter(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsHeroRankedCharacter(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsNormalRankedCharacter(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsTrialRankedCharacter(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterInGuild(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterInParty(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterInRaid(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterAFriend(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendChatMessage(messageText, channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SafeChatChannelName(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendMessage(messageText, channelName, token, recipient)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ShowAvoidanceForLevel70Rogues()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnounceRankChanges(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnounceRaidInvite(officerName,channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnounceWaitList(officerName,channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnounceRaidEnd(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:BroadcastRaidEnd()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnounceCrowdControlTargets(channelName, recipient)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetCharacterClass(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetCCTypeByClass(classType)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CCTakeMyTarget()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AutoSetCCTypes()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ClearAllCCSettings()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoBroadcastCCTargets(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CleanseCCTargets()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SafeCCName(unsafeCCName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SafeCCType(unsafeCCType)", channelName) 
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessCCUpdateMessage(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSpecialMenu()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextRed(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextGreen(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextBlue(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextWhite(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextYellow(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextPurple(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextBlizzard(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextStory(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextByCharacterClass(text, characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourStatusOnOff(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourStatusOneZero(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextForReportTitle(text, channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ColourTextForReportContent(text, channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SafeText(text)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SafeNumber(number)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CaseCorrectedNameString(nameString)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitCharacter()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitCharacterCancel()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitReportStatus()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitNameFetch()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitRankFetch()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitMainFetch()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitConfirmContinue()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoRecruitCharacter()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoRecruitGuildAnnouncement()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitConfirmPostJoin()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoRecruitPostJoinActions(task)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitRankChange()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RecruitAllDone()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SetCharacterPublicNote(characterName, messageText)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SetCharacterOfficerNote(characterName, messageText)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CalculateItemLevelDKP()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CHAT_MSG_SYSTEM(msg)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CHAT_MSG_EMOTE(msg)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CHAT_MSG_MONSTER_EMOTE(msg)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:RaidInstanceWelcomeStatusUpdated()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:LOOT_OPENED()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:LootMonitorStatusUpdated()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ToggleLootMonitor()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoNotifyLootMonitorTriggered(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoWarnLootMonitorStopLooting(msg, channel, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SetLootMonitorMLSeen()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SetLootMonitorMLNotSeen()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:LootMonitorTest()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckGuildAdminStatus()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckTrialCharacterOfficerNotes()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsTrialMemberOfficerNoteValid(officernote)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckAltCharacterPublicNotes()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckMainCharacterOfficerNotes()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckAltCharacterRanks()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckCurrentGuildActivityStatus()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ConfirmJoinWaitlist()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CreateVersionCheckFrame(sender, versionText)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListRaidersWithMissingConsumables(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendBMNotificationByWhisper(characterName, message)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendBMNotificationByAddon(characterName, message)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterBuffedWithSuitableFlask(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterBuffedWithSuitableBattleElixir(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterBuffedWithSuitableGuardianElixir(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterBuffedWithSuitableFood(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsCharacterBuffedWithSuitableRoguePoisons(characterName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:FindInTooltips(textToFind)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSuitableFlasksArray()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSuitableBattleElixirsArray()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSuitableGuardianElixirsArray()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSuitableFoodArray()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSuitableRoguePoisonsArray()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetSpellNameFromSpellInfo(spellId)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckBuffExpiryTimes(characterName, channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:JoinTables(table1, table2)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ConfigureBuffMonitorBossMode()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ConfigureBuffMonitorTrashMode()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ToggleBuffMonitorProfile()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ShowBuffMonitorStatus(showCombatStatus, showWhisperStatus, showReportingStatus, showOutputStatus)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:BuffsReminder()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:CheckMyBuffs(textMessage)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:PLAYER_REGEN_DISABLED()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:PLAYER_REGEN_ENABLED()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoReadyCheck()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:READY_CHECK(sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ResetCombatEntryTokens()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnounceBiddingInstructions(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:AnnouncePUGStyleBiddingInstructions(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:GetMasterLooterCharacterName()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:MakeBidToMasterLooter(bidType, requestedAltStatus)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsThisARecognisedBid(bidText)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:InitialiseBidManagerRBPT()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessRecognisedLootBid(msg, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessManualLootBid(msg, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SendAcknowledgementOfBidReceived(msg, sender)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:DoProcessBidAcknowledgement(msg, sender, channel)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ListWinningBidders(channelName)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:MyTargetOrMeOtherwise()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:SetGuildMessageOfTheDay(messageText)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:Debug(messageText)", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:IsDebugEnabled()", channelName)
  ConvergeFu:SendChatMessage("ConvergeFu:ShowAPI(channelName)", channelName)
end
